file_name_standard_operations macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push string length		;ebp+12
;push offset file_name		;ebp+8
;call SC_Get_File_Name

SC_Get_File_Name proc
push ebp
mov ebp,esp

;mov eax,(-1)
;cmp get_file_name_busy_flag,1
;je no_get_file_name
;mov get_file_name_busy_flag,1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  IF busy flag is not equal to (-1) than set Busy flag to (-1)  ; Else leaves busy flag intact
mov eax,(-1)
cmpxchg get_file_name_busy_flag,eax
jz no_get_file_name		;Jump if ZF is 1 [ IF operands are not equal ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find specified filename end
.DATA
get_file_name_busy_flag			dd 0
length_of_all_string			dd 0
file_name_start_address			dd 0
only_file_name_length			dd 0
get_file_name_address_increment		dd 0
extension_type				dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov file_name_extension_address_increment,0
mov extension_start_address,0
mov extension_length,0
mov length_of_all_string,0
mov file_name_start_address,0
mov only_file_name_length,0
mov get_file_name_address_increment,0
mov extension_type,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

xor ecx,ecx
mov eax,dword ptr [ebp]+8	;offset file_name
mov ebx,dword ptr [ebp]+12	;string length

push ebx		;string_length	;ebp+20
push ecx		;find_byte		;ebp+16
push eax		;scan_string	;ebp+12
call Find_Byte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xchg eax,ebx
mov eax,1			;specified filename too long, cannot find filename end [Error code]
cmp eax,0
je end_get_file_name
mov length_of_all_string,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find specified filename end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find filename start
xor ecx,ecx
mov ebx,length_of_all_string
mov cl,'\'				;Filename seperator
mov eax,dword ptr [ebp]+8		;offset file_name
add eax,length_of_all_string

push ebx		;string_length	;ebp+20
push ecx		;find_byte		;ebp+16
push eax		;scan_string	;ebp+12
call Find_Byte_Back 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found	
	;;;[ecx] = length of string	
	;;;[esi] address of found byte ;[esi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,1
je no_all_file_name_specified		;Jump if specified all file name

mov esi,dword ptr [ebp]+8		;offset file_name
mov file_name_start_address,esi

jmp end_find_file_name_start
no_all_file_name_specified:

inc esi
mov file_name_start_address,esi

end_find_file_name_start:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find filename start
mov eax,2				;filename not specified [Error code]
mov ebx,dword ptr [ebp]+8		;offset file_name
add ebx,length_of_all_string
cmp file_name_start_address,ebx
jae end_get_file_name

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Escape seperators
mov eax,dword ptr [ebp]+8		;offset file_name
mov ebx,file_name_start_address
sub ebx,eax
mov get_file_name_address_increment,ebx

mov eax,dword ptr [ebp]+8		;offset file_name
add eax,get_file_name_address_increment

mov ebx,length_of_all_string
sub ebx,get_file_name_address_increment

push ebx			;string_length		;ebp+28
push eax			;offset string		;ebp+24
call Escape_Separators 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
xchg eax,esi
mov eax,3				;Filename not specified. String end reached [Error code]
cmp esi,1
jne end_get_file_name
xchg eax,esi

add get_file_name_address_increment,ebx

mov eax,4				;Filename not specified [Error code]
mov ebx,length_of_all_string
cmp get_file_name_address_increment,ebx
jae end_get_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Escape seperators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get filename length
mov eax,dword ptr [ebp]+8		;offset file_name
add eax,get_file_name_address_increment

mov ebx,length_of_all_string
sub ebx,get_file_name_address_increment

push ebx			;scan_string_length	;ebp+20
push eax			;scan_string		;ebp+16
call Get_Word 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Word found  
;[EAX] - 0 Word found, but string end reached
	;[ESI] - Word start address
	;[ECX] - Word length

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,5			;FileName not specified. [Error code]
cmp ecx,0
je end_get_file_name

mov only_file_name_length,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get filename length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine filename extension
mov extension_type,0			;Filename without extension

xor ecx,ecx
mov cl,'.'

push only_file_name_length		;string_length	;ebp+20
push ecx				;find_byte		;ebp+16
push file_name_start_address		;scan_string	;ebp+12
call Find_Byte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je end_get_file_name				;Not error case
mov extension_start_address,esi

mov file_name_extension_address_increment,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine filename extension
.DATA
file_name_extension_address_increment	dd 0
extension_start_address			dd 0
extension_length			dd 0
.CODE

mov extension_length,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine extension length
mov ebx,only_file_name_length
sub ebx,file_name_extension_address_increment

push ebx				;scan_string_length	;ebp+20
push extension_start_address		;scan_string		;ebp+16
call Get_Word
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Word found  
;[EAX] - 0 Word found, but string end reached
	;[ESI] - Word start address
	;[ECX] - Word length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,6			;Extension point specified but extension is not. [Error code]
cmp ecx,1
je end_get_file_name		;Jump if found only point

mov eax,7			;Extension too long [Error code]
cmp ecx,400
jae end_get_file_name		;Jump if found only point

mov extension_length,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine extension length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer extension
mov ecx,extension_length
mov esi,extension_start_address
mov edi,offset internal_extension_change
cld
rep movsb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer extension
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert extension into lowercase
start_convert_extension_for_type_determining:
push extension_length				;ebp+12
push offset internal_extension_change			;ebp+8
call SC_Convert_Into_Lowercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy 
;[eax] -  0  - Function normal processed
	;[ebx] - count of converted bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_convert_extension_for_type_determining
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert extension into lowercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine extension type
.DATA
internal_extension_change	db 400 dup (0)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Supported extension types
asm_extension		db '.asm'		;Extension code - 1 
inc_extension		db '.inc'		;Extension code - 2
def_extension		db '.def'		;Extension code - 3
rc_extension		db '.rc '		;Extension code - 4
map_extension		db '.map'		;Extension code - 5
txt_extension		db '.txt'		;Extension code - 6
bat_extension		db '.bat'		;Extension code - 7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Supported extension types
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 1
push extension_length			;ebp+24
push offset asm_extension		;Second_string		;ebp+20
push offset internal_extension_change	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_1_determining

mov extension_type,1
jmp end_of_extension_determining
end_of_extension_1_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 2
push extension_length			;ebp+24
push offset inc_extension		;Second_string		;ebp+20
push offset internal_extension_change	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_2_determining

mov extension_type,2
jmp end_of_extension_determining
end_of_extension_2_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 3
push extension_length			;ebp+24
push offset def_extension		;Second_string		;ebp+20
push offset internal_extension_change	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_3_determining

mov extension_type,3
jmp end_of_extension_determining
end_of_extension_3_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 4
push extension_length			;ebp+24
push offset rc_extension		;Second_string		;ebp+20
push offset internal_extension_change	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_4_determining

mov extension_type,4
jmp end_of_extension_determining
end_of_extension_4_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 5
push extension_length			;ebp+24
push offset map_extension		;Second_string		;ebp+20
push offset internal_extension_change	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_5_determining

mov extension_type,5
jmp end_of_extension_determining
end_of_extension_5_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 6
push extension_length			;ebp+24
push offset txt_extension		;Second_string		;ebp+20
push offset internal_extension_change	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_6_determining

mov extension_type,6
jmp end_of_extension_determining
end_of_extension_6_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 7
push extension_length			;ebp+24
push offset bat_extension		;Second_string		;ebp+20
push offset internal_extension_change	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_7_determining

mov extension_type,7
jmp end_of_extension_determining
end_of_extension_7_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 7
mov extension_type,10
end_of_extension_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine extension type

xor eax,eax
end_get_file_name:


mov get_file_name_busy_flag,0
no_get_file_name:


mov esi,file_name_start_address
mov ecx,only_file_name_length
mov edi,extension_start_address
mov edx,extension_length

mov ebx,extension_type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Return values
;[eax] - (-1) - function busy
;[eax] - 0 - Function processed successfully
;[eax] - 1 - Specified filename too long, cannot find filename end
;[eax] - 2 - Filename not specified
;[eax] - 3 - Filename not specified. String end reached [Error code]
;[eax] - 4 - Filename not specified  [Error code]
;[eax] - 5 - FileName not specified. [Error code]
;[eax] - 6 - Extension point specified but extension is not
;[eax] - 7 - Extension too long [Error code]
	;[esi] - only filename address
	;[ecx] - only filename length
	;[edi] - extension_address
	;[edx] - extension length
	;[ebx] - file type
		;[ebx] - 0 - filename without extension
		;[ebx] - 1 - filename with .asm extension
		;[ebx] - 2 - filename with .inc extension
		;[ebx] - 3 - filename with .def extension
		;[ebx] - 4 - filename with .rc  extension
		;[ebx] - 5 - filename with .map extension
		;[ebx] - 6 - filename with .txt extension
		;[ebx] - 7 - filename with .bat extension
		;[ebx] - 10 - filename with unsupported extension
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Get_File_Name endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push string_length			;ebp+12
;push string_address			;ebp+8
;call SC_Convert_Into_Lowercase

SC_Convert_Into_Lowercase proc
push ebp
mov ebp,esp

mov eax,(-1)
cmp Convert_Into_Lowercase_busy_flag,1
je end_convert_into_lowercase
mov Convert_Into_Lowercase_busy_flag,1

.DATA
Convert_Into_Lowercase_busy_flag		dd 0
lowercase_convert_counter			dd 0
lowercase_convert_flag				dd 0
.CODE

mov lowercase_convert_flag,0		;Initially set count of converted flag to null
mov lowercase_convert_counter,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert into lowercase
start_convert_into_lowercase:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;UPPERCASE CODES	--> [ 65 - 90  ]
;LOWERCASE CODES	--> [ 97 - 122 ]

;;;;;;;;;; Substraction --> 32
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ebx,ebx
mov eax,dword ptr [ebp]+8		;string address
add eax,lowercase_convert_counter

;;Check_Location_Within_Boundaries macro Min, Value, Max ;[EAX] - 1 True	[EAX] - 0 False

mov bl,byte ptr [eax]
Check_Location_Within_Boundaries  65, ebx, 90 ;[EAX] - 1 True	[EAX] - 0 False

xor edx,edx
mov ecx,dword ptr [ebp]+8		;string address
add ecx,lowercase_convert_counter
mov dl,byte ptr [ecx]
mov esi,edx
mov edi,edx
add esi,32

xchg eax,ebx
xor eax,eax
cmp ebx,1
sete al
add lowercase_convert_flag,eax

ror eax,1
cdq
and esi,edx
not edx
and edi,edx
add esi,edi
mov eax,esi

mov ecx,dword ptr [ebp]+8		;string length
add ecx,lowercase_convert_counter
mov byte ptr [ecx],al
;;;;ADD 32 if eax 1 else no

inc lowercase_convert_counter
mov eax,dword ptr [ebp]+12		;string length
cmp lowercase_convert_counter,eax
jb start_convert_into_lowercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert into lowercase

xor eax,eax
mov Convert_Into_Lowercase_busy_flag,0
end_convert_into_lowercase:
mov ebx,lowercase_convert_flag

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy 
;[eax] -  0  - Function normal processed
	;[ebx] - count of converted bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Convert_Into_Lowercase endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push string_length			;ebp+12
;push string_address			;ebp+8
;call SC_Convert_Into_Uppercase

SC_Convert_Into_Uppercase proc
push ebp
mov ebp,esp

mov eax,(-1)
cmp Convert_Into_Uppercase_busy_flag,1
je end_convert_into_uppercase
mov Convert_Into_Uppercase_busy_flag,1

.DATA
Convert_Into_Uppercase_busy_flag		dd 0
uppercase_convert_counter			dd 0
uppercase_convert_flag				dd 0
.CODE

mov uppercase_convert_flag,0		;Initially set count of converted flag to null
mov uppercase_convert_counter,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert into lowercase
start_convert_into_uppercase:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;UPPERCASE CODES	--> [ 65 - 90  ]
;LOWERCASE CODES	--> [ 97 - 122 ]

;;;;;;;;;; Substraction --> 32
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ebx,ebx
mov eax,dword ptr [ebp]+8		;string address
add eax,uppercase_convert_counter

;;Check_Location_Within_Boundaries macro Min, Value, Max ;[EAX] - 1 True	[EAX] - 0 False

mov bl,byte ptr [eax]
Check_Location_Within_Boundaries  97, ebx, 122 ;[EAX] - 1 True	[EAX] - 0 False

xor edx,edx
mov ecx,dword ptr [ebp]+8		;string address
add ecx,uppercase_convert_counter
mov dl,byte ptr [ecx]
mov esi,edx
mov edi,edx
sub esi,32

xchg eax,ebx
xor eax,eax
cmp ebx,1
sete al
add uppercase_convert_flag,eax

ror eax,1
cdq
and esi,edx
not edx
and edi,edx
add esi,edi
mov eax,esi

mov ecx,dword ptr [ebp]+8		;string length
add ecx,uppercase_convert_counter
mov byte ptr [ecx],al
;;;;ADD 32 if eax 1 else no

inc uppercase_convert_counter
mov eax,dword ptr [ebp]+12		;string length
cmp uppercase_convert_counter,eax
jb start_convert_into_uppercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert into lowercase

xor eax,eax
mov Convert_Into_Uppercase_busy_flag,0
end_convert_into_uppercase:
mov ebx,uppercase_convert_flag

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy 
;[eax] -  0  - Function normal processed
	;[ebx] - count of converted bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Convert_Into_Uppercase endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm 