SPL_Init_Functions_1 macro
;;;Using example
;push spl_buffer_length				;ebp+16
;push offset spl_buffer				;ebp+12
;push offset all_spl_descriptior_address	;ebp+8
;call SPL_Init_System
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Init_System proc
push ebp
mov ebp,esp

mov eax,dword ptr [ebp+12]
mov spl_buffer_address,eax
mov ebx,dword ptr [ebp+16]
mov spl_buffer_length,ebx
mov ecx,dword ptr [ebp+8]
mov all_spl_descriptor_address,ecx

.DATA
spl_buffer_address			dd 0
spl_buffer_length			dd 0
all_spl_descriptor_address		dd 0
init_buffers_block_address		dd 0
all_spl_address_increment		dd 0
standard_object_length			dd 0

;flls					db 'File_Load_List_Start'
;flle					db 'File_Load_List_End'
fls					db 'File_List_Start'
fle					db 'File_List_End'
pls					db 'Programs_List_Start'
ple					db 'Programs_List_End'
ols					db 'Operations_List_Start'
ole					db 'Operations_List_End'

fll_flag				dd 0
fl_flag					dd 0
pl_flag					dd 0
ol_flag					dd 0

.CODE

mov all_spl_address_increment,0
mov fl_flag,0
mov pl_flag,0
mov ol_flag,0
mov standard_object_length,0

xor eax,eax
mov edi,all_spl_descriptor_address
mov ecx,48
rep stosb 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start to Find Files_list_start
start_find_files_list:

mov eax,93			;Unexpected end while init system [Error code]
mov ebx,all_spl_address_increment
cmp ebx,spl_buffer_length
ja end_init_system
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Find [ symbol
;SV_find_byte macro scan_string, find_byte, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ecx,ecx
mov eax,spl_buffer_address
add eax,all_spl_address_increment

mov ebx,spl_buffer_length
sub ebx,all_spl_address_increment

mov cl,'['

;;;SV_find_byte eax, cl, ebx

push ebx	;string_length	;ebp+20
push ecx	;find_byte		;ebp+16
push eax	;scan_string	;ebp+12
call Find_Byte

add all_spl_address_increment,ecx
cmp eax,0
je end_init_system
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Find [ symbol
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Standard Object
;;push offset spl_object_string ;spl_object_address	;ebp + 24
;;push 20  ;string_length					;ebp + 20
;;call SPL_Get_Standard_Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 - success [TRUE]
;[EAX] - Any other value [Error code]
	;[EBX] - 0 - Find direct word in delimiters
	;[EBX] - 1 - Find label 
	;[ESI] - Word or label Start Address [Or error address when error occurs]
	;[ECX] - Word or label length
	;[EDI] - Object end address  [  second ']'  ] 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,spl_buffer_address
add eax,all_spl_address_increment

mov ebx,spl_buffer_length
sub ebx,all_spl_address_increment

push eax	;offset spl_object_string ;spl_object_address	;ebp + 24
push ebx	;20  ;string_length					;ebp + 20
call SPL_Get_Standard_Object

sub edi,spl_buffer_address
inc edi
sub edi,all_spl_address_increment
mov standard_object_length,edi

inc all_spl_address_increment

cmp eax,1
jne start_find_files_list
cmp ebx,0
je start_find_files_list

mov edx,spl_buffer_length
mov eax,93			;Unexpected end while find Files List Start
inc ecx
add all_spl_address_increment,ecx
cmp all_spl_address_increment,edx
ja end_init_system
dec ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Standard Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check File Load List [Start]
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[esi]
;[ecx]
push esi
push ecx

mov edi,offset fls	;db 'File_List_Start'

;;;SV_compare_string esi, edi, ecx			;Check with 'File_List_Start'

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

pop ecx
pop esi
cmp eax,1
jne no_file_list_start

mov eax,112			;File List Error [Error code]
cmp fl_flag,0
jne end_init_system

mov eax,114			;File List Error [Error code]
cmp pl_flag,1		;Program List
je end_init_system
mov eax,115			;File List Error [Error code]
cmp ol_flag,1		;Operation List
je end_init_system

mov eax,spl_buffer_address
add eax,all_spl_address_increment
mov edx,all_spl_descriptor_address
mov dword ptr [edx]+4,eax		;Set File  List Start

mov fl_flag,1
no_file_list_start:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check File Load List [Start]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check File Load List [End]
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[esi]
;[ecx]
push esi
push ecx

mov edi,offset fle	;db 'File_List_End'

;;;SV_compare_string esi, edi, ecx			;Check with 'File_List_Start'
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

pop ecx
pop esi
cmp eax,1
jne no_file_list_end

mov eax,116			;File Load List Error [Error code]
cmp fl_flag,1
jne end_init_system

mov eax,118			;File Load List Error [Error code]
cmp pl_flag,1		;Program List
je end_init_system

mov eax,119			;File Load List Error [Error code]
cmp ol_flag,1		;Operation List
je end_init_system

mov eax,spl_buffer_address
add eax,all_spl_address_increment

mov edx,all_spl_descriptor_address
sub eax,dword ptr [edx]+4
sub eax,standard_object_length

mov edx,all_spl_descriptor_address
mov dword ptr [edx]+8,eax		;Set File Load List length

mov fl_flag,17		;Set File Load List as Complete
no_file_list_end:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check File Load List [End]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Programs List [Start]
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[esi]
;[ecx]
push esi
push ecx

mov edi,offset pls	;db 'Programs_List_Start'
;;SV_compare_string esi, edi, ecx			;Check with 'Programs_List_Start'

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

pop ecx
pop esi
cmp eax,1
jne no_programs_list_start

mov eax,120			;Programs List Error [Error code]
cmp pl_flag,0
jne end_init_system

mov eax,122			;Programs List Error [Error code]
cmp fl_flag,1		;Program List
je end_init_system
mov eax,123			;Programs List Error [Error code]
cmp ol_flag,1		;Operation List
je end_init_system

mov eax,spl_buffer_address
add eax,all_spl_address_increment
mov edx,all_spl_descriptor_address
mov dword ptr [edx]+20,eax		;Set Programs List Start

mov pl_flag,1
no_programs_list_start:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Programs List [Start]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Programs List [End]
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[esi]
;[ecx]
push esi
push ecx

mov edi,offset ple	;db 'Programs_List_End';
;;SV_compare_string esi, edi, ecx			;Check with 'Programs_List_Start'
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

pop ecx
pop esi
cmp eax,1
jne no_programs_list_end

mov eax,124			;Programs List Error [Error code]
cmp pl_flag,1
jne end_init_system

mov eax,126			;Programs List Error [Error code]
cmp fl_flag,1		;Program List
je end_init_system

mov eax,127			;Programs List Error [Error code]
cmp ol_flag,1		;Operation List
je end_init_system

mov eax,spl_buffer_address
add eax,all_spl_address_increment

mov edx,all_spl_descriptor_address
sub eax,dword ptr [edx]+20
sub eax,standard_object_length

mov edx,all_spl_descriptor_address
mov dword ptr [edx]+24,eax		;Set Programs List length

mov pl_flag,17		;Set Programs List as Complete
no_programs_list_end:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Programs List [End]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Operations List [Start]
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[esi]
;[ecx]
push esi
push ecx

mov edi,offset ols	;db 'Operations_List_Start'
;;SV_compare_string esi, edi, ecx			;Check with 'Operations_List_Start'

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

pop ecx
pop esi
cmp eax,1
jne no_operations_list_start

mov eax,128			;Operations List Error [Error code]
cmp ol_flag,0
jne end_init_system

mov eax,130			;Operations List Error [Error code]
cmp fl_flag,1		;Program List
je end_init_system
mov eax,131			;Operations List Error [Error code]
cmp pl_flag,1		;Operation List
je end_init_system

mov eax,spl_buffer_address
add eax,all_spl_address_increment
mov edx,all_spl_descriptor_address
mov dword ptr [edx]+28,eax		;Set Programs List Start

mov ol_flag,1
no_operations_list_start:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Operations List [Start]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Operations List [End]
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[esi]
;[ecx]
push esi
push ecx

mov edi,offset ole	;db 'Operations_List_End'
;;SV_compare_string esi, edi, ecx			;Check with 'Operations_List_Start'

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

pop ecx
pop esi
cmp eax,1
jne no_operations_list_end

mov eax,132			;Operations List Error [Error code]
cmp ol_flag,1
jne end_init_system

mov eax,134			;Operations List Error [Error code]
cmp fl_flag,1		;Program List
je end_init_system

mov eax,135			;Operations List Error [Error code]
cmp pl_flag,1		;Operation List
je end_init_system

mov eax,spl_buffer_address
add eax,all_spl_address_increment

mov edx,all_spl_descriptor_address
sub eax,dword ptr [edx]+28
sub eax,standard_object_length

mov edx,all_spl_descriptor_address
mov dword ptr [edx]+32,eax		;Set Operations List length

mov ol_flag,17		;Set Operations List as Complete
no_operations_list_end:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Operations List [End]
jmp start_find_files_list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Object Lists
end_init_system:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 12
SPL_Init_System endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using Example
;push offset all_spl_program_descriptor_block	;ebp+8
;call SPL_Check_System_Initialization

SPL_Check_System_Initialization proc
push ebp
mov ebp,esp

mov edx,dword ptr [ebp+8]

;mov eax,136
;mov edx,dword ptr [edx]+12	;Warning Files Load List
;cmp edx,0
;je end_check_SPL_init

;mov eax,137
;mov ebx,dword ptr [edx]+16	;Warning Files Load List
;cmp ebx,0
;je end_check_SPL_init

mov eax,138
mov ebx,dword ptr [edx]+4	;Files List Start 
cmp ebx,0
je end_check_SPL_init

mov eax,139
mov ecx,dword ptr [edx]+8	;Files List Length
cmp ecx,0
je end_check_SPL_init

mov eax,140
mov esi,dword ptr [edx]+20	;Programs List Start 
cmp esi,0
je end_check_SPL_init

mov eax,141
mov edi,dword ptr [edx]+24	;Programs List Length
cmp edi,0
je end_check_SPL_init

mov eax,142
mov ebx,dword ptr [edx]+28	;Operations List Start 
cmp ebx,0
je end_check_SPL_init

mov eax,143
mov ecx,dword ptr [edx]+32	;Operations List Length
cmp ecx,0
je end_check_SPL_init

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1	;All SPL normal init
end_check_SPL_init:

mov esp,ebp
pop ebp
ret 4
SPL_Check_System_Initialization endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push offset operation_fill_block	;ebp+8
;call SPL_Get_Operation_Type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Get_Operation_Type proc
push ebp
mov ebp,esp

mov eax,dword ptr [ebp+8]
mov dword ptr [eax],0		;At start Set Operation type as Error 

.DATA
compile_operation	db 'Compile', 0			;1
link_operation		db 'Link'			;2
console_operation	db 'ConsoleConnect'		;3
delete_operation	db 'Delete', 0, 0		;4
execute_operation	db 'Execute', 0			;5
shell_execute_operation	db 'ShellExecute', 0, 0, 0, 0	;6
copy_operation		db 'Copy'			;7

.CODE

;show_decimal 430, 30, ebx
;pushad

;push 60;ebx		;output_scan_string_length
;push eax ;spl_buffer_address	;output_scan_string_address
;push 380	
;push 30
;push hdc
;call TextOutA
;popad

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar 
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]

mov esi,dword ptr [eax]+8	;Operation Name Address
mov ecx,dword ptr [eax]+4	;Operation Name Length
mov edi,offset compile_operation	;compile_operation	db 'Compile', 0			;1
cmp ecx,7
jne no_compile_operation

;;;SV_compare_string esi, edi, ecx

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

cmp eax,0
je no_compile_operation

mov eax,dword ptr [ebp+8]
mov dword ptr [eax],1

mov eax,1
jmp end_get_operation_type
no_compile_operation:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar 
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]

mov esi,dword ptr [eax]+8	;Operation Name Address
mov ecx,dword ptr [eax]+4	;Operation Name Length
mov edi,offset link_operation	;link_operation		db 'Link'			;2
cmp ecx,4
jne no_link_operation

;;SV_compare_string esi, edi, ecx

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

cmp eax,0
je no_link_operation

mov eax,dword ptr [ebp+8]
mov dword ptr [eax],2

mov eax,1
jmp end_get_operation_type
no_link_operation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar 
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]

mov esi,dword ptr [eax]+8	;Operation Name Address
mov ecx,dword ptr [eax]+4	;Operation Name Length
mov edi,offset console_operation	;;console_operation	db 'ConsoleConnect'		;3
cmp ecx,14
jne no_console_operation

;;;;SV_compare_string esi, edi, ecx
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

cmp eax,0
je no_console_operation

mov eax,dword ptr [ebp+8]
mov dword ptr [eax],3

mov eax,1
jmp end_get_operation_type
no_console_operation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar 
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]

mov esi,dword ptr [eax]+8	;Operation Name Address
mov ecx,dword ptr [eax]+4	;Operation Name Length
mov edi,offset delete_operation	;delete_operation	db 'Delete', 0, 0		;4
cmp ecx,6
jne no_delete_operation

;;SV_compare_string esi, edi, ecx
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

cmp eax,0
je no_delete_operation

mov eax,dword ptr [ebp+8]
mov dword ptr [eax],4

mov eax,1
jmp end_get_operation_type
no_delete_operation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar 
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]

mov esi,dword ptr [eax]+8	;Operation Name Address
mov ecx,dword ptr [eax]+4	;Operation Name Length
mov edi,offset execute_operation	;execute_operation	db 'Execute', 0			;5
cmp ecx,7
jne no_execute_operation

;;SV_compare_string esi, edi, ecx
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

cmp eax,0
je no_execute_operation

mov eax,dword ptr [ebp+8]
mov dword ptr [eax],5
mov eax,1
jmp end_get_operation_type
no_execute_operation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar 
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]

mov esi,dword ptr [eax]+8	;Operation Name Address
mov ecx,dword ptr [eax]+4	;Operation Name Length
mov edi,offset shell_execute_operation	;shell_execute_operation	db 'ShellExecute', 0, 0, 0, 0	;6
cmp ecx,12
jne no_shell_execute_operation

;;;;SV_compare_string esi, edi, ecx
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String


cmp eax,0
je no_shell_execute_operation

mov eax,dword ptr [ebp+8]
mov dword ptr [eax],6

mov eax,1
jmp end_get_operation_type
no_shell_execute_operation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar 
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]

mov esi,dword ptr [eax]+8	;Operation Name Address
mov ecx,dword ptr [eax]+4	;Operation Name Length
mov edi,offset copy_operation	;copy_operation		db 'Copy'			;7
cmp ecx,4
jne no_copy_operation

;;SV_compare_string esi, edi, ecx
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

cmp eax,0
je no_copy_operation

mov eax,dword ptr [ebp+8]
mov dword ptr [eax],7	;Set Operation type as Copy

mov eax,1
jmp end_get_operation_type
no_copy_operation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,144			;Cannot determine operation name by name [Error code]
end_get_operation_type:

mov esp,ebp
pop ebp
ret 4
SPL_Get_Operation_Type endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


endm