SPL_Standard_Functions_3 macro
SPL_Process_One_Float_Operator proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push offset scan_string_address		;ebp+36
;push offset scan_string_length		;ebp+32
;push offset operation_type		;ebp+28
;push offset word_start_address		;ebp+24
;push offset word_length			;ebp+20
;call SPL_Process_One_Float_Operator
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sub esp,12
;push eax		;ebp+12
;push eax		;ebp+8
;push eax		;ebp+4

push ebp
mov ebp,esp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Bit 0 	[0 - Word  Operator][1 - Delimiter Operator]
;Bit 1	[0 - Check Operator][1 - Get       Operator]
;.DATA
;find_string_address	dd 0	;ebp+12
;find_string_length	dd 0	;ebp+8
;address_increment	dd 0	;ebp+4
;.CODE

mov dword ptr [ebp+4],0		;mov address_increment,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,dword ptr [ebp+36]	;mov esi,scan_string_address
add esi,dword ptr [ebp+4]		;add esi,address_increment

mov eax,5		;Unexpected end [Error code]
mov edx,dword ptr [ebp+4]	;mov edx,address_increment
	mov ebx,dword ptr [ebp+32]
cmp edx,dword ptr [ebx]		;cmp edx,scan_string_length
ja end_process_float_operator

mov eax,dword ptr [ebp+36]	;mov eax,scan_string_address

add eax,dword ptr [ebp+4]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,scan_string_length
	mov ebx,dword ptr [ebx]
sub ebx,dword ptr [ebp+4]	;sub ebx,address_increment

;;SV_Escape_Separators SPL_015, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

	mov esi,dword ptr [ebp+36]	;mov esi,scan_string_address
	add esi,dword ptr [ebp+4]		;add esi,address_increment

xchg eax,edi
mov esi,ecx
mov eax,5		;Unexpected end [Error code]
cmp edi,1
jne end_process_float_operator

;mov eax,5		;[eax] already contains 5;Unexpected end [Error code]
mov edx,ebx
add edx,dword ptr [ebp+4]	;add edx,address_increment
	mov ecx,dword ptr [ebp+32]
cmp edx,dword ptr [ecx]		;cmp edx,scan_string_length
ja end_process_float_operator

add dword ptr [ebp+4],ebx	;add address_increment,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,dword ptr [ebp+28]	;mov ebx,operation_type
	mov ebx,dword ptr [ebx]
bt ebx,0
jc no_word_operator	;jump if 1 [ 0 - word object ]

;SV_Get_Word macro word_index, scan_string, scan_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Word found  
;[EAX] - 0 Word found, but string end reached
	;[ESI] - Word start address
	;[ECX] - Word length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,scan_string_address
add eax,dword ptr [ebp+4]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,scan_string_length
	mov ebx,dword ptr [ebx]
sub ebx,dword ptr [ebp+4]	;sub ebx,address_increment

xchg eax,esi

mov eax,12		;Specified operator type is absent in current position [Error code]
cmp byte ptr [esi],'"'
je end_process_float_operator

;mov eax,12		;Specified operator type is absent in current position [Error code]
cmp byte ptr [esi],"'"
je end_process_float_operator

xchg eax,esi

;;;;SV_Get_Word SPL_016, eax, ebx
push ebx	;scan_string_length	;ebp+20
push eax	;scan_string		;ebp+16
call Get_Word

xchg eax,edi
xchg esi,ebx 
	mov esi,dword ptr [ebp+36]	;mov esi,scan_string_address
	add esi,dword ptr [ebp+4]	;add esi,address_increment
mov eax,5		;Unexpected end [Error code]
cmp edi,0
;je end_process_float_operator	


mov eax,5		;[eax] already contains 5;Unexpected end [Error code]
mov edx,ecx
add edx,dword ptr [ebp+4]	;add edx,address_increment
	mov edi,dword ptr [ebp+32]
cmp edx,dword ptr [edi]	;cmp edx,scan_string_length
ja end_process_float_operator

xchg esi,ebx 
xchg eax,edi

mov dword ptr [ebp+12],esi	;mov find_string_address,esi
mov dword ptr [ebp+8],ecx	;mov find_string_length,ecx

add dword ptr [ebp+4],ecx	;add address_increment,ecx

jmp end_determine_object_type
no_word_operator:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,dword ptr [ebp+28]	;mov ebx,operation_type
	mov ebx,dword ptr [ebx]
bt ebx,0
jnc end_determine_object_type ;jump if no 1 [ 1 - Delimiter object ]

;Get_Object_In_Delimiters macro SPL_index, scan_string_address, scan_string_len
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;[eax] = 10	First symbol is not a delimiter
;;;[eax] = 1	Object in double delimiters is get
;;;[eax] = 0	String end reached, or cannot retrieve delimiter object 
	;;;[esi] = start address of object in delimiters
	;;;[ecx] = length of string limited by delimiters
	;;;[edx] = address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,scan_string_address
add eax,dword ptr [ebp+4]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,scan_string_length
	mov ebx,dword ptr [ebx]

sub ebx,dword ptr [ebp+4]	;sub ebx,address_increment

;;Get_Object_In_Delimiters SPL_018, eax, ebx
push ebx	;scan_string_len			;ebp+12
push eax	;scan_string_address		;ebp+8
call Get_Object_In_Delimiters

xchg esi,edi
	mov esi,dword ptr [ebp+36]	;mov esi,scan_string_address
	add esi,dword ptr [ebp+4]	;add esi,address_increment

cmp eax,1			;;[Error code][eax] - is already contains error code
jne end_process_float_operator

mov eax,5		;Unexpected end [Error code]
mov ebx,dword ptr [ebp+4]		;mov ebx,address_increment
add ebx,ecx
inc ebx
inc ebx
	mov edx,dword ptr [ebp+32]
cmp ebx,dword ptr [edx]			;cmp ebx,scan_string_length
ja end_process_float_operator

mov ebx,ecx
add ebx,2
add dword ptr [ebp+4],ebx		;add address_increment,ebx

xchg esi,edi

mov dword ptr [ebp+12],esi		;mov find_string_address,esi
mov dword ptr [ebp+8],ecx		;mov find_string_length,ecx
xor eax,eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
end_determine_object_type:

mov ebx,dword ptr [ebp+28]		;mov ebx,operation_type
	mov ebx,dword ptr [ebx]
bt ebx,1
jc no_compare_object	;jump if 1 [ 0 - check or compare obtained object ]

	mov esi,dword ptr [ebp+36]	;mov esi,scan_string_address
	add esi,dword ptr [ebp+4]	;add esi,address_increment
mov eax,13			;Operators lengths are not similar [Error code]
mov ecx,dword ptr [ebp+8]		;mov ecx,find_string_length

	mov edi,dword ptr [ebp+20]
cmp ecx,dword ptr [edi]			;cmp ecx,word_length
jne end_process_float_operator

;word_start_address	dd 0
;word_length		dd 0

;;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,dword ptr [ebp+12]	;mov esi,find_string_address
mov edi,dword ptr [ebp+24]	;mov edi,word_start_address
	mov edi,dword ptr [edi]
mov dword ptr [ebp+8],ecx	;mov find_string_length,ecx

;;SV_compare_string esi, edi, ecx
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String 

xchg eax,ebx
	mov esi,dword ptr [ebp+36]	;mov esi,scan_string_address
	add esi,dword ptr [ebp+4]	;add esi,address_increment
mov eax,11			;Specified operator is invalid [Error code]
cmp ebx,0
je end_process_float_operator

mov eax,1		;Normal execution [Error code]

jmp end_operation_type
no_compare_object:

mov ebx,dword ptr [ebp+28]	;mov ebx,operation_type
	mov ebx,dword ptr [ebx]
bt ebx,1
jnc end_operation_type	;jump if 0 [ 1 - send parameters of previous obtained object ]

mov dword ptr [ebp+12],esi	;mov find_string_address,esi
mov dword ptr [ebp+8],ecx	;mov find_string_length,ecx

mov eax,dword ptr [ebp+24]
mov dword ptr [eax],esi	;mov word_start_address,esi

mov eax,dword ptr [ebp+20]
mov dword ptr [eax],ecx	;mov word_length,ecx

mov eax,1		;Normal execution [Error code]

end_operation_type:
nop
nop
nop

mov esi,dword ptr [ebp+36]
add esi,dword ptr [ebp+4]

end_process_float_operator:

mov ecx,dword ptr [ebp+4]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Normal execution
;[eax] - Any other value is error code
;[esi] - error address
;[ecx] - address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
add esp,12
ret 20
SPL_Process_One_Float_Operator endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Get_Insert_Object proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset replace_start_address	;ebp+20
;push offset replace_length		;ebp+16
;push insert_object_address		;ebp+12
;push insert_object_length		;ebp+8
;call SPL_Get_Insert_Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.586
push ebp
mov ebp,esp

mov eax,dword ptr [ebp+12]
	mov ebx,dword ptr [ebp+8]
mov insert_object_address,eax
	mov insert_object_length,ebx

.DATA
insert_object_address		dd 0
insert_object_length		dd 0
address_increment		dd 0
open_commas			db '[',0, 0, 0
file_name_type			dd 0	;[ 0 - direct word in delimiters ][ 1 - label ]
file_name_start_address		dd 0
file_name_length		dd 0
extension_type			dd 0	;[ 0 - direct word in delimiters ][ 1 - label ] 
extension_start_address		dd 0
extension_length		dd 0

replace_object_start_address	dd 0
replace_object_length		dd 0

.CODE
mov address_increment,0
mov file_name_type,0
mov file_name_length,0
mov extension_type,0
mov extension_start_address,0
mov extension_length,0

mov replace_object_start_address,0
mov replace_object_length,0

start_get_insert_object:

mov esi,insert_object_address
add esi,address_increment
mov eax,0			;String object not found [Error code]
mov ebx,address_increment
cmp ebx,insert_object_length
ja end_get_insert_object

;insert_object		db '..[..[ Insert "File" Start ][ 00177 ][ "obj" ][Insert "File" End ]..',0

;SV_find_string  macro label_index, scan_string_address, all_string_size, find_string_address, find_str_size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;[eax] = 1 string find
;;;[eax] = 0 string not find
	;;;[ebx] address_increment while find string = [esi] -  scan_string_offset
	;;;[esi] address of first byte of found string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,insert_object_address
add eax,address_increment
mov ebx,insert_object_length
mov ecx,offset open_commas

;;SV_find_string SPL_019, eax, ebx, ecx, 1

push 1	;find_str_size			;ebp+24
push ecx	;find_string_address		;ebp+20
push ebx	;all_string_size			;ebp+16
push eax	;scan_string_address		;ebp+12
call Find_String 

mov replace_object_start_address,esi

	mov esi,insert_object_address
	add esi,address_increment
cmp eax,0
je end_get_insert_object		;Insert Object[or first commas] not Found [Error code]

mov eax,0
mov ecx,ebx
add ecx,address_increment 	
inc ecx
cmp ecx,insert_object_length
ja end_get_insert_object

add address_increment,ebx
inc address_increment

.DATA
operation_type_1	dd 0	;;0 - Check Word Operator;1 - Check Delimiter Operator;2 - Get Word Operator;3 - Get Delimiter Operator
word_start_address_1	dd offset word_insert
word_length_1		dd 6
word_insert		db 'Insert',0,0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,insert_object_address
	add eax,address_increment
push eax ;offset insert_object			 ;eax		;offset scan_string_address		;ebp+36
push offset insert_object_length	;offset scan_string_length		;ebp+32
push offset operation_type_1		;ebp+28
push offset word_start_address_1		;ebp+24
push offset word_length_1			;ebp+20
call SPL_Process_One_Float_Operator
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Normal execution
;[eax] - Any other value is error code [0][5][10][11][12][13]
	;[esi] - error address
	;[ecx] - address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[1]  - [Float operator normal get]
;[0]  - [String end reached when try to find second delimiter]  
;[5]  - [String end reached]
;[10] - [First symbol is not delimiter]
;[11] - [Specified operator is invalid]
;[12] - [Specified operator type is invalid in current position]
;[13] - [Operator lengths are not similar]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Continue serial check of the float operators			;In case of [1]
;Return [SPL_Get_Insert_Object] as Insert Object Not Found	;In case of [0][5]
;Start over from [start_get_insert_object]			;In case of [10][11][12][13]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0			;String End Reached [Error code]
je end_get_insert_object
cmp eax,5			;String End Reached [Error code]
je end_get_insert_object
cmp eax,10			;Second symbol is not delimiter [Error code]
je start_get_insert_object
cmp eax,11			;Specified operator is invalid [Error code]
je start_get_insert_object
cmp eax,13			;Operator lengths are not similar [Error code]
je start_get_insert_object

xor eax,eax			;String end reached [Insert Object Not Found] 
mov edx,address_increment
add edx,ecx
	;inc edx
cmp edx,insert_object_length
ja end_get_insert_object		;[esi] -  already contains error address
mov address_increment,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
operation_type_2	dd 3	;3 - Get Delimiter Operator;0 - Check Word Operator;1 - Check Delimiter Operator;2 - Get Word Operator
word_start_address_2	dd offset word_in_delimiters_file
word_length_2		dd 4
word_in_delimiters_file	dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,insert_object_address;
	add eax,address_increment
push eax ;offset insert_object			 ;eax		;offset scan_string_address		;ebp+36
push offset insert_object_length	;offset scan_string_length		;ebp+32
push offset operation_type_2		;ebp+28
push offset word_start_address_2		;ebp+24
push offset word_length_2			;ebp+20
call SPL_Process_One_Float_Operator
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0			;String End Reached [Error code]
je end_get_insert_object
cmp eax,5			;String End Reached [Error code]
je end_get_insert_object
cmp eax,10			;Second symbol is not delimiter [Error code]
je start_get_insert_object
cmp eax,11			;Specified operator is invalid [Error code]
je start_get_insert_object
cmp eax,13			;Operator lengths are not similar [Error code]
je start_get_insert_object

xor eax,eax			;String end reached [Insert Object Not Found] 
mov edx,address_increment
add edx,ecx
	;inc edx
cmp edx,insert_object_length
ja end_get_insert_object	;[esi] - already contain error address
mov address_increment,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
operation_type_3	dd 0	;;0 - Check Word Operator;1 - Check Delimiter Operator;2 - Get Word Operator;3 - Get Delimiter Operator
word_start_address_3	dd offset word_start
word_length_3		dd 5
word_start		db 'Start',0, 0, 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,insert_object_address;
	add eax,address_increment
push eax ;offset insert_object			 ;eax		;offset scan_string_address		;ebp+36
push offset insert_object_length	;offset scan_string_length		;ebp+32
push offset operation_type_3		;ebp+28
push offset word_start_address_3		;ebp+24
push offset word_length_3			;ebp+20
call SPL_Process_One_Float_Operator
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0			;String End Reached [Error code]
je end_get_insert_object
cmp eax,5			;String End Reached [Error code]
je end_get_insert_object
cmp eax,10			;Second symbol is not delimiter [Error code]
je start_get_insert_object
cmp eax,11			;Specified operator is invalid [Error code]
je start_get_insert_object
cmp eax,13			;Operator lengths are not similar [Error code]
je start_get_insert_object

xor eax,eax			;String end reached [Insert Object Not Found] 
mov edx,address_increment
add edx,ecx
	;inc edx
cmp edx,insert_object_length
ja end_get_insert_object	;[esi] - already contains error address
mov address_increment,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,insert_object_address
add eax,address_increment
mov ebx,insert_object_length
sub ebx,address_increment

;;SV_Escape_Separators SPL_020, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

cmp eax,1
jne end_get_insert_object
add address_increment,ebx

	mov esi,insert_object_address
	add esi,address_increment

xor eax,eax
mov ecx,insert_object_address
add ecx,address_increment
cmp byte ptr [ecx],']'		;Check ]   ;; [ Insert "File" Start ]
jne end_get_insert_object

mov ebx,address_increment
inc ebx
cmp ebx,insert_object_length
ja end_get_insert_object

inc address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,insert_object_address
add eax,address_increment
mov ebx,insert_object_length
sub ebx,address_increment

push eax	;Object string address 
push ebx	;Object string length 
call SPL_Get_Standard_Object			;Get File name as standard object --> [ 00176 ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 - success [TRUE]
;[EAX] - Any other value [Error code]
	;[EBX] - 0 - Find direct word in delimiters
	;[EBX] - 1 - Find label 
	;[ESI] - Word or label Start Address [Or error address when error occurs]
	;[ECX] - Word or label length
	;[EDI] - Object end address  [  second ']'  ] 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;[All errors after this are Insert Object errors]
;	mov esi,insert_object_address	;[esi] - already contains error address
;	add esi,address_increment

xchg eax,edx
mov eax,15		;Insert Object file name bad definition	[Error code]
cmp edx,1
jne end_get_insert_object
xchg eax,edx

mov file_name_type,ebx
mov file_name_start_address,esi
mov file_name_length,ecx

sub edi,insert_object_address
mov address_increment,edi

mov eax,16			;Unexpected end after file name definition [Error code]
mov ecx,address_increment
	;inc ecx
cmp ecx,insert_object_length
ja end_get_insert_object

inc address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov extension_length,0

mov eax,insert_object_address
add eax,address_increment
mov ebx,insert_object_length
sub ebx,address_increment

push eax	;Object string address 
push ebx	;Object string length 
call SPL_Get_Standard_Object			;Get File name as standard object --> [ 00176 ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 - success [TRUE]
;[EAX] - Any other value [Error code]
	;[EBX] - 0 - Find direct word in delimiters
	;[EBX] - 1 - Find label 
	;[ESI] - Word or label Start Address [Or error address when error occurs]
	;[ECX] - Word or label length
	;[EDI] - Object end address  [  second ']'  ] 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;[All errors after this are Insert Object errors]
cmp eax,1
jne no_extension_defined

mov extension_type,ebx
mov extension_start_address,esi
mov extension_length,ecx

sub edi,insert_object_address
mov address_increment,edi

mov eax,17			;Unexpected end after extension definition [Error code]
mov ecx,address_increment
	;inc ecx
cmp ecx,insert_object_length
ja end_get_insert_object

inc address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1
no_extension_defined:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,insert_object_address
add eax,address_increment
mov ebx,insert_object_length
sub ebx,address_increment

;;SV_Escape_Separators SPL_021, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

	mov esi,insert_object_address
	add esi,address_increment

xchg eax,ecx
mov eax,17			;Unexpected end after extension definition [Error code]
cmp ecx,1
jne end_get_insert_object
add address_increment,ebx
xchg eax,ecx

mov eax,14			;[ Expected in Insert Object end 
mov ecx,insert_object_address
add ecx,address_increment
cmp byte ptr [ecx],'['		;Check ]   ;; [ Insert "File" Start ]
jne end_get_insert_object

mov ebx,address_increment
inc ebx
cmp ebx,insert_object_length
ja end_get_insert_object

inc address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
operation_type_4	dd 0	;;0 - Check Word Operator;1 - Check Delimiter Operator;2 - Get Word Operator;3 - Get Delimiter Operator
word_start_address_4	dd offset word_insert_4
word_length_4		dd 6
word_insert_4		db 'Insert',0,0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,insert_object_address
	add eax,address_increment
push eax ;offset insert_object			 ;eax		;offset scan_string_address		;ebp+36
push offset insert_object_length	;offset scan_string_length		;ebp+32
push offset operation_type_4		;ebp+28
push offset word_start_address_4		;ebp+24
push offset word_length_4			;ebp+20
call SPL_Process_One_Float_Operator
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Normal execution
;[eax] - Any other value is error code [0][5][10][11][12][13]
	;[esi] - error address
	;[ecx] - address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[1]  - [Float operator normal get]
;[0]  - [String end reached when try to find second delimiter]  
;[5]  - [String end reached]
;[10] - [First symbol is not delimiter]
;[11] - [Specified operator is invalid]
;[12] - [Specified operator type is invalid in current position]
;[13] - [Operator lengths are not similar]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Continue serial check of the float operators			;In case of [1]
;Return [SPL_Get_Insert_Object] as Insert Object Not Found	;In case of [0][5]
;Start over from [start_get_insert_object]			;In case of [10][11][12][13]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	mov esi,insert_object_address	;[esi] - already contains error address
;	add esi,address_increment

xchg eax,ebx
mov eax,18		;Insert Object end. Error in word insert [Error code]
cmp ebx,1
jne end_get_insert_object
xchg eax,ebx

;mov eax,18		;Insert Object end. Error in word insert [Error code]
mov edx,address_increment
add edx,ecx
	;inc edx
cmp edx,insert_object_length
ja end_get_insert_object
mov address_increment,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA  ;2
operation_type_5	dd 3	;3 - Get Delimiter Operator;0 - Check Word Operator;1 - Check Delimiter Operator;2 - Get Word Operator
word_start_address_5	dd 0 ;offset word_in_delimiters_file_5
word_length_5		dd 4
word_in_delimiters_file_5	dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,insert_object_address;
	add eax,address_increment
push eax ;offset insert_object			 ;eax		;offset scan_string_address		;ebp+36
push offset insert_object_length	;offset scan_string_length		;ebp+32
push offset operation_type_5		;ebp+28
push offset word_start_address_5		;ebp+24
push offset word_length_5			;ebp+20
call SPL_Process_One_Float_Operator
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	mov esi,insert_object_address
;	add esi,address_increment

xchg eax,edx

mov eax,20			;Insert Object end. Object name in delimiters defined no correct [Error code]
cmp edx,1	
jne end_get_insert_object
xchg eax,edx

xor eax,eax			;String end reached [Insert Object Not Found] 
mov edx,address_increment
add edx,ecx
cmp edx,insert_object_length
ja end_get_insert_object
mov address_increment,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,21		;Insert object start and end object names are not similar [Error code]
mov ebx,word_length_2
cmp ebx,word_length_5
jne end_get_insert_object

xor eax,eax

;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,word_start_address_2
mov ebx,word_start_address_5
mov ecx,word_length_2

;;SV_compare_string eax, ebx, ecx
push ecx	;compare_length		;ebp+24
push ebx	;Second_string		;ebp+20
push eax	;First_string		;ebp+16
call Compare_String

	mov esi,insert_object_address
	add esi,address_increment

xchg eax,ebx
mov eax,21		;Insert object start and end object names are not similar [Error code]
cmp ebx,0
je end_get_insert_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
operation_type_6	dd 0	;;0 - Check Word Operator;1 - Check Delimiter Operator;2 - Get Word Operator;3 - Get Delimiter Operator
word_start_address_6	dd offset word_insert_6
word_length_6		dd 3
word_insert_6		db 'End',0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,insert_object_address
	add eax,address_increment
push eax ;offset insert_object			 ;eax		;offset scan_string_address		;ebp+36
push offset insert_object_length	;offset scan_string_length		;ebp+32
push offset operation_type_6		;ebp+28
push offset word_start_address_6		;ebp+24
push offset word_length_6			;ebp+20
call SPL_Process_One_Float_Operator
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Normal execution
;[eax] - Any other value is error code [0][5][10][11][12][13]
	;[esi] - error address
	;[ecx] - address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	mov esi,insert_object_address
;	add esi,address_increment
xchg eax,edx

mov eax,22			;Insert Object end. End word is not defined correct [Error code]
cmp edx,1	
jne end_get_insert_object
xchg eax,edx

mov eax,23			;Unexpected end after word --> end [Insert Object end][Error code] 
mov edx,address_increment
add edx,ecx
cmp edx,insert_object_length
ja end_get_insert_object
mov address_increment,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,insert_object_address
add eax,address_increment
mov ebx,insert_object_length
sub ebx,address_increment

;;SV_Escape_Separators SPL_022, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

	mov esi,insert_object_address
	add esi,address_increment

xchg eax,ecx
mov eax,17			;Unexpected end after extension definition [Error code]
cmp ecx,1
jne end_get_insert_object
add address_increment,ebx
xchg eax,ecx

mov eax,24			;] Expected in Insert Object end 
mov ecx,insert_object_address
add ecx,address_increment
cmp byte ptr [ecx],']'		;Check ]   ;; [ Insert "File" Start ]
jne end_get_insert_object

mov eax,23			;[ Expected in Insert Object end 
mov ebx,address_increment
inc ebx
cmp ebx,insert_object_length
ja end_get_insert_object
mov address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sub ecx,replace_object_start_address
inc ecx
mov replace_object_length,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,dword ptr [ebp+20]
mov ebx,replace_object_start_address
mov dword ptr [eax],ebx

mov ecx,dword ptr [ebp+16]
mov edx,replace_object_length
mov dword ptr [ecx],edx

;push offset replace_start_address	;ebp+20
;push offset replace_length	;ebp+16
;replace_object_start_address	dd 0
;replace_object_length		dd 0

mov eax,1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,file_name_start_address
mov ecx,file_name_length
mov dl,byte ptr file_name_type	;[ 0 - direct word in delimiters ][ 1 - label ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov edi,extension_start_address
mov ebx,extension_length
mov dh,byte ptr extension_type	;[ 0 - direct word in delimiters ][ 1 - label ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

end_get_insert_object:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Insert Object Normal Get
;[eax] - any other value is error code
;[esi] - file name start address	;[or error address when error occurs]
	;[ecx] - file name length
	;[dl] - file name type	[ 0 - direct word in delimiters][ 1 - label ] 
;[edi] - extension start address
	;[ebx] - extension name length
	;[dh] - extension type	[ 0 - direct word in delimiters][ 1 - label ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


mov esp,ebp
pop ebp
ret 16
SPL_Get_Insert_Object endp

endm

