SPL_Standard_Functions_4 macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push file_names_start_address			;ebp+20
;push file_names_length				;ebp+16
;push insert_object_string_address		;ebp+12
;push insert_object_string_length		;ebp+8
;call Process_Insert_Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Process_Insert_Object proc	;Process Object will insert data direct into the specified string
push ebp
mov ebp,esp

mov eax,dword ptr [ebp+8]
mov i_o_string_length,eax
mov ebx,dword ptr [ebp+12]
mov i_o_string_address,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
i_o_string_length		dd 0
i_o_string_address		dd 0

io_file_name_type		dd 0
insert_object_file_name		dd 100 dup (0)		;400 byte
insert_object_file_name_length	dd 0
io_extension_object_type	dd 0
insert_object_extension		dd 100 dup (0)
insert_object_extension_length	dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
replace_start_address		dd 0
replace_length			dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
insert_objects_count		dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE

mov insert_objects_count,0

start_process_insert_object:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset data 
xor eax,eax
mov ecx,100		;400
mov edi,offset insert_object_file_name
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Reset data
cld
xor eax,eax
mov ecx,100		;400
mov edi,offset insert_object_extension
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Reset data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Reset data
mov io_file_name_type,0
mov io_extension_object_type,0
mov io_file_name_type,0
mov io_extension_object_type,0
mov insert_object_file_name_length,0
mov insert_object_extension_length,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov replace_start_address,0
mov replace_length,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset data

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Insert Object
mov eax,i_o_string_address		;offset insert_object	
mov ebx,i_o_string_length		;insert_object_string_length		;ebp+8

push offset replace_start_address
push offset replace_length
push eax				;insert_object_address
push ebx				;insert_object_length
call SPL_Get_Insert_Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;[eax] - 1 - Insert Object Normal Get	;Replace object
;[eax] - 0 - Insert Object Not Found	;Go to end with [eax] - 0 - Insert Object Not Found
;[eax] - 5 - Insert Object Not Found 	;Go to end with [eax] - 5 - Insert Object Not Found

;[eax] - any other value is Insert_object_error	;Go to end with obtained [eax] and [esi]
;[esi] - error address

cmp eax,0
je end_process_insert_object
cmp eax,5
je end_process_insert_object

cmp eax,1
jne no_replace_insert_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Insert Object Normal Get
;[eax] - any other value is error code
;[esi] - file name start address	;[or error address when error occurs]
	;[ecx] - file name length
	;[dl] - file name type	[ 0 - direct word in delimiters][ 1 - label ] 
;[edi] - extension start address
	;[ebx] - extension name length
	;[dh] - extension type	[ 0 - direct word in delimiters][ 1 - label ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Sent results to Structure
mov byte ptr io_file_name_type,dl
mov byte ptr io_extension_object_type,dh
mov insert_object_file_name_length,ecx
mov insert_object_extension_length,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		push ebx
cmp dl,0
	push edx
sete al
ror eax,1
cdq
xor eax,eax
mov ebx,25		;Filename too large [Error code]
and ebx,edx
add eax,ebx
	pop edx
	push eax
	push edx
cmp dl,1
sete al
ror eax,1
cdq
xor eax,eax
mov ebx,27		;Filename Label Too large [Error code]
and ebx,edx
add eax,ebx
	pop ebx
add eax,ebx
	pop edx
		pop ebx

cmp ecx,400	;Filename		;[esi] - already contain error address [Error code]
jae end_process_insert_object
;[eax] - 25 - FileName too large [above then 400 byte]
;[eax] - 27 - FileName label too large
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		push ebx
cmp dh,0
	push edx
sete al
ror eax,1
cdq
xor eax,eax
mov ebx,26		;Extension too large [Error code]
and ebx,edx
add eax,ebx
	pop edx
	push eax
cmp dh,1
sete al
ror eax,1
cdq
xor eax,eax
mov ebx,28		;Extension label too large [Error code]
and ebx,edx
add eax,ebx
	pop ebx
add eax,ebx
	pop ebx
cmp ebx,400	;Extension 	;[esi] - already contain error address [Error code]
jae end_process_insert_object
;[eax] - 25 - FileName too large [above then 400 byte]
;[eax] - 27 - FileName label too large
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push esi
push edi
cld
;;;;;;;;;mov esi,file name start address
mov edi,offset insert_object_file_name
rep movsb 

pop edi
pop esi

mov ecx,ebx
mov esi,edi
mov edi,offset insert_object_extension	

cld
rep movsb 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Insert Object
inc insert_objects_count

cmp io_file_name_type,0	;[ 0 - direct word in delimiters][ 1 - label ] 
je no_file_name_label	;[If 1 [label] then Replace with true file name

;insert_object_file_name		dd 100 dup (0)		;400 byte
;insert_object_file_name_length	dd 0

mov eax,insert_object_file_name_length

push dword ptr [ebp+20] ;offset object_from_label	;object_string_address	;ebp+36
push dword ptr [ebp+16]		;264		;object_string_length	;ebp+32
push offset insert_object_file_name	;label		;ebp+28
push eax	;5 ;label_length		;ebp+244
call SPL_Get_Object_From_Label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SPL_Get_Object_From_Label 
;;	 [00176 = "....................." ]
;;	 [00176 = '.....................' ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Object from label find [Success]
;[EAX] - 0 Object from label not find [Error]
;[EAX] - Any other value[False][Error code]
	;[ESI] - Object start address
	;[ECX] - Object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xchg eax,ebx			;[esi] - already contain error address [Error code]
mov eax,29			;Specified file name label not found [Error code]
cmp ebx,0
je end_process_insert_object
;;;;;;;;;;;;;;;;;;;If ebx >1 then add ebx,40
cmp ebx,1
seta al
ror eax,1
cdq
mov edi,40		;[Error code group 42 45 47 48 49 ]
and edi,edx
add ebx,edi
;;;;;;;;;;;;;;;;;;;
xchg eax,ebx
cmp eax,1
ja end_process_insert_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ESI] - Object start address
;[ECX] - Object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			;[esi] - already contain error address [Error code]
mov eax,25		;Filename too large [Error code]
cmp ecx,400		;FileName Limit 400 byte
jae end_process_insert_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start send found true FileName
mov insert_object_file_name_length,ecx

;;[ESI] - Object start address
mov edi,offset insert_object_file_name
rep movsb 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End send found true FileName
xor eax,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
no_file_name_label:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp io_extension_object_type,0	;Check IF Extension label [1 - Label][0 - No label [direct word] ]
je no_extension_label

mov eax,insert_object_extension_length

;insert_object_extension		dd 100 dup (0)
;insert_object_extension_length	dd 0

push dword ptr [ebp+20] ;offset object_from_label	;object_string_address	;ebp+36
push dword ptr [ebp+16]		;264		;object_string_length	;ebp+32
push offset insert_object_extension	;label		;ebp+28
push eax	;5 ;label_length		;ebp+244
call SPL_Get_Object_From_Label				;Get True Extension which corresponds to the extension specified label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SPL_Get_Object_From_Label 
;;	 [00176 = "....................." ]
;;	 [00176 = '.....................' ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Object from label find [Success]
;[EAX] - 0 Object from label not find [Error]
;[EAX] - Any other value[False][Error code]
	;[ESI] - Object start address	;or error address 
	;[ECX] - Object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xchg eax,ebx
mov eax,30			;Specified Extension label not found [Error code]
cmp ebx,0
je end_process_insert_object
;;;;;;;;;;;;;;;;;;;If ebx >1 then add ebx,50
cmp ebx,1
seta al
ror eax,1
cdq
mov edi,50		;[Error code group 52 55 57 58 59 ]
and edi,edx
add ebx,edi
;;;;;;;;;;;;;;;;;;;
xchg eax,ebx
cmp eax,1
ja end_process_insert_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ESI] - Object start address
;[ECX] - Object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,26		;Extension too large [Error code]
cmp ecx,400		;Extension Limit 400 byte
jae end_process_insert_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start send found true FileName
mov insert_object_extension_length,ecx
;;[ESI] - Object start address
mov edi,offset insert_object_extension
rep movsb 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End send found true FileName
mov eax,1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
no_extension_label:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Change Extension
cmp insert_object_file_name_length,0
je end_change_extension

;SV_find_byte_back macro scan_string, find_byte, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found	
	;;;[ecx] = length of string	
	;;;[esi] address of found byte ;[esi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	xor ecx,ecx
mov eax,offset insert_object_file_name
mov ebx,insert_object_file_name_length
add eax,ebx
	mov cl,'.'		;Find Extension Separator
dec eax
;;;;SV_find_byte_back  eax, cl, ebx

push ebx	;string_length	;ebp+20
push ecx	;find_byte		;ebp+16
push eax	;scan_string	;ebp+12
call Find_Byte_Back


;IF [eax] = 1 byte Found	then extension address --> [esi]
;IF [eax] = 0 byte Not Found	then extension address --> offset insert_object_file_name + insert_object_file_name_length

	mov ebx,offset insert_object_file_name
cmp eax,1
sete al
ror eax,1
cdq 
	add ebx,insert_object_file_name_length
and esi,edx
not edx
and ebx,edx
add esi,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[esi] - contains extension change address 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sub esi,offset insert_object_file_name

xchg esi,edi
	mov esi,offset insert_object_file_name	;Set [esi] to error address
mov eax,31			;Full file name too large [Cannot change extension][Error code]
mov ebx,edi
add ebx,insert_object_extension_length

inc ebx
cmp ebx,400			;Full file name limit [400 byte]
jae end_process_insert_object

cmp insert_object_extension_length,0
je end_change_extension

mov insert_object_file_name_length,ebx	;Set New Length of file name after extension change

xchg esi,edi

add esi,offset insert_object_file_name

xchg esi,edi
mov ecx,insert_object_extension_length
mov esi,offset insert_object_extension
mov byte ptr [edi],'.'
inc edi

cld
rep movsb
;;;;;;;;;;;;;;;;;;;;;;Start Delete Remained end	;[Delete remained end of the extension]
mov eax,insert_object_file_name_length
add eax,offset insert_object_file_name
mov byte ptr [eax],0
;;;;;;;;;;;;;;;;;;;;;;End Delete Remained end

end_change_extension:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Change Extension

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Replace 
mov eax,replace_length
cmp insert_object_file_name_length,eax  ;[IF insert_object_file_name_length < replace_length]
ja no_below_or_equal		;jump if above
;;;; ...................[--------------]..................
;;;;;;;			 ............ 
;;;;;;;				     |-|
;;;;				    Absolute substraction --> 7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Correct string
mov ecx,replace_start_address
sub ecx,i_o_string_address

mov edi,i_o_string_length
sub edi,ecx
sub edi,replace_length

mov ecx,edi

mov edi,replace_start_address
add edi,insert_object_file_name_length

mov esi,replace_start_address
add esi,replace_length

cld
rep movsb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Correct string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Remaining bytes
mov eax,replace_length			;55
sub eax,insert_object_file_name_length	;20
					;35
mov ecx,eax

mov edi,i_o_string_length		;68
sub edi,eax			;68 - 35 = 33	;in [esi] - new length of string 
add edi,i_o_string_address

xor eax,eax
cld
rep stosb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Replace with file name
mov ecx,insert_object_file_name_length
mov edi,replace_start_address
cld
mov esi,offset insert_object_file_name
rep movsb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Replace with file name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set new scan address
;;;set new
;;;mov eax,i_o_string_address
;;;mov ebx,i_o_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; ...................[--------------]..................
;;;; |<-------[ecx]---->|..........    |<--------------->|
;;;; |			|<------->|<-->|		 |
;;;; |<------------------------------------------------->|
;;;;;;;			i_o_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ecx,replace_length
sub ecx,insert_object_file_name_length
mov eax,i_o_string_length
sub eax,ecx
mov i_o_string_length,eax	;New string length

mov ecx,replace_start_address
add ecx,insert_object_file_name_length
mov i_o_string_address,ecx	;New scan address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End set new scan address
jmp start_process_insert_object
no_below_or_equal:

mov eax,replace_length
cmp insert_object_file_name_length,eax  ;[IF insert_object_file_name_length > replace_length ]
jbe no_above		;jump if below
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; ...................[--------------]..................
;;;; |<-------[ecx]---->|...................|<---------->|
;;;; |			|<------------>|<-->|		 |
;;;; |<-----------------i_o_string_length--------------->|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,32				;Filename Too large. Cannot Replace filename [Error code]
mov ebx,insert_object_file_name_length

sub ebx,replace_length
add ebx,i_o_string_length
cmp ebx,400			;Insert Object String Limit
jae end_process_insert_object
xor eax,eax

;[ebx] - string new size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Correct string
add ebx,i_o_string_address

mov edi,ebx		;Destination
dec edi

mov ecx,replace_start_address
sub ecx,i_o_string_address

mov edx,i_o_string_length	;80
sub edx,replace_length		;55

sub edx,ecx

xchg ecx,edx		;Set count of copy bytes

mov esi,i_o_string_address
add esi,i_o_string_length
dec esi

std
rep movsb
cld
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Correct string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Replace with file name
mov ecx,insert_object_file_name_length
mov edi,replace_start_address
cld
mov esi,offset insert_object_file_name
rep movsb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Replace with file name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set new scan address
;set new
;i_o_string_address
;i_o_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; ...................[--------------]..................
;;;; |<-------[ecx]---->|...................|<---------->|
;;;; |			|<------------>|<-->|		 |
;;;; |<-----------------i_o_string_length--------------->|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ecx,replace_start_address
add ecx,insert_object_file_name_length	;New scan address
mov i_o_string_address,ecx

mov eax,insert_object_file_name_length
sub eax,replace_length
add eax,i_o_string_length		;in [eax] - new string length
mov i_o_string_length,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End set new scan address
jmp start_process_insert_object
no_above:

xor eax,eax
nop
nop
nop
no_replace_insert_object:

end_process_insert_object:

mov ebx,insert_objects_count

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Insert Object Not Found
;[eax] - 5 - Insert Object Not Found [string end reached while search Insert Object]
;[eax] - 1 - Insert Object Found and Replaced
;[eax] - any other value - error code
	;[esi] - error address
	;[ebx] - Insert Objects Count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 16
Process_Insert_Object endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Output_Type	proc
;;;Using example
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset output_scan_string		;[ebp+12]
;push output_scan_string_length		;[ebp+8]
;call Get_Output_Type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[Output:STDOUT/STDERR ]
;[Output:STDERR/STDOUT ]
;[Output: None ]
;[Output: ]		;None
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]
mov output_scan_string_length,eax
mov ebx,dword ptr [ebp+12]
mov output_scan_string_address,ebx

.DATA
output_scan_string_address	dd 0
output_scan_string_length	dd 0
output_address_increment	dd 0

stdout_output			dd 0	;0 - no output  1 - output
stderr_output			dd 0	;0 - no output  1 - output

GOT_output_word			db 'Output:', 0
STDOUT_word			db 'STDOUT', 0, 0
STDERR_word			db 'STDERR', 0, 0
None_word			db 'None', 0, 0, 0, 0

.CODE

mov output_address_increment,0
mov stdout_output,0
mov stderr_output,0

mov esi,output_scan_string_address
mov eax,33				;String end reached before get [ [Error code]
cmp output_scan_string_length,0
je end_get_output_type

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,output_scan_string_address
mov ebx,output_scan_string_length

;;SV_Escape_Separators SPL_023, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,33				;String end reached while get output type
cmp ecx,1
jne end_get_output_type

mov output_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,34				; [ Expected in output object [Error code]
	mov esi,output_scan_string_address
	add esi,output_address_increment
cmp byte ptr [esi],'['
jne end_get_output_type

mov eax,35				;String end reached after [  .  [Error code]
mov ecx,output_address_increment
inc ecx
cmp ecx,output_scan_string_length
ja end_get_output_type

inc output_address_increment	;jump over to [
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,output_scan_string_address
add eax,output_address_increment

mov ebx,output_scan_string_length
sub ebx,output_address_increment

;;SV_Escape_Separators SPL_024, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,35				;String end reached after [  .  [Error code]
cmp ecx,1
jne end_get_output_type

add output_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Get_Word macro word_index, scan_string, scan_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Word found  
;[EAX] - 0 Word found, but string end reached
	;[ESI] - Word start address
	;[ECX] - Word length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,output_scan_string_address
	add esi,output_address_increment

mov eax,36			;Unexpected end before get Output: word [Error code]
mov ebx,output_address_increment
add ebx,7
cmp ebx,output_scan_string_length
ja end_get_output_type

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,offset GOT_output_word
mov ecx,7

;;SV_compare_string esi, eax, ecx
push ecx	;compare_length		;ebp+24
push eax	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String


	mov esi,output_scan_string_address
	add esi,output_address_increment
xchg eax,ebx
mov eax,38			;Word must be 'Output' [Error code]
cmp ebx,0
je end_get_output_type

mov eax,39			;String end reached after word output
mov ebx,output_address_increment
add ebx,7
cmp ebx,output_scan_string_length
ja end_get_output_type

add output_address_increment,7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,output_scan_string_address
add eax,output_address_increment

mov ebx,output_scan_string_length
sub ebx,output_address_increment

;;SV_Escape_Separators SPL_025, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,37 				;Unexpected end after word Output: [Error code]
cmp ecx,1
jne end_get_output_type

add output_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check First Output Type
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,40			;Unexpected end after word output[No output specified][Error code]
mov edi,output_address_increment
add edi,4
cmp edi,output_scan_string_length
ja end_get_output_type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check if None

mov edi,offset None_word

mov esi,output_scan_string_address
add esi,output_address_increment
mov ecx,4

;;SV_compare_string esi, edi, ecx		;Check if None

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

cmp eax,0
je no_output_none

mov stdout_output,0
mov stderr_output,0
add output_address_increment,4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,output_scan_string_address
add eax,output_address_increment

mov ebx,output_scan_string_length
sub ebx,output_address_increment

;;SV_Escape_Separators SPL_026, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,41				;Unexpected end after word 'None' [Error code]
cmp ecx,1
jne end_get_output_type

mov eax,41				;Unexpected end after word 'None' [Error code]
add ebx,output_address_increment
inc ebx
cmp ebx,output_scan_string_length
ja end_get_output_type

dec ebx
mov output_address_increment,ebx

add ebx,output_scan_string_address

mov eax,43				;] Expected after word 'None' [Error code]
cmp byte ptr [ebx],']'
jne end_get_output_type

inc output_address_increment

;output_address_increment	dd 0
;stdout_output			dd 0	;0 - no output  1 - output
;stderr_output			dd 0	;0 - no output  1 - output
	;[ebx] - 1 - STDOUT	0 - No STDOUT
	;[ecx] - 1 - STDERR	0 - No STDERR
	;[esi] - error address
	;[edx] - address increment

mov ebx,stdout_output
mov ecx,stderr_output
mov edx,output_address_increment

mov eax,1
jmp end_get_output_type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
no_output_none:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check if None

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check if STDOUT
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,44			;Unexpected end while get first output type [No output specified][Error code]
mov edi,output_address_increment
add edi,6
cmp edi,output_scan_string_length
ja end_get_output_type

mov edi,offset STDOUT_word

mov esi,output_scan_string_address
add esi,output_address_increment
mov ecx,6

;;;SV_compare_string esi, edi, ecx		;Check if None

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

cmp eax,0
je no_stdout
mov stdout_output,1		;Set STDOUT as valid
add output_address_increment,6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,output_scan_string_address
add eax,output_address_increment

mov ebx,output_scan_string_length
sub ebx,output_address_increment

;;SV_Escape_Separators SPL_027, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
mov eax,64				;Unexpected end after word 'STDOUT' [Error code]
	mov esi,output_scan_string_address
	add esi,output_address_increment
cmp ecx,1
jne end_get_output_type

mov eax,64				;Unexpected end after word 'STDOUT' [Error code]
add ebx,output_address_increment
inc ebx
cmp ebx,output_scan_string_length
ja end_get_output_type

dec ebx
mov output_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check if any else output types are specified
mov esi,output_scan_string_address
add esi,output_address_increment
cmp byte ptr [esi],'/'
jne no_else_output

inc output_address_increment

mov eax,output_scan_string_address
add eax,output_address_increment

mov ebx,output_scan_string_length
sub ebx,output_address_increment

;;SV_Escape_Separators SPL_028, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,output_scan_string_address
	add esi,output_address_increment

mov eax,46				;Unexpected end after '/' [Error code]
cmp ecx,1
jne end_get_output_type

mov eax,46				;Unexpected end after '/' [Error code]
add ebx,output_address_increment
inc ebx
cmp ebx,output_scan_string_length
ja end_get_output_type

dec ebx
mov output_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check if STDERR
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,50			;Unexpected end after word '/' [Error code]
mov edi,output_address_increment
add edi,6
cmp edi,output_scan_string_length
ja end_get_output_type

mov edi,offset STDERR_word

mov esi,output_scan_string_address
add esi,output_address_increment
mov ecx,6

;;SV_compare_string esi, edi, ecx		;Check if None

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

xchg eax,ebx
mov eax,51			;Specified output type after STDOUT is not STDERR [Error code]
cmp ebx,0
je end_get_output_type
mov stderr_output,1		;Set STDOUT as valid
add output_address_increment,6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check if STDERR
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check if any else output types are specified
no_else_output:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check End of output object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,output_scan_string_address
add eax,output_address_increment

mov ebx,output_scan_string_length
sub ebx,output_address_increment

;;SV_Escape_Separators SPL_029, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,54				;Unexpected end in output object [Error code]
cmp ecx,1
jne end_get_output_type

mov eax,54				;Unexpected end in output object [Error code]
add ebx,output_address_increment
inc ebx
cmp ebx,output_scan_string_length
ja end_get_output_type

dec ebx
mov output_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check if any else output types are specified

mov eax,53				; ] Expected in output object [Error code]
	mov esi,output_scan_string_address
	add esi,output_address_increment
cmp byte ptr [esi],']'
jne end_get_output_type
inc output_address_increment

mov eax,1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check End of output object
;output_address_increment	dd 0
;stdout_output			dd 0	;0 - no output  1 - output
;stderr_output			dd 0	;0 - no output  1 - output
	;[ebx] - 1 - STDOUT	0 - No STDOUT
	;[ecx] - 1 - STDERR	0 - No STDERR
	;[esi] - error address
	;[edx] - address increment
mov ebx,stdout_output
mov ecx,stderr_output
mov edx,output_address_increment

jmp end_get_output_type
no_stdout:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check if STDOUT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check if STDERR
	mov esi,output_scan_string_address;
	add esi,output_address_increment
mov eax,44			;Unexpected end after word output[No output specified][Error code]
mov edi,output_address_increment
add edi,6
cmp edi,output_scan_string_length
ja end_get_output_type			;Can be absent because it present in STDOUT check

mov edi,offset STDERR_word

mov esi,output_scan_string_address
add esi,output_address_increment
mov ecx,6

;;SV_compare_string esi, edi, ecx		;Check if STDERR
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

cmp eax,0
je no_stderr
mov stderr_output,1		;Set STDERR as valid
add output_address_increment,6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,output_scan_string_address
add eax,output_address_increment

mov ebx,output_scan_string_length
sub ebx,output_address_increment

;;SV_Escape_Separators SPL_033, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,59
cmp ecx,1
jne end_get_output_type

mov eax,59				;Unexpected end after word 'STDERR' [Error code]
add ebx,output_address_increment
inc ebx
cmp ebx,output_scan_string_length
ja end_get_output_type

dec ebx
mov output_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check if any else output types are specified
mov esi,output_scan_string_address
add esi,output_address_increment
cmp byte ptr [esi],'/'
jne no_else_output_in_stderr

inc output_address_increment

mov eax,output_scan_string_address
add eax,output_address_increment

mov ebx,output_scan_string_length
sub ebx,output_address_increment

;;SV_Escape_Separators SPL_034, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,60				;Unexpected end after '/' [Error code]
cmp ecx,1
jne end_get_output_type

mov eax,60				;Unexpected end after '/' [Error code]
add ebx,output_address_increment
inc ebx
cmp ebx,output_scan_string_length
ja end_get_output_type

dec ebx
mov output_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check if STDERR
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,60			;Unexpected end after word '/' [Error code]
mov edi,output_address_increment
add edi,6
cmp edi,output_scan_string_length
ja end_get_output_type

mov edi,offset STDOUT_word

mov esi,output_scan_string_address
add esi,output_address_increment
mov ecx,6

;;;SV_compare_string esi, edi, ecx		
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String


xchg eax,ebx
mov eax,61			;Specified output type after STDERR is not STDOUT [Error code]
cmp ebx,0
je end_get_output_type
mov stdout_output,1		;Set STDOUT as valid
add output_address_increment,6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check if STDERR
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check if any else output types are specified
no_else_output_in_stderr:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check End of output object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,output_scan_string_address
add eax,output_address_increment

mov ebx,output_scan_string_length
sub ebx,output_address_increment

;;SV_Escape_Separators SPL_035, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,output_scan_string_address
	add esi,output_address_increment
mov eax,62				;Unexpected end in output object [Error code]
cmp ecx,1
jne end_get_output_type

mov eax,62				;Unexpected end in output object [Error code]
add ebx,output_address_increment
inc ebx
cmp ebx,output_scan_string_length
ja end_get_output_type

dec ebx
mov output_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check if any else output types are specified except STDERR

mov eax,53				; ] Expected in output object [Error code]
	mov esi,output_scan_string_address
	add esi,output_address_increment
cmp byte ptr [esi],']'
jne end_get_output_type
inc output_address_increment

mov eax,1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check End of output object
;output_address_increment	dd 0
;stdout_output			dd 0	;0 - no output  1 - output
;stderr_output			dd 0	;0 - no output  1 - output
	;[ebx] - 1 - STDOUT	0 - No STDOUT
	;[ecx] - 1 - STDERR	0 - No STDERR
	;[esi] - error address
	;[edx] - address increment
mov ebx,stdout_output
mov ecx,stderr_output
mov edx,output_address_increment

jmp end_get_output_type
no_stderr:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check if STDERR
	mov esi,output_scan_string_address
	add esi,output_address_increment

mov eax,56			;Cannot Determine output type [Error code]
end_get_output_type:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Output Type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 output type normal get
;[eax] - any other value is error code
	;[ebx] - 1 - STDOUT	0 - No STDOUT
	;[ecx] - 1 - STDERR	0 - No STDERR
	;[esi] - error address
	;[edx] - address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
Get_Output_Type	endp

endm
