;Lock Function	After the function locked access to function can be obtained only 
;		when [Call locked function].
;Unlock function	After the function unlocked, access to function can be obtained only ;
;		when [Call unlocked function].
;Call locked function	Used when function is locked. Causes an error when function is
;		unlocked. 
;		[Not standard call. Used for high priority operations]
;Call unlocked function	Used when function is unlocked. Causes an error when function is
;		locked. [Standard call. Used for standard operations]
;	
;	All these type of functions have [SCL] prefix.
;

;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
standard_sync_header macro  busy_flag, end_point
.DATA
busy_flag	dd 0	;0 - no busy ; 1 -  busy
.CODE
;mov eax,(-1)
;cmp busy_flag,1
;je end_point
;mov busy_flag,1


mov eax,0
mov ebx,(-1)
cmpxchg busy_flag,ebx
mov eax,(-1)
jnz end_point		;Jump if ZF is 1 [ IF operands are not equal ]


;IF [Destination]  = [eax] then [Destination] <-- [Source]	;[ZF] = 1
;IF [Destination] <> [eax] then [eax] <-- [Destination]		;[ZF] = 0

;Source in register
;Destination in register or memory 
;[eax]

;If the values in the destination operand and the
;accumulator are equal, the destination operand is replaced with the source operand.
;Otherwise, the original value of the destination operand is loaded into the accumulator. The
;flags reflect the result which would have been obtained by subtracting the destination
;operand from the accumulator. The ZF flag is set if the values in the destination operand and
;the accumulator were equal, otherwise it is cleared.




endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
.DATA
lock_flag	dd 0	;0 - free ;1 - locked
operation_type	dd 0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start unlock function
;IF dword ptr [ebp+8] = 2  and  mouse_botton_down_lock = 1 Then mouse_botton_down_lock = 0
;IF dword ptr [ebp+8] = 2  and  mouse_botton_down_lock = 0 Then mouse_botton_down_lock = 0

mov eax,(-3)			;Function unlocked  [Result code]
mov ecx,operation_type
xor ebx,ebx
cmp ecx,2		;unlock function
jne no_unlock_mouse&IND
mov lock_flag,0		;Unlock function

jmp lock_point
no_unlock_mouse&IND:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End unlock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start lock function
;IF dword ptr [ebp+8] = 3  and  mouse_botton_down_lock = 0 Then mouse_botton_down_lock = 1
;IF dword ptr [ebp+8] = 3  and  mouse_botton_down_lock = 1 Then mouse_botton_down_lock = 1

mov eax,(-2)			;Function locked  [Result code]
mov ecx,operation_type
xor ebx,ebx
cmp ecx,3		;unlock function
jne no_lock_mouse&IND
mov lock_flag,1		;Lock function

jmp lock_point
no_lock_mouse&IND:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check Free call 
;IF dword ptr [ebp+8] = 0  and  mouse_botton_down_lock = 1 Then [eax] = (-2) and go to end

mov eax,(-2)			;Function locked [Result code]
xor ebx,ebx
mov ecx,operation_type
cmp ecx,0
sete bl

xor edx,edx
mov ecx,lock_flag
cmp ecx,1
sete dl

and edx,ebx
cmp edx,1
je lock_point
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check Free call 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check Locked call 
;;IF dword ptr [ebp+8] = 1  and  mouse_botton_down_lock = 0 Then [eax] = (-3) and go to end

mov eax,(-3)			;Function unlocked [Result code]
xor ebx,ebx
mov ecx,operation_type
cmp ecx,1
sete bl

xor edx,edx
mov ecx,lock_flag
cmp ecx,0
sete dl

and edx,ebx
cmp edx,1
je lock_point
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check Locked call 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




endm


standard_sync_lock_footer macro busy_flag, lock_point, end_point

lock_point:
mov eax,0
mov busy_flag,0
end_point:


endm


; Named Call












