system_text macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push shell_execute_SSE code		;ebp+8
;call Get_Shell_Execute_Error_Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Shell_Execute_Error_Text proc
push ebp
mov ebp,esp

mov ecx,dword ptr [ebp]+8
cmp ecx,32
jbe no_above_sh_SSE_code 
mov eax,offset sh_out_SSE
mov ebx,76
jmp end_get_sh_SSE_text
no_above_sh_SSE_code:

mov ecx,dword ptr [ebp]+8
rol ecx,3	; mul 8
add ecx,offset shell_execute_SSEs
mov eax,dword ptr [ecx]
mov ebx,dword ptr [ecx]+4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - SSE text address
;[ebx] - SSE text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
shell_execute_SSEs	dd offset SHE_000,		51	;0
			dd offset invalid_SSE_code,	61	;1
			dd offset SHE_002,		33	;2
			dd offset SHE_003,		33	;3
			dd offset invalid_SSE_code,	61	;4
			dd offset SHE_005,		57	;5
			dd offset invalid_SSE_code,	61	;6
			dd offset invalid_SSE_code,	61	;7
			dd offset SHE_008,		54	;8
			dd offset invalid_SSE_code,	61	;9
			dd offset invalid_SSE_code,	61	;10
			dd offset SHE_011,		65	;11
			dd offset invalid_SSE_code,	61	;12
			dd offset invalid_SSE_code,	61	;13
			dd offset invalid_SSE_code,	61	;14
			dd offset invalid_SSE_code,	61	;15
			dd offset invalid_SSE_code,	61	;16
			dd offset invalid_SSE_code,	61	;17
			dd offset invalid_SSE_code,	61	;18
			dd offset invalid_SSE_code,	61	;19
			dd offset invalid_SSE_code,	61	;20
			dd offset invalid_SSE_code,	61	;21
			dd offset invalid_SSE_code,	61	;22
			dd offset invalid_SSE_code,	61	;23
			dd offset invalid_SSE_code,	61	;24
			dd offset invalid_SSE_code,	61	;25
			dd offset SHE_026,		29	;26
			dd offset SHE_027,		50	;27
			dd offset SHE_028,		73	;28
			dd offset SHE_029,		27	;29
			dd offset SHE_030,		95	;30
			dd offset SHE_031,		69	;31
			dd offset SHE_032,		49	;32

SHE_000			db 'The operating system is out of memory or resources.',0 				;0	
SHE_002			db 'The specified file was not found.',0 						;2	
SHE_003			db 'The specified path was not found.',0						;3	
SHE_005			db 'The operating system denied access to the specified file.',0			;5	
SHE_008			db 'There was not enough memory to complete the operation.',0 				;8	
SHE_011			db 'The .EXE file is invalid (non-Win32 .EXE or error in .EXE image).',0 		;11	
SHE_026			db 'A sharing violation occurred.',0							;26
SHE_027			db 'The filename association is incomplete or invalid.',0				;27
SHE_028			db 'The DDE transaction could not be completed because the request timed out.',0	;28
SHE_029			db 'The DDE transaction failed.',0							;29
SHE_030			db 'The DDE transaction could not be completed because other DDE transactions were being processed.',0 ;30
SHE_031			db 'There is no application associated with the given filename extension.',0		;31
SHE_032			db 'The specified dynamic-link library was not found.',0				;32
invalid_SSE_code	db 'The specified error code for ShellExecute function is invalid',0

sh_out_SSE		db 'The specified error code is above then 32. It is not ShellExecute error code',0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE

end_get_sh_SSE_text:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - SSE text address
;[ebx] - SSE text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
Get_Shell_Execute_Error_Text endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push system_SSE code		;ebp+8
;call Get_System_Error_Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_System_Error_Text proc
push ebp
mov ebp,esp

mov ecx,dword ptr [ebp]+8
cmp ecx,299
jbe no_above_st_SSE_code 

mov eax,offset system_out_SSE_code
mov ebx,78
jmp end_get_system_SSE_text

no_above_st_SSE_code:

mov ecx,dword ptr [ebp]+8
rol ecx,3	; mul 8
add ecx,offset standard_system_SSEs
mov eax,dword ptr [ecx]
mov ebx,dword ptr [ecx]+4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - SSE text address
;[ebx] - SSE text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
standard_system_SSEs		dd offset SSE_SUCCESS, 		37	;0
				dd offset SSE_INVALID_FUNCTION, 	19	;1
				dd offset SSE_FILE_NOT_FOUND,		42	;2
				dd offset SSE_PATH_NOT_FOUND,	 	42	;3
				dd offset SSE_TOO_MANY_OPEN_FILES, 	32	;4
				dd offset SSE_ACCESS_DENIED, 		17	;5
				dd offset SSE_INVALID_HANDLE,		22	;6
				dd offset SSE_ARENA_TRASHED, 		42	;7
				dd offset SSE_NOT_ENOUGH_MEMORY,	56	;8
				dd offset SSE_INVALID_BLOCK,	 	45	;9
				dd offset SSE_BAD_ENVIRONMENT,	29	;10
				dd offset SSE_INVALID_ACCESS,		27	;12
				dd offset SSE_INVALID_DATA,		20	;13
				dd offset SSE_OUTOFMEMORY,		59	;14
				dd offset SSE_INVALID_DRIVE,		33	;15
				dd offset SSE_CURRENT_DIRECTORY,	32	;16
				dd offset SSE_NOT_SAME_DEVICE, 	58	;17
				dd offset SSE_NO_MORE_FILES,		24	;18
				dd offset SSE_WRITE_PROTECT, 		29	;19
				dd offset SSE_BAD_UNIT,		44	;20
				dd offset SSE_NOT_READY, 		24	;21
				dd offset SSE_BAD_COMMAND,		42	;22
				dd offset SSE_CRC,			36	;23
				dd offset SSE_BAD_LENGTH,		65	;24
				dd offset SSE_SEEK,			61	;25
				dd offset SSE_NOT_DOS_DISK,		50	;26
				dd offset SSE_SECTOR_NOT_FOUND,	43	;27
				dd offset SSE_OUT_OF_PAPER,		28	;28
				dd offset SSE_WRITE_FAULT,		48	;29
				dd offset SSE_READ_FAULT,		49	;30
				dd offset SSE_GEN_FAILURE,		51	;31
				dd offset SSE_SHARING_VIOLATION,	79	;32
				dd offset SSE_LOCK_VIOLATION,		92	;33
				dd offset SSE_WRONG_DISK,		87	;34
				dd offset SSE_SHARING_BUFFER_EXCEEDED, 34	;35
				dd offset invalid_system_SSE,		25	;36
				dd offset invalid_system_SSE,		25	;37
				dd offset SSE_HANDLE_EOF,		20	;38
				dd offset SSE_HANDLE_DISK_FULL, 	17	;39
				dd offset invalid_system_SSE, 	25	;40
				dd offset invalid_system_SSE, 	25	;41
				dd offset invalid_system_SSE,		25	;42
				dd offset invalid_system_SSE,		25	;43
				dd offset invalid_system_SSE,		25	;44
				dd offset invalid_system_SSE,		25	;45
				dd offset invalid_system_SSE,		25	;46
				dd offset invalid_system_SSE,		25	;47
				dd offset invalid_system_SSE,		25	;48
				dd offset invalid_system_SSE,		25	;49
				dd offset SSE_NOT_SUPPORTED,		37	;50
				dd offset SSE_REM_NOT_LIST,		37	;51
				dd offset SSE_DUP_NAME,		39	;52
				dd offset SSE_BAD_NETPATH,		31	;53
				dd offset SSE_NETWORK_BUSY,		20	;54
				dd offset SSE_DEV_NOT_EXIST,		64	;55
				dd offset SSE_TOO_MANY_CMDS,		48	;56
				dd offset SSE_ADAP_HDW_ERR,		42	;57
				dd offset SSE_BAD_NET_RESP,		60	;58
				dd offset SSE_UNEXP_NET_ERR,		37	;59
				dd offset SSE_BAD_REM_ADAP,		37	;60
				dd offset SSE_PRINTQ_FULL, 		26	;61
				dd offset SSE_NO_SPOOL_SPACE,		77	;62
				dd offset SSE_PRINT_CANCELLED,	44	;63
				dd offset SSE_NETNAME_DELETED, 	50	;64
				dd offset SSE_NETWORK_ACCESS_DENIED,	25	;65
				dd offset SSE_BAD_DEV_TYPE,		41	;66
				dd offset SSE_BAD_NET_NAME,		33	;67
				dd offset SSE_TOO_MANY_NAMES,		72	;68
				dd offset SSE_TOO_MANY_SESS,		44	;69
				dd offset SSE_SHARING_PAUSED,		72	;70
				dd offset SSE_REQ_NOT_ACCEP,		142	;71
				dd offset SSE_REDIR_PAUSED,		53	;72
				dd offset invalid_system_SSE,		25	;73
				dd offset invalid_system_SSE,		25	;74
				dd offset invalid_system_SSE,		25	;75
				dd offset invalid_system_SSE,		25	;76
				dd offset invalid_system_SSE,		25	;77
				dd offset invalid_system_SSE,		25	;78
				dd offset invalid_system_SSE,		25	;79
				dd offset SSE_FILE_EXISTS, 		16	;80
				dd offset invalid_system_SSE,		25	;81
				dd offset SSE_CANNOT_MAKE,		40	;82
				dd offset SSE_FAIL_I24,		14	;83
				dd offset SSE_OUT_OF_STRUCTURES,	49	;84
				dd offset SSE_ALREADY_ASSIGNED,	40	;85
				dd offset SSE_INVALID_PASSWORD,	46	;86
				dd offset SSE_INVALID_PARAMETER,	27	;87
				dd offset SSE_NET_WRITE_FAULT,	38	;88
				dd offset SSE_NO_PROC_SLOTS,		53	;89
				dd offset invalid_system_SSE,		25	;90
				dd offset invalid_system_SSE,		25	;91
				dd offset invalid_system_SSE,		25	;92
				dd offset invalid_system_SSE,		25	;93
				dd offset invalid_system_SSE,		25	;94
				dd offset invalid_system_SSE,		25	;95
				dd offset invalid_system_SSE,		25	;96
				dd offset invalid_system_SSE,		25	;97
				dd offset invalid_system_SSE,		25	;98
				dd offset invalid_system_SSE,		25	;99
				dd offset SSE_TOO_MANY_SEMAPHORES,	39	;100
				dd offset SSE_EXCL_SEM_ALREADY_OWNED, 52	;101
				dd offset SSE_SEM_IS_SET,		42	;102
				dd offset SSE_TOO_MANY_SEM_REQUESTS,	34	;103
				dd offset SSE_INVALID_AT_INTERRUPT_TIME, 54	;104
				dd offset SSE_SEM_OWNER_DIED,		51	;105
				dd offset SSE_SEM_USER_LIMIT,		33	;106
				dd offset SSE_DISK_CHANGE,		60	;107
				dd offset SSE_DRIVE_LOCKED,		48	;108
				dd offset SSE_BROKEN_PIPE,		24	;109
				dd offset SSE_OPEN_FAILED,		52	;110
				dd offset SSE_BUFFER_OVERFLOW,	26	;111
				dd offset SSE_DISK_FULL,		38	;112
				dd offset SSE_NO_MORE_SEARCH_HANDLES,	44	;113
				dd offset SSE_INVALID_TARGET_HANDLE,	49	;114
				dd offset invalid_system_SSE,		25	;115
				dd offset invalid_system_SSE,		25	;116
				dd offset SSE_INVALID_CATEGORY,	62	;117
				dd offset SSE_INVALID_VERIFY_SWITCH,	58	;118
				dd offset SSE_BAD_DRIVER_LEVEL,	50	;119
				dd offset SSE_CALL_NOT_IMPLEMENTED,	47	;120
				dd offset SSE_SEM_TIMEOUT, 		41	;121
				dd offset SSE_INSUFFICIENT_BUFFER,	51	;122
				dd offset SSE_INVALID_NAME, 		66	;123
				dd offset SSE_INVALID_LEVEL,		37	;124
				dd offset SSE_NO_VOLUME_LABEL,	29	;125
				dd offset SSE_MOD_NOT_FOUND,		40	;126
				dd offset SSE_PROC_NOT_FOUND,		43	;127
				dd offset SSE_WAIT_NO_CHILDREN,	41	;128
				dd offset SSE_CHILD_NOT_COMPLETE,	52	;129
				dd offset SSE_DIRECT_ACCESS_HANDLE,	96	;130
				dd offset SSE_NEGATIVE_SEEK,		78	;131
				dd offset SSE_SEEK_ON_DEVICE,	 	63	;132
				dd offset SSE_IS_JOIN_TARGET,		90	;133
				dd offset SSE_IS_JOINED,		91	;134
				dd offset SSE_IS_SUBSTED,		96	;135
				dd offset SSE_NOT_JOINED,		66	;136
				dd offset SSE_NOT_SUBSTED, 		79	;137
				dd offset SSE_JOIN_TO_JOIN,		66	;138
				dd offset SSE_SUBST_TO_SUBST,		77	;139
				dd offset SSE_JOIN_TO_SUBST, 		71	;140
				dd offset SSE_SUBST_TO_JOIN, 		67	;141
				dd offset SSE_BUSY_DRIVE,		55	;142
				dd offset SSE_SAME_DRIVE,		85	;143
				dd offset SSE_DIR_NOT_ROOT,		58	;144
				dd offset SSE_DIR_NOT_EMPTY,		27	;145
				dd offset SSE_IS_SUBST_PATH,		49 	;146
				dd offset SSE_IS_JOIN_PATH,		59	;147
				dd offset SSE_PATH_BUSY,		47	;148
				dd offset SSE_IS_SUBST_TARGET,	124	;149
				dd offset SSE_SYSTEM_TRACE,		93	;150
				dd offset SSE_INVALID_EVENT_COUNT,	74	;151
				dd offset SSE_TOO_MANY_MUXWAITERS,	67	;152
				dd offset SSE_INVALID_LIST_FORMAT,	38	;153
				dd offset SSE_LABEL_TOO_LONG,		89	;154
				dd offset SSE_TOO_MANY_TCBS,		29	;155
				dd offset SSE_SIGNAL_REFUSED,		45	;156
				dd offset SSE_DISCARDED,		54	;157
				dd offset SSE_NOT_LOCKED, 		32	;158
				dd offset SSE_BAD_THREADID_ADDR,	40	;159
				dd offset SSE_BAD_ARGUMENTS,		56	;160
				dd offset SSE_BAD_PATHNAME,		30	;161
				dd offset SSE_SIGNAL_PENDING,		28	;162
				dd offset invalid_system_SSE,		25	;163
				dd offset SSE_MAX_THRDS_REACHED,	45	;164
				dd offset invalid_system_SSE,		25	;165
				dd offset invalid_system_SSE,		25	;166
				dd offset SSE_LOCK_FAILED,		34	;167
				dd offset invalid_system_SSE, 	25	;168
				dd offset invalid_system_SSE,		25	;169
				dd offset SSE_BUSY,			33	;170
				dd offset invalid_system_SSE,		25	;171
				dd offset invalid_system_SSE,		25	;172
				dd offset SSE_CANCEL_VIOLATION,	66 	;173
				dd offset SSE_ATOMIC_LOCKS_NOT_SUPPORTED, 65	;174
				dd offset invalid_system_SSE,		25	;175
				dd offset invalid_system_SSE,		25	;176
				dd offset invalid_system_SSE,		25	;177
				dd offset invalid_system_SSE,		25	;178
				dd offset invalid_system_SSE,		25	;179
				dd offset SSE_INVALID_SEGMENT_NUMBER, 58 	;180
				dd offset invalid_system_SSE,		25	;181
				dd offset SSE_INVALID_ORDINAL,	35	;182
				dd offset SSE_ALREADY_EXISTS,		51	;183
				dd offset invalid_system_SSE,		25	;184
				dd offset invalid_system_SSE,		25	;185
				dd offset SSE_INVALID_FLAG_NUMBER,	31	;186
				dd offset SSE_SEM_NOT_FOUND,		50	;187
				dd offset SSE_INVALID_STARTING_CODESEG, 35	;188
				dd offset SSE_INVALID_STACKSEG,	35	;189
				dd offset SSE_INVALID_MODULETYPE,	35	;190
				dd offset SSE_INVALID_EXE_SIGNATURE,	33	;191
				dd offset SSE_EXE_MARKED_INVALID,	35	;192
				dd offset SSE_BAD_EXE_FORMAT,		41	;193
				dd offset SSE_ITERATED_DATA_EXCEEDS_64k, 35	;194
				dd offset SSE_INVALID_MINALLOCSIZE,	35	;195
				dd offset SSE_DYNLINK_FROM_INVALID_RING, 57	;196
				dd offset SSE_IOPL_NOT_ENABLED,	73	;197
				dd offset SSE_INVALID_SEGDPL,		35	;198
				dd offset SSE_AUTODATASEG_EXCEEDS_64k, 57	;199
				dd offset SSE_RING2SEG_MUST_BE_MOVABLE, 57	;200
				dd offset SSE_RELOC_CHAIN_XEEDS_SEGLIM, 35	;201
				dd offset SSE_INFLOOP_IN_RELOC_CHAIN,	35	;202
				dd offset SSE_ENVVAR_NOT_FOUND,	66	;203
				dd offset invalid_system_SSE,		25	;204
				dd offset SSE_NO_SIGNAL_SENT,		55	;205
				dd offset SSE_FILENAME_EXCED_RANGE,	38	;206
				dd offset SSE_RING2_STACK_IN_USE,	20	;207
				dd offset SSE_META_EXPANSION_TOO_LONG, 117	;208
				dd offset SSE_INVALID_SIGNAL_NUMBER,	39	;209
				dd offset SSE_THREAD_1_INACTIVE,	33	;210
				dd offset invalid_system_SSE,	 	25	;211
				dd offset SSE_LOCKED,			48	;212
				dd offset invalid_system_SSE,		25	;213
				dd offset SSE_TOO_MANY_MODULES,	82	;214
				dd offset SSE_NESTING_NOT_ALLOWED,	31	;215
				dd offset SSE_EXE_MACHINE_TYPE_MISMATCH, 85	;216
				dd offset invalid_system_SSE,		25	;217
				dd offset invalid_system_SSE,		25	;218
				dd offset invalid_system_SSE,		25	;219
				dd offset invalid_system_SSE,		25	;220
				dd offset invalid_system_SSE,		25	;221
				dd offset invalid_system_SSE,		25	;222
				dd offset invalid_system_SSE,		25	;223
				dd offset invalid_system_SSE,		25	;224
				dd offset invalid_system_SSE,		25	;225
				dd offset invalid_system_SSE,		25	;226
				dd offset invalid_system_SSE,		25	;227
				dd offset invalid_system_SSE,		25	;228
				dd offset invalid_system_SSE,		25	;229
				dd offset SSE_BAD_PIPE,		26	;230
				dd offset SSE_PIPE_BUSY,		28	;231
				dd offset SSE_NO_DATA,		25	;232
				dd offset SSE_PIPE_NOT_CONNECTED,	43	;233
				dd offset SSE_MORE_DATA,		23	;234
				dd offset invalid_system_SSE,		25	;235
				dd offset invalid_system_SSE,		25	;236
				dd offset invalid_system_SSE,		25	;237
				dd offset invalid_system_SSE,		25	;238
				dd offset invalid_system_SSE,		25	;239
				dd offset SSE_VC_DISCONNECTED,		26	;240
				dd offset invalid_system_SSE,		25	;241
				dd offset invalid_system_SSE,		25	;242
				dd offset invalid_system_SSE,		25	;243
				dd offset invalid_system_SSE,		25	;244
				dd offset invalid_system_SSE,		25	;245
				dd offset invalid_system_SSE,		25	;246
				dd offset invalid_system_SSE,		25	;247
				dd offset invalid_system_SSE,		25	;248
				dd offset invalid_system_SSE,		25	;249
				dd offset invalid_system_SSE,		25	;250
				dd offset invalid_system_SSE,		25	;251
				dd offset invalid_system_SSE,		25	;252
				dd offset invalid_system_SSE,		25	;253
				dd offset SSE_INVALID_EA_NAME,	50	;254
				dd offset SSE_EA_LIST_INCONSISTENT,	41	;255
				dd offset invalid_system_SSE,		25	;256
				dd offset invalid_system_SSE,		25	;257
				dd offset invalid_system_SSE,		25	;258
				dd offset SSE_NO_MORE_ITEMS, 		26	;259
				dd offset invalid_system_SSE,		25	;260
				dd offset invalid_system_SSE,		25	;261
				dd offset invalid_system_SSE,		25	;262
				dd offset invalid_system_SSE,		25	;263
				dd offset invalid_system_SSE,		25	;264
				dd offset invalid_system_SSE,		25	;265
				dd offset SSE_CANNOT_COPY,		28	;266
				dd offset SSE_DIRECTORY,		30	;267
				dd offset invalid_system_SSE,		25	;268
				dd offset invalid_system_SSE,		25	;269
				dd offset invalid_system_SSE,		25	;270
				dd offset invalid_system_SSE,		25	;271
				dd offset invalid_system_SSE,		25	;272
				dd offset invalid_system_SSE,		25	;273
				dd offset invalid_system_SSE,		25	;274
				dd offset SSE_EAS_DIDNT_FIT,		50	;275
				dd offset SSE_EA_FILE_CORRUPT,	66	;276
				dd offset SSE_EA_TABLE_FULL,		42	;277
				dd offset SSE_INVALID_EA_HANDLE,	51	;278
				dd offset invalid_system_SSE,		25	;279
				dd offset invalid_system_SSE,		25	;280
				dd offset invalid_system_SSE,		25	;281
				dd offset SSE_EAS_NOT_SUPPORTED,	61	;282
				dd offset invalid_system_SSE,		25	;283
				dd offset invalid_system_SSE,		25	;284
				dd offset invalid_system_SSE,		25	;285
				dd offset invalid_system_SSE,		25	;286
				dd offset invalid_system_SSE,		25	;287
				dd offset SSE_NOT_OWNER,		45	;288
				dd offset invalid_system_SSE,		25	;289
				dd offset invalid_system_SSE,		25	;290
				dd offset invalid_system_SSE,		25	;291
				dd offset invalid_system_SSE,		25	;292
				dd offset invalid_system_SSE,		25	;293
				dd offset invalid_system_SSE,		25	;294
				dd offset invalid_system_SSE,		25	;295
				dd offset invalid_system_SSE,		25	;296
				dd offset invalid_system_SSE,		25	;297
				dd offset SSE_TOO_MANY_POSTS,		40	;298
				dd offset SSE_PARTIAL_COPY,		61	;299

SSE_SUCCESS			db 'The operation completed successfully.',0					;0
SSE_INVALID_FUNCTION		db 'Incorrect function.',0							;1
SSE_FILE_NOT_FOUND		db 'The system cannot find the file specified.',0				;2
SSE_PATH_NOT_FOUND		db 'The system cannot find the path specified.',0				;3
SSE_TOO_MANY_OPEN_FILES		db 'The system cannot open the file.',0						;4
SSE_ACCESS_DENIED		db 'Access is denied.',0							;5
SSE_INVALID_HANDLE		db 'The handle is invalid.',0							;6
SSE_ARENA_TRASHED		db 'The storage control blocks were destroyed.',0				;7
SSE_NOT_ENOUGH_MEMORY		db 'Not enough storage is available to process this command.',0			;8
SSE_INVALID_BLOCK		db 'The storage control block address is invalid.',0				;9
SSE_BAD_ENVIRONMENT		db 'The environment is incorrect.',0						;10
SSE_BAD_FORMAT			db 'An attempt was made to load a program with an incorrect format.',0		;11
SSE_INVALID_ACCESS		db 'The access code is invalid.',0						;12
SSE_INVALID_DATA		db 'The data is invalid.',0							;13
SSE_OUTOFMEMORY			db 'Not enough storage is available to complete this operation.',0		;14
SSE_INVALID_DRIVE		db 'The system cannot find the drive specified.',0				;15
SSE_CURRENT_DIRECTORY		db 'The directory cannot be removed.',0						;16
SSE_NOT_SAME_DEVICE		db 'The system cannot move the file to a different disk drive.',0		;17
SSE_NO_MORE_FILES		db 'There are no more files.',0							;18
SSE_WRITE_PROTECT		db 'The media is write protected.',0						;19
SSE_BAD_UNIT			db 'The system cannot find the device specified.',0				;20
SSE_NOT_READY			db 'The device is not ready.',0							;21
SSE_BAD_COMMAND			db 'The device does not recognize the command.',0				;22
SSE_CRC				db 'Data error (cyclic redundancy check)',0					;23
SSE_BAD_LENGTH			db 'The program issued a command but the command length is incorrect.',0	;24
SSE_SEEK			db 'The drive cannot locate a specific area or track on the disk.',0		;25
SSE_NOT_DOS_DISK		db 'The specified disk or diskette cannot be accessed.',0			;26
SSE_SECTOR_NOT_FOUND		db 'The drive cannot find the sector requested.',0				;27
SSE_OUT_OF_PAPER		db 'The printer is out of paper.',0						;28
SSE_WRITE_FAULT			db 'The system cannot write to the specified device.',0				;29
SSE_READ_FAULT			db 'The system cannot read from the specified device.',0			;30
SSE_GEN_FAILURE			db 'A device attached to the system is not functioning.',0			;31
SSE_SHARING_VIOLATION		db 'The process cannot access the file because it is being used by another process.',0			;32
SSE_LOCK_VIOLATION		db 'The process cannot access the file because another process has locked a portion of the file.',0	;33
SSE_WRONG_DISK			db 'The wrong diskette is in the drive. Insert %2 (Volume Serial Number: %3) into drive %1.',0		;34
SSE_SHARING_BUFFER_EXCEEDED	db 'Too many files opened for sharing.',0 					;35
SSE_HANDLE_EOF			db 'Reached end of file.',0 							;38
SSE_HANDLE_DISK_FULL		db 'The disk is full.',0 							;39
SSE_NOT_SUPPORTED		db 'The network request is not supported.',0					;50
SSE_REM_NOT_LIST		db 'The remote computer is not available.',0					;51
SSE_DUP_NAME			db 'A duplicate name exists on the network.',0					;52
SSE_BAD_NETPATH			db 'The network path was not found.',0						;53
SSE_NETWORK_BUSY		db 'The network is busy.',0							;54
SSE_DEV_NOT_EXIST		db 'The specified network resource or device is no longer available.',0		;55
SSE_TOO_MANY_CMDS		db 'The network BIOS command limit has been reached.',0				;56
SSE_ADAP_HDW_ERR		db 'A network adapter hardware error occurred.',0				;57
SSE_BAD_NET_RESP		db 'The specified server cannot perform the requested operation.',0		;58
SSE_UNEXP_NET_ERR		db 'An unexpected network error occurred.',0					;59
SSE_BAD_REM_ADAP		db 'The remote adapter is not compatible.',0					;60
SSE_PRINTQ_FULL			db 'The printer queue is full.',0						;61
SSE_NO_SPOOL_SPACE		db 'Space to store the file waiting to be printed is not available on the server.',0		;62
SSE_PRINT_CANCELLED		db 'Your file waiting to be printed was deleted.',0				;63
SSE_NETNAME_DELETED		db 'The specified network name is no longer available.',0			;64
SSE_NETWORK_ACCESS_DENIED	db 'Network access is denied.',0						;65
SSE_BAD_DEV_TYPE		db 'The network resource type is not correct.',0				;66
SSE_BAD_NET_NAME		db 'The network name cannot be found.',0					;67
SSE_TOO_MANY_NAMES		db 'The name limit for the local computer network adapter card was exceeded.',0	;68
SSE_TOO_MANY_SESS		db 'The network BIOS session limit was exceeded.',0				;69
SSE_SHARING_PAUSED		db 'The remote server has been paused or is in the process of being started.',0	;70
SSE_REQ_NOT_ACCEP		db 'No more connections can be made to this remote computer at this time because there are already as many connections as the computer can accept.',0	;71
SSE_REDIR_PAUSED		db 'The specified printer or disk device has been paused.',0			;72
SSE_FILE_EXISTS			db 'The file exists.',0								;80
SSE_CANNOT_MAKE			db 'The directory or file cannot be created.',0					;82
SSE_FAIL_I24			db 'Fail on INT 24',0								;83
SSE_OUT_OF_STRUCTURES		db 'Storage to process this request is not available.',0			;84
SSE_ALREADY_ASSIGNED		db 'The local device name is already in use.',0					;85
SSE_INVALID_PASSWORD		db 'The specified network password is not correct.',0				;86
SSE_INVALID_PARAMETER		db 'The parameter is incorrect.',0						;87
SSE_NET_WRITE_FAULT		db 'A write fault occurred on the network.',0					;88
SSE_NO_PROC_SLOTS		db 'The system cannot start another process at this time.',0			;89
SSE_TOO_MANY_SEMAPHORES		db 'Cannot create another system semaphore.',0					;100
SSE_EXCL_SEM_ALREADY_OWNED	db 'The exclusive semaphore is owned by another process.',0			;101
SSE_SEM_IS_SET			db 'The semaphore is set and cannot be closed.',0				;102
SSE_TOO_MANY_SEM_REQUESTS	db 'The semaphore cannot be set again.',0					;103
SSE_INVALID_AT_INTERRUPT_TIME	db 'Cannot request exclusive semaphores at interrupt time.',0			;104
SSE_SEM_OWNER_DIED		db 'The previous ownership of this semaphore has ended.',0			;105
SSE_SEM_USER_LIMIT		db 'Insert the diskette for drive %1.',0					;106
SSE_DISK_CHANGE			db 'Program stopped because alternate diskette was not inserted.',0		;107
SSE_DRIVE_LOCKED		db 'The disk is in use or locked by another process.',0				;108
SSE_BROKEN_PIPE			db 'The pipe has been ended.',0							;109
SSE_OPEN_FAILED			db 'The system cannot open the device or file specified.',0			;110
SSE_BUFFER_OVERFLOW		db 'The file name is too long.',0						;111
SSE_DISK_FULL			db 'There is not enough space on the disk.',0					;112
SSE_NO_MORE_SEARCH_HANDLES	db 'No more internal file identifiers available.',0				;113
SSE_INVALID_TARGET_HANDLE	db 'The target internal file identifier is incorrect.',0			;114
SSE_INVALID_CATEGORY		db 'The IOCTL call made by the application program is not correct.',0		;117
SSE_INVALID_VERIFY_SWITCH	db 'The verify-on-write switch parameter value is not correct.',0		;118
SSE_BAD_DRIVER_LEVEL		db 'The system does not support the command requested.',0			;119
SSE_CALL_NOT_IMPLEMENTED	db 'This function is only valid in Windows NT mode.',0				;120
SSE_SEM_TIMEOUT			db 'The semaphore timeout period has expired.',0				;121
SSE_INSUFFICIENT_BUFFER		db 'The data area passed to a system call is too small.',0			;122
SSE_INVALID_NAME		db 'The filename, directory name, or volume label syntax is incorrect.',0	;123
SSE_INVALID_LEVEL		db 'The system call level is not correct.',0					;124
SSE_NO_VOLUME_LABEL		db 'The disk has no volume label.',0						;125
SSE_MOD_NOT_FOUND		db 'The specified module could not be found.',0					;126
SSE_PROC_NOT_FOUND		db 'The specified procedure could not be found.',0				;127
SSE_WAIT_NO_CHILDREN		db 'There are no child processes to wait for.',0				;128
SSE_CHILD_NOT_COMPLETE		db 'The %1 application cannot be run in Windows NT mode.',0			;129
SSE_DIRECT_ACCESS_HANDLE	db 'Attempt to use a file handle to an open disk partition for an operation other than raw disk I/O.',0		;130
SSE_NEGATIVE_SEEK		db 'An attempt was made to move the file pointer before the beginning of the file.',0				;131
SSE_SEEK_ON_DEVICE		db 'The file pointer cannot be set on the specified device or file.',0						;132
SSE_IS_JOIN_TARGET		db 'A JOIN or SUBST command cannot be used for a drive that contains previously joined drives.',0		;133
SSE_IS_JOINED			db 'An attempt was made to use a JOIN or SUBST command on a drive that has already been joined.',0		;134
SSE_IS_SUBSTED			db 'An attempt was made to use a JOIN or SUBST command on a drive that has already been substituted.',0		;135
SSE_NOT_JOINED			db 'The system tried to delete the JOIN of a drive that is not joined.',0					;136
SSE_NOT_SUBSTED			db 'The system tried to delete the substitution of a drive that is not substituted.',0				;137
SSE_JOIN_TO_JOIN		db 'The system tried to join a drive to a directory on a joined drive.',0					;138
SSE_SUBST_TO_SUBST		db 'The system tried to substitute a drive to a directory on a substituted drive.',0				;139
SSE_JOIN_TO_SUBST		db 'The system tried to join a drive to a directory on a substituted drive.',0					;140
SSE_SUBST_TO_JOIN		db 'The system tried to SUBST a drive to a directory on a joined drive.',0					;141
SSE_BUSY_DRIVE			db 'The system cannot perform a JOIN or SUBST at this time.',0							;142
SSE_SAME_DRIVE			db 'The system cannot join or substitute a drive to or for a directory on the same drive.',0			;143
SSE_DIR_NOT_ROOT		db 'The directory is not a subdirectory of the root directory.',0						;144
SSE_DIR_NOT_EMPTY		db 'The directory is not empty.',0										;145
SSE_IS_SUBST_PATH		db 'The path specified is being used in a substitute.',0							;146
SSE_IS_JOIN_PATH		db 'Not enough resources are available to process this command.',0						;147
SSE_PATH_BUSY			db 'The path specified cannot be used at this time.',0								;148
SSE_IS_SUBST_TARGET		db 'An attempt was made to join or substitute a drive for which a directory on the drive is the target of a previous substitute.',0	;149
SSE_SYSTEM_TRACE		db 'System trace information was not specified in your CONFIG.SYS file, or tracing is disallowed.',0		;150
SSE_INVALID_EVENT_COUNT		db 'The number of specified semaphore events for DosMuxSemWait is not correct.',0				;151
SSE_TOO_MANY_MUXWAITERS		db 'DosMuxSemWait did not execute; too many semaphores are already set.',0					;152
SSE_INVALID_LIST_FORMAT		db 'The DosMuxSemWait list is not correct.',0									;153
SSE_LABEL_TOO_LONG		db 'The volume label you entered exceeds the label character limit of the target file system.',0		;154
SSE_TOO_MANY_TCBS		db 'Cannot create another thread.',0										;155
SSE_SIGNAL_REFUSED		db 'The recipient process has refused the signal.',0				;156
SSE_DISCARDED			db 'The segment is already discarded and cannot be locked.',0			;157
SSE_NOT_LOCKED			db 'The segment is already unlocked.',0						;158
SSE_BAD_THREADID_ADDR		db 'The address for the thread ID is not correct.',0				;159
SSE_BAD_ARGUMENTS		db 'The argument string passed to DosExecPgm is not correct.',0			;160
SSE_BAD_PATHNAME		db 'The specified path is invalid.',0						;161
SSE_SIGNAL_PENDING		db 'A signal is already pending.',0						;162
SSE_MAX_THRDS_REACHED		db 'No more threads can be created in the system.',0				;164
SSE_LOCK_FAILED			db 'Unable to lock a region of a file.',0					;167
SSE_BUSY			db 'The requested resource is in use.',0					;170
SSE_CANCEL_VIOLATION		db 'A lock request was not outstanding for the supplied cancel region.',0	;173
SSE_ATOMIC_LOCKS_NOT_SUPPORTED db 'The file system does not support atomic changes to the lock type.',0	;174
SSE_INVALID_SEGMENT_NUMBER	db 'The system detected a segment number that was not correct.',0		;180
SSE_INVALID_ORDINAL		db 'The operating system cannot run %1.',0					;182
SSE_ALREADY_EXISTS		db 'Cannot create a file when that file already exists.',0			;183
SSE_INVALID_FLAG_NUMBER		db 'The flag passed is not correct.',0						;186	
SSE_SEM_NOT_FOUND		db 'The specified system semaphore name was not found.',0			;187
SSE_INVALID_STARTING_CODESEG	db 'The operating system cannot run %1.',0					;188
SSE_INVALID_STACKSEG		db 'The operating system cannot run %1.	',0					;189
SSE_INVALID_MODULETYPE		db 'The operating system cannot run %1.	',0					;190
SSE_INVALID_EXE_SIGNATURE	db 'Cannot run %1 in Windows NT mode.',0					;191
SSE_EXE_MARKED_INVALID		db 'The operating system cannot run %1.	',0					;192
SSE_BAD_EXE_FORMAT		db '%1 is not a valid Windows NT application.',0				;193
SSE_ITERATED_DATA_EXCEEDS_64k	db 'The operating system cannot run %1.',0					;194
SSE_INVALID_MINALLOCSIZE	db 'The operating system cannot run %1.	',0					;195
SSE_DYNLINK_FROM_INVALID_RING	db 'The operating system cannot run this application program.',0		;196
SSE_IOPL_NOT_ENABLED		db 'The operating system is not presently configured to run this application.',0	;197
SSE_INVALID_SEGDPL		db 'The operating system cannot run %1.',0					;198
SSE_AUTODATASEG_EXCEEDS_64k	db 'The operating system cannot run this application program.',0		;199
SSE_RING2SEG_MUST_BE_MOVABLE	db 'The code segment cannot be greater than or equal to 64KB.',0		;200
SSE_RELOC_CHAIN_XEEDS_SEGLIM	db 'The operating system cannot run %1.',0					;201
SSE_INFLOOP_IN_RELOC_CHAIN	db 'The operating system cannot run %1.',0					;202
SSE_ENVVAR_NOT_FOUND		db 'The system could not find the environment option that was entered.',0	;203
SSE_NO_SIGNAL_SENT		db 'No process in the command subtree has a signal handler.',0			;205
SSE_FILENAME_EXCED_RANGE	db 'The filename or extension is too long.',0					;206
SSE_RING2_STACK_IN_USE		db 'The ring 2 stack is in use.',0						;207
SSE_META_EXPANSION_TOO_LONG	db 'The global filename characters, * or ?, are entered incorrectly or too many global filename characters are specified.',0	;208
SSE_INVALID_SIGNAL_NUMBER	db 'The signal being posted is not correct.',0					;209
SSE_THREAD_1_INACTIVE		db 'The signal handler cannot be set.',0					;210
SSE_LOCKED			db 'The segment is locked and cannot be reallocated.',0				;212
SSE_TOO_MANY_MODULES		db 'Too many dynamic link modules are attached to this program or dynamic link module.',0	;214
SSE_NESTING_NOT_ALLOWED	db 'Cannot nest calls to LoadModule.',0								;215
SSE_EXE_MACHINE_TYPE_MISMATCH	db 'The image file %1 is valid, but is for a machine type other than the current machine.',0	;216
SSE_BAD_PIPE			db 'The pipe state is invalid.',0					;230
SSE_PIPE_BUSY			db 'All pipe instances are busy.',0					;231
SSE_NO_DATA			db 'The pipe is being closed.',0					;232
SSE_PIPE_NOT_CONNECTED		db 'No process is on the other end of the pipe.',0			;233
SSE_MORE_DATA			db 'More data is available.',0						;234
SSE_VC_DISCONNECTED		db 'The session was cancelled.',0					;240
SSE_INVALID_EA_NAME		db 'The specified extended attribute name was invalid.',0		;254
SSE_EA_LIST_INCONSISTENT	db 'The extended attributes are inconsistent.',0			;255
SSE_NO_MORE_ITEMS		db 'No more data is available.',0					;259
SSE_CANNOT_COPY			db 'The Copy API cannot be used.',0					;266
SSE_DIRECTORY			db 'The directory name is invalid.',0					;267
SSE_EAS_DIDNT_FIT		db 'The extended attributes did not fit in the buffer.',0		;275
SSE_EA_FILE_CORRUPT		db 'The extended attribute file on the mounted file system is corrupt.',0	;276
SSE_EA_TABLE_FULL		db 'The extended attribute table file is full.',0				;277
SSE_INVALID_EA_HANDLE		db 'The specified extended attribute handle is invalid.',0			;278
SSE_EAS_NOT_SUPPORTED		db 'The mounted file system does not support extended attributes.',0		;282
SSE_NOT_OWNER			db 'Attempt to release mutex not owned by caller.',0				;288
SSE_TOO_MANY_POSTS		db 'Too many posts were made to a semaphore.',0					;298
SSE_PARTIAL_COPY		db 'Only part of a Read/WriteProcessMemory request was completed.',0		;299
invalid_system_SSE		db 'Invalid system error code',0

system_out_SSE_code		db 'Specified code is not supported by this function. Supported codes are 0 - 299.',0 
.CODE

end_get_system_SSE_text:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - SSE text address
;[ebx] - SSE text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
Get_System_Error_Text endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push shell_execute_SSE code		;ebp+8
;call Get_SPL_Error_Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_SPL_Error_Text proc
push ebp
mov ebp,esp

mov ecx,dword ptr [ebp]+8
cmp ecx,169
jbe no_above_SPL_SSE_code 
mov eax,offset SSE_INVALID_SPL_CODE
mov ebx,75
jmp end_get_SPL_SSE_text
no_above_SPL_SSE_code:

mov ecx,dword ptr [ebp]+8
rol ecx,3	; mul 8
add ecx,offset SPL_SSEs
mov eax,dword ptr [ecx]
mov ebx,dword ptr [ecx]+4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - SSE text address
;[ebx] - SSE text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA

SPL_SSEs			dd offset SSE_STRING_END_REACHED,		47	;0
				dd offset SSE_SPL_NORMAL_EXECUTION,		40	;1
				dd offset SSE_EXPECTED_START_SYMBOL,		22	;2
				dd offset SSE_EXPECTED_SINGLE_DLM,		22	;3
				dd offset SSE_EXPECTED_DOUBLE_DLM,		22	;4
				dd offset SSE_UNEXPECTED_END,			15	;5
				dd offset SSE_EXPECTED_END_SYMBOL,		22	;6
				dd offset SSE_INVALID_OBJECT,			29	;7
				dd offset SSE_IN_DELIMITERS,			30	;8
				dd offset SSE_EQUATION_EXPECTED,		22	;9
				dd offset SSE_FIRST_DELIMITERS,		30	;10
				dd offset SSE_INVALID_OPERATOR,		30	;11
				dd offset SSE_INVALID_OPERATOR_TYPE, 		54	;12
				dd offset SSE_INVALID_OPERATOR_LENGTH,	29	;13
				dd offset SSE_INSERT_OBJECT_END,		43	;14
				dd offset SSE_INSERT_OBJECT_FILE_NAME,	46	;15 
				dd offset SSE_INSERT_UE_AFND,			57	;16
				dd offset SSE_INSERT_UE_AED,			57	;17
				dd offset SSE_IO_EWI,				42	;18
				dd offset SSE_UE_AWI,				54	;19
				dd offset SSE_IOE_OBNDNC,			67	;20
				dd offset SSE_IO_SAEOANS,			57	;21
				dd offset SSE_IOE_WER,			52	;22
				dd offset SSE_IOE_UEAWE,			51	;23
				dd offset SSE_E_EXPECTED_IIOE,		43	;24
				dd offset SSE_FILENAME_LARGE,			50	;25
				dd offset SSE_EXTENSION_LARGE,		51	;26
				dd offset SSE_FILENAME_LABEL_LARGE,		56	;27
				dd offset SSE_EXTENSION_LABEL_LARGE,		57	;28
				dd offset SSE_NO_FILENAME_FROM_LABEL,		63	;29
				dd offset SSE_NO_EXTENSION_FROM_LABEL,	64	;30
				dd offset SSE_FULL_FILENAME_LARGE,		83	;31
				dd offset SSE_CANNOT_REPLACE_FILENAME,	63	;32
				dd offset SSE_STRING_END_REACHED_BSS,		46	;33
				dd offset SSE_OUTPUT_OBJECT_EPDSS,		39	;34
				dd offset SSE_STRING_END_REACHED_IOO,		56	;35
				dd offset SSE_UNEXPECTED_ASSD,		35	;36
				dd offset SSE_UNEXPECTED_END_AFWO,		35	;37
				dd offset SSE_WORD_OUTPUT_INVALID,		32	;38
				dd offset SSE_STRING_END_RAWO,		39	;39
				dd offset SSE_UEXPD_AFWO,			56	;40
				dd offset SSE_UNEXPECTED_END_AFWN,		33	;41
				dd offset SSE_EXPECTED_START_SWTRFFL,		53	;42
				dd offset SSE_EXPECTED_ESAFWN,		40	;43
				dd offset SSE_UNEXPECTED_END_DGFOT,		44	;44
				dd offset SSE_UNEXPECTED_EWTRFFL,		46	;45
				dd offset SSE_UNEXPECTED_END_AFSPS,		42	;46
				dd offset SSE_OBJECT_TYPE_INVWTTFFL,		90 	;47
				dd offset SSE_IN_DELIMITERS_WTTFFL,		57	;48
				dd offset SSE_EXPECTED_EQSWTTFFFL,		45	;49 
				dd offset SSE_STDOUR_SEP_D_UEEND,		64	;50
				dd offset SSE_NO_STDERR_AFTER_STDOUT,		49	;51
				dd offset SSE_EXPECTED_STSWTTFEL,		75	;52
				dd offset SSE_EXPECTED_END_SYMBOL_IOO,	39	;53
				dd offset SSE_UNEXPECTED_END_STDOUT_C,	47	;54
				dd offset SSE_UNEXPECTED_ENDWTTF_EFL,		77	;55
				dd offset SSE_CANNOT_DETERMINE_OUTPUT,	29	;56
				dd offset SSE_C_DETERMINE_OT_WTTFEFL,		94	;57 
				dd offset SSE_IN_DELIMITERS_OWTTFFFL,		83	;58
				dd offset SSE_UNEXPECTED_E_AFTER_STDERR,	28	;59
				dd offset SSE_UNEXPECTED_E_AS_SDR_CASE,	61	;60
				dd offset SSE_SPAFTER_STDERR_IN_STDOUT,	49	;61
				dd offset SSE_UNEXPECTED_END_STDERR_C,	47	;62
				dd offset SSE_EXPECTED_STS_IN_OUPUT_O,	39	;63
				dd offset SSE_UNEXPECTED_END_AFTER_W_S,	35	;64
				dd offset SSE_OPERATION_O_ST_END_R,		63	;65
				dd offset SSE_EXPECTED_STAR_S_I_O_S_O,	48	;66
				dd offset SSE_UNEE_AFTER_OO_S_AF_SSY,		60	;67
				dd offset SSE_INVALID_WORD_IOS,		58	;68
				dd offset SSE_UNEXPECTED_END_AF_OP_W_S,	75	;69
				dd offset SSE_OPERATION_NAME_DEF_N_C_S,	61	;70
				dd offset SSE_STING_END_REACHED_IOS,		91	;71
				dd offset SSE_INVALID_START_WORD,		52	;72
				dd offset SSE_EXPECTED_IN_OPS_SS,		41	;73
				dd offset SSE_STRE_R_AFT_W_S_IO_O,		64	;74
				dd offset SSE_OPEO_H_R_B_AN_OP_PERF,		57	;75
				dd offset SSE_EXPECTED_SPL_0076,		46	;76
				dd offset SSE_UNEXPECTED_END_SPL_0077,	58	;77
				dd offset SSE_WORD_MUST_BE_OPERATION,		49	;78
				dd offset SSE_UNEXPECTED_END_SPL_0079,	66	;79
				dd offset SSE_OPERATION_NAME_SPL_0080,	66	;80
				dd offset SSE_STR_END_REACHED_AFTER_OPN,	75	;81
				dd offset SSE_WORD_END_EXPECTED_SPL_0082,	37	;82
				dd offset SSE_EXPECTED_SPL_0083,		39	;83
				dd offset SSE_STRING_END_SPL_0084,		36	;84
				dd offset SSE_STRING_END_SPL_0085,		45	;85
				dd offset SSE_STRING_END_SPL_0086,		44	;86
				dd offset SSE_STRING_END_SPL_0087,		45	;87
				dd offset SSE_INPUT_IS_TOO_LARGE_SPL_88,	29	;88
				dd offset SSE_INPUT_IS_TOO_LARGE_SPL_89,	30	;89
				dd offset SSE_FOUND_FILENAME_SPL_0090,	87	;90
				dd offset SSE_FOUND_FILENAME_SPL_0091,	88	;91
				dd offset SSE_OPERATION_NAME_SPL_0092,	46	;92
				dd offset SSE_INIT_UNEXPECTED_END,		31	;93
				dd offset SSE_FILENAME_SPL_0094,		22	;94
				dd offset SSE_FILENAME_SPL_0095,		30	;95
				dd offset SSE_SPL_CODE_RESERVED,		33	;96
				dd offset SSE_SPL_CODE_RESERVED,		33	;97
				dd offset SSE_SPL_CODE_RESERVED,		33	;98
				dd offset SSE_SPL_CODE_RESERVED,		33	;99
				dd offset SSE_SPL_CODE_RESERVED,		33	;100
				dd offset SSE_SPL_CODE_RESERVED,		33	;101
				dd offset SSE_SPL_CODE_RESERVED,		33	;102
				dd offset SSE_SPL_CODE_RESERVED,		33	;103
				dd offset SSE_FLL_SPL_0104,			54	;104
				dd offset SSE_FLL_SPL_0105,			60	;105
				dd offset SSE_FLL_SPL_0106,			64	;106
				dd offset SSE_FLL_SPL_0107,			60	;107
				dd offset SSE_FLL_SPL_0108,			61	;108
				dd offset SSE_FLL_SPL_0109,			58	;109
				dd offset SSE_FLL_SPL_0110,			61	;110
				dd offset SSE_FLL_SPL_0111,			63	;111
				dd offset SSE_FL_SPL_0112,			49	;112
				dd offset SSE_FL_SPL_0113,			60	;113
				dd offset SSE_FL_SPL_0114,			58	;114
				dd offset SSE_FL_SPL_0115,			60	;115
				dd offset SSE_FL_SPL_0116,			88	;116
				dd offset SSE_FL_SPL_0117,			61	;117
				dd offset SSE_FL_SPL_0118,			59	;118
				dd offset SSE_FL_SPL_0119,			61	;119
				dd offset SSE_PL_SPL_0120,			52	;120
				dd offset SSE_PL_SPL_0121,			66	;121
				dd offset SSE_PL_SPL_0122,			61	;122
				dd offset SSE_PL_SPL_0123,			66	;123
				dd offset SSE_PL_SPL_0124,			94	;124
				dd offset SSE_PL_SPL_0125,			64	;125
				dd offset SSE_PL_SPL_0126,			59	;126
				dd offset SSE_PL_SPL_0127,			64	;127
				dd offset SSE_OL_SPL_0128,			54	;128
				dd offset SSE_OL_SPL_0129,			68	;129
				dd offset SSE_OL_SPL_0130,			63	;130
				dd offset SSE_OL_SPL_0131,			66	;131
				dd offset SSE_OL_SPL_0132,			86	;132
				dd offset SSE_OL_SPL_0133,			61	;133
				dd offset SSE_OL_SPL_0134,			56	;134
				dd offset SSE_OL_SPL_0135,			59	;135
				dd offset SSE_SPL_0136,			35	;136
				dd offset SSE_SPL_0137,			56	;137
				dd offset SSE_SPL_0138,			30	;138
				dd offset SSE_SPL_0139,			51	;139
				dd offset SSE_SPL_0140,			33	;140
				dd offset SSE_SPL_0141,			54	;141
				dd offset SSE_SPL_0142,			58	;142
				dd offset SSE_SPL_0143,			56	;143
				dd offset SSE_SPL_0144,			40	;144
				dd offset SSE_SPL_0145,			40	;145
				dd offset SSE_SPL_0146,			26	;146
				dd offset SSE_SPL_0147,			56	;147
				dd offset SSE_SPL_0148,			42	;148
				dd offset SSE_SPL_0149,			38	;149
				dd offset SSE_SPL_0150,			51	;150
				dd offset SSE_SPL_0151,			65	;151
				dd offset SSE_SPL_0152,			34	;152
				dd offset SSE_SPL_0153,			41	;153
				dd offset SSE_SPL_0154,			42	;154
				dd offset SSE_SPL_0155,			36	;155
				dd offset SSE_SPL_0156,			79	;156
				dd offset SSE_SPL_0157,			83	;157
				dd offset SSE_SPL_0158,			56	;158
				dd offset SSE_SPL_0159,			30	;159
				dd offset SSE_SPL_0160,			58	;160
				dd offset SSE_SPL_0161,			63	;161
				dd offset SSE_SPL_0162,			48	;162
				dd offset SSE_SPL_0163,			35	;163
				dd offset SSE_SPL_0164,			37	;164
				dd offset SSE_SPL_0165,			42	;165
				dd offset SSE_SPL_0166,			59	;166
				dd offset SSE_SPL_0167,			53	;167
				dd offset SSE_SPL_0168,			63	;168
				dd offset SSE_SPL_0169,			63	;169


SSE_STRING_END_REACHED		db 'String end reached during operation performing.',0		;0
SSE_SPL_NORMAL_EXECUTION	db 'SPL operation is completed successfully.',0		;1
SSE_EXPECTED_START_SYMBOL	db 'Expected " [ " symbol.',0			;2
SSE_EXPECTED_SINGLE_DLM		db "Expected  ' delimiter.",0			;3
SSE_EXPECTED_DOUBLE_DLM		db 'Expected  " delimiter.',0			;4
SSE_UNEXPECTED_END		db 'Unexpected end.',0				;5
SSE_EXPECTED_END_SYMBOL		db 'Expected " ] " symbol.',0			;6
SSE_INVALID_OBJECT		db 'Cannot determine object type.',0		;7
SSE_IN_DELIMITERS		db 'Cannot found second delimiter.',0		;8
SSE_EQUATION_EXPECTED		db 'Expected " = " symbol.',0			;9
SSE_FIRST_DELIMITERS		db 'First symbol is not delimiter.',0		;10
SSE_INVALID_OPERATOR		db 'Specified operator is invalid.',0		;11
SSE_INVALID_OPERATOR_TYPE	db 'Specified operator type is absent in current position.',0	;12
SSE_INVALID_OPERATOR_LENGTH	db 'Operator length is incorrect.',0		;13
SSE_INSERT_OBJECT_END		db 'Expected " [ " symbol in insert object end.',0	;14
SSE_INSERT_OBJECT_FILE_NAME	db 'Insert object file name definition is invalid.',0		;15 
SSE_INSERT_UE_AFND		db 'Insert object: Unexpected end after file name definition.',0	;16
SSE_INSERT_UE_AED		db 'Insert object: Unexpected end after extension definition.',0	;17
SSE_IO_EWI			db 'Insert object end: Error in word "Insert".',0		;18
SSE_UE_AWI			db 'Insert object end: Unexpected end after word "Insert".',0	;19
SSE_IOE_OBNDNC			db 'Insert object end: Object name in delimiter is defined not correct.',0	;20
SSE_IO_SAEOANS			db 'Insert object start and end object names are not similar.',0	;21
SSE_IOE_WER			db 'Insert object end: Word "End" definition is invalid.',0		;22
SSE_IOE_UEAWE			db 'Insert object end: Unexpected end after word "End".',0		;23
SSE_E_EXPECTED_IIOE		db 'Expected " ] " symbol in insert object end.',0			;24
SSE_FILENAME_LARGE		db 'Specified filename too large, more than 400 bytes.',0		;25
SSE_EXTENSION_LARGE		db 'Specified extension too large, more than 400 bytes.',0		;26
SSE_FILENAME_LABEL_LARGE	db 'Specified filename label too large, more than 400 bytes.',0		;27
SSE_EXTENSION_LABEL_LARGE	db 'Specified extension label too large, more than 400 bytes.',0	;28
SSE_NO_FILENAME_FROM_LABEL	db 'Cannot find filename by using specified label in insert object.',0	;29
SSE_NO_EXTENSION_FROM_LABEL	db 'Cannot find extension by using specified label in insert object.',0	;30
SSE_FULL_FILENAME_LARGE		db 'Full filename too large [which found by using label], cannot change file extension.',0	;31
SSE_CANNOT_REPLACE_FILENAME	db 'Filename too large. Cannot replace insert object with filename.',0	;32
SSE_STRING_END_REACHED_BSS	db 'String end reached  before start " [ " symbol .',0			;33
SSE_OUTPUT_OBJECT_EPDSS		db 'Expected " [ " symbol in output object.',0				;34
SSE_STRING_END_REACHED_IOO	db 'String end reached in output object after symbol " [ " .',0		;35
SSE_UNEXPECTED_ASSD		db 'Unexpected end after symbol " [ " .',0				;36
SSE_UNEXPECTED_END_AFWO		db 'Unexpected end after word "Output".',0				;37
SSE_WORD_OUTPUT_INVALID		db 'Specified word must be "Output".',0					;38
SSE_STRING_END_RAWO		db 'String end reached after word "Output".',0				;39
SSE_UEXPD_AFWO			db 'Unexpected end after word "Output". No output specified.',0		;40
SSE_UNEXPECTED_END_AFWN		db 'Unexpected end after word "None".',0				;41
SSE_EXPECTED_START_SWTRFFL	db 'Expected " [ " symbol during filename search process.',0		;42
SSE_EXPECTED_ESAFWN		db 'Expected " ] " symbol after word "None". ',0				;43
SSE_UNEXPECTED_END_DGFOT	db 'Unexpected end before get first output type.',0			;44
SSE_UNEXPECTED_EWTRFFL		db 'Unexpected end during filename search process.',0			;45
SSE_UNEXPECTED_END_AFSPS	db 'Unexpected end after separator symbol "/".',0			;46
SSE_OBJECT_TYPE_INVWTTFFL	db 'Cannot determine object type. [Occured during filename search][Filename defined as label]. ',0	;47
SSE_IN_DELIMITERS_WTTFFL	db 'Error in delimiters during filename label search process.',0	;48
SSE_EXPECTED_EQSWTTFFFL		db 'Expected equal sign " = " in filename object.',0			;49 
SSE_STDOUR_SEP_D_UEEND		db 'Unexpected end after separator sign " / ".[After word "STDOUT"].',0	;50
SSE_NO_STDERR_AFTER_STDOUT	db 'Specified output type after STDOUT is not STDERR.',0			;51
SSE_EXPECTED_STSWTTFEL		db 'Expected start symbol " [ " . [Occured during extension search from label].',0	;52
SSE_EXPECTED_END_SYMBOL_IOO	db 'Expected symbol " ] " in output object.',0				;53
SSE_UNEXPECTED_END_STDOUT_C	db 'Unexpected end in output object. [STDOUT case].',0			;54
SSE_UNEXPECTED_ENDWTTF_EFL	db 'Unexpected end during extension search process. [Extension defined as label].',0	;55
SSE_CANNOT_DETERMINE_OUTPUT	db 'Cannot determine output type.',0					;56
SSE_C_DETERMINE_OT_WTTFEFL	db 'Cannot determine object type. [Occured during extension search.][Extension defined as label.].',0	;57 
SSE_IN_DELIMITERS_OWTTFFFL	db 'Error in delimiters. [Occured during filename search.][Filename defined as label.].',0		;58
SSE_UNEXPECTED_E_AFTER_STDERR	db 'Unexpected end after STDERR ',0					;59
SSE_UNEXPECTED_E_AS_SDR_CASE	db 'Unexpected end after separator " / ". [After word "STDERR" ].',0	;60
SSE_SPAFTER_STDERR_IN_STDOUT	db 'Specified output type after STDERR is not STDOUT.',0		;61
SSE_UNEXPECTED_END_STDERR_C	db 'Unexpected end in output object. [STDERR case].',0			;62
SSE_EXPECTED_STS_IN_OUPUT_O	db 'Expected symbol " ] " in output object.',0				;63
SSE_UNEXPECTED_END_AFTER_W_S	db 'Unexpected end after word "STDOUT". ',0				;64
SSE_OPERATION_O_ST_END_R	db 'Operation object start part end reached direct after scan start',0	;65
SSE_EXPECTED_STAR_S_I_O_S_O	db 'Expected symbol " [ " in operation start object.',0			;66
SSE_UNEE_AFTER_OO_S_AF_SSY	db 'Unexpected end in operation object start after symbol " [ ". ',0	;67
SSE_INVALID_WORD_IOS		db 'Error. Invalid word in operation start. Word must be "Operation".',0	;68
SSE_UNEXPECTED_END_AF_OP_W_S	db 'Unexpected end after word "Operation". [Occured in operation start object].',0	;69
SSE_OPERATION_NAME_DEF_N_C_S	db 'Operation name defined not correct in operation start object.',0	;70
SSE_STING_END_REACHED_IOS	db 'String end reached after operation name in delimiters. [Occured in operation start object].',0	;71
SSE_INVALID_START_WORD		db 'Error.Word is not "Start" in operation object start.',0		;72
SSE_EXPECTED_IN_OPS_SS		db 'Expected symbol " ] " in operation start.',0			;73
SSE_STRE_R_AFT_W_S_IO_O		db 'String end reached after word "Start" in operation start object.',0	;74
SSE_OPEO_H_R_B_AN_OP_PERF	db 'Operation end object end reached direct after scan start.',0		;75
SSE_EXPECTED_SPL_0076		db 'Expected symbol " [ " in operation end object.',0			;76
SSE_UNEXPECTED_END_SPL_0077	db 'Unexpected end in operation end object after symbol " [ ".',0	;77
SSE_WORD_MUST_BE_OPERATION	db 'Word in operation end object must be "Operation".',0		;78
SSE_UNEXPECTED_END_SPL_0079	db 'Unexpected end after word "Operation". [Occured in operation end].',0 ;79
SSE_OPERATION_NAME_SPL_0080	db 'Operation name in delimiters defined not correct in operation end.',0	;80
SSE_STR_END_REACHED_AFTER_OPN	db 'String end reached after operation name. [Occured in operation end object].',0	;81
SSE_WORD_END_EXPECTED_SPL_0082	db 'Word "End" expected in operation end.',0				;82
SSE_EXPECTED_SPL_0083		db 'Expected symbol " ] " in operation end.',0				;83
SSE_STRING_END_SPL_0084		db 'String end reached after word "End".',0				;84
SSE_STRING_END_SPL_0085		db 'String end reached before first input object.',0			;85
SSE_STRING_END_SPL_0086		db 'String end reached after first input object.',0			;86
SSE_STRING_END_SPL_0087		db 'String end reached after second input object.',0			;87
SSE_INPUT_IS_TOO_LARGE_SPL_88	db 'First input length too large.',0					;88
SSE_INPUT_IS_TOO_LARGE_SPL_89	db 'Second input length too large.',0					;89
SSE_FOUND_FILENAME_SPL_0090	db 'Found filename from first input label is too large. Cannot replace label with filename.',0		;90
SSE_FOUND_FILENAME_SPL_0091	db 'Found filename from second input label is too large. Cannot replace label with filename.',0		;91
SSE_OPERATION_NAME_SPL_0092	db 'Operation start and end names are not similar.',0			;92
SSE_INIT_UNEXPECTED_END		db 'Unexpected end during init SPL.',0					;93
SSE_FILENAME_SPL_0094		db 'Filename contains EOL.',0						;94
SSE_FILENAME_SPL_0095		db 'Filename contains null symbol.',0					;95;

SSE_FLL_SPL_0104		db 'File load list start redefinition not allowed attempt.',0		;104
SSE_FLL_SPL_0105		db 'File load list start definition before define file list end.',0	;105
SSE_FLL_SPL_0106		db 'File load list start definition before define programs list end.',0	;106
SSE_FLL_SPL_0107		db 'File load list definition before define operations list end.',0	;107
SSE_FLL_SPL_0108		db 'Attempt to define file load list end before start definition.',0	;108
SSE_FLL_SPL_0109		db 'File load list end definition when file list not complete.',0	;109
SSE_FLL_SPL_0110		db 'File load list end definition when program list not complete.',0	;110
SSE_FLL_SPL_0111		db 'File load list end definition when operation list not complete.',0	;111
SSE_FL_SPL_0112			db 'File list start redefinition not allowed attempt.',0		;112
SSE_FL_SPL_0113			db 'File list start definition when file load list not complete. ',0	;113
SSE_FL_SPL_0114			db 'File list start definition when program list not complete. ',0	;114
SSE_FL_SPL_0115			db 'File list start definition when operation list not complete. ',0	;115
SSE_FL_SPL_0116			db 'File list end definition not allowed attempt when start of file list is not defined yet.',0	;116
SSE_FL_SPL_0117			db 'File list end definition when file load list is not complete.',0	;117
SSE_FL_SPL_0118			db 'File list end definition when program list is not complete. ',0	;118
SSE_FL_SPL_0119			db 'File list end definition when operation list is not complete. ',0	;119
SSE_PL_SPL_0120			db 'Program list start redefinition not allowed attempt.',0		;120
SSE_PL_SPL_0121			db 'Program list start definition when file load list is not complete.',0	;121
SSE_PL_SPL_0122			db 'Program list start definition when file list is not complete. ',0	;122
SSE_PL_SPL_0123			db 'Program list start definition when operation list is not complete.',0	;123
SSE_PL_SPL_0124			db 'Program list end definition not allowed attempt when start of program list is not defined yet.',0	;124
SSE_PL_SPL_0125			db 'Program list end definition when file load list is not complete.',0	;125
SSE_PL_SPL_0126			db 'Program list end definition when file list is not complete.',0	;126
SSE_PL_SPL_0127			db 'Program list end definition when operation list is not complete.',0	;127
SSE_OL_SPL_0128			db 'Operation list start redefinition not allowed attempt.',0		;128
SSE_OL_SPL_0129			db 'Operation list start definition when file load list is not complete.',0	;129
SSE_OL_SPL_0130			db 'Operation list start definition when file list is not complete.',0	;130
SSE_OL_SPL_0131			db 'Operation list start definition when program list is not complete.',0	;131
SSE_OL_SPL_0132			db 'Operation end definition invalid attempt when operation list start is not defined yet.',0	;132
SSE_OL_SPL_0133			db 'Operation end definition when file load list is not complete.',0	;133
SSE_OL_SPL_0134			db 'Operation end definition when file list is not complete.',0		;134
SSE_OL_SPL_0135			db 'Operation end definition when program list is not complete.',0	;135
SSE_SPL_0136			db 'File load list start not specified.',0				;136
SSE_SPL_0137			db 'File load list end not specified or list length is null.',0		;137
SSE_SPL_0138			db 'File list start not specified.',0					;138
SSE_SPL_0139			db 'File list end not specified or list length is null.',0		;139
SSE_SPL_0140			db 'Program list start not specified.',0				;140
SSE_SPL_0141			db 'Program list end not specified or list length is null.',0		;141
SSE_SPL_0142			db 'Operation list start not specified or list length is null.',0	;142
SSE_SPL_0143			db 'Operation list end not specified or list length is null.',0		;143
SSE_SPL_0144			db 'Cannot determine operation type by name.',0				;144
SSE_SPL_0145			db 'String end reached during operation get.',0				;145
SSE_SPL_0146			db 'Operation type is unknown.',0					;146

SSE_SPL_0147			db 'String end reached when try to start get load File name.',0		;147
SSE_SPL_0148			db 'Expected " [ " symbol in file load object.',0			;148
SSE_SPL_0149			db 'String end reached after symbol " [ ".',0				;149
SSE_SPL_0150			db 'String end reached when try to get word "FileName".',0		;150
SSE_SPL_0151			db 'Found word length is invalid, must be 8. Word must be "FileName".',0	;151
SSE_SPL_0152			db 'Specified word must be "FileName".',0				;152
SSE_SPL_0153			db 'String end reached after word "FileName".',0			;153
SSE_SPL_0154			db 'Expected equal sign after word "FileName".',0			;154
SSE_SPL_0155			db 'String end reached after equal sign.',0				;155
SSE_SPL_0156			db 'Error in file load object. Specified file name first symbol is not a delimiter.',0	;156
SSE_SPL_0157			db 'Error in file load object. String end reached when try to get object in delimiters.',0	;157
SSE_SPL_0158			db 'String end reached after file load object in delimiters.',0		;158
SSE_SPL_0159			db 'Specified word must be "Line".',0					;159
SSE_SPL_0160			db 'Expected equal sign after word "Line" in file load object.',0	;160
SSE_SPL_0161			db 'String end reached after equal sign in end of file load object.',0	;161
SSE_SPL_0162			db 'Cannot retrieve line number in load file object.',0			;162
SSE_SPL_0163			db 'Specified line number is too large.',0				;163
SSE_SPL_0164			db 'String end reached after line number.',0				;164
SSE_SPL_0165			db 'Expected " ] " symbol in file load object.',0			;165
SSE_SPL_0166			db 'File name for generate is too large. [For file load object].',0	;166
SSE_SPL_0167			db 'SPL buffer limit reached. Cannot add FileName object.',0		;167
SSE_SPL_0168			db 'Input 1 contents are invalid. Operation could not be performed.',0	;168
SSE_SPL_0169			db 'Input 2 contents are invalid. Operation could not be performed.',0	;169

SSE_SPL_CODE_RESERVED		db 'Specified error code is reserved.',0				
SSE_INVALID_SPL_CODE		db 'Specified error code is too large and not supported by this version of SPL.',0

.CODE

end_get_SPL_SSE_text:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - SSE text address
;[ebx] - SSE text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
Get_SPL_Error_Text endp

endm

