asm_ide_standard_project_functions macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
current_file_name_address		dd 0
current_save_active_richedit_window	dd 0
save_current_file_error_code		dd 0
close_confirmation_title		db 'Save confirmation',0
close_confirmation_text			db 'The contents of specified window has been changed',0dh, 0ah
					db 'Do you want to save changes?',0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Using example
;push offset file_name			;ebp+16
;push window_handle			;ebp+12
;push operation_type			;ebp+8
;call SCL_Save_Specified_File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Save_Specified_File proc
push ebp
mov ebp,esp
;;;;Save specified window handle contents into specified file 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SSF_01, EP_SSF_01

mov eax,dword ptr [ebp]+8
mov operation_type_SSF_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SSF_01, LF_SSF_01, operation_type_SSF_01, LP_SSF_01, EP_SSF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov save_current_file_error_code,0

.DATA
save_SP_file_system_error_text		dd 0
save_specified_file_error_code		dd 0
specified_file_description		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;lParam   
push 0				;wParam   
push 0B8h			;EM_GETMODIFY 0B8h
push dword ptr [ebp]+12		;window_handle
call SendMessageA
cmp eax,0
je SP_save_or_close_end_point	;Jump if specified text is not modified
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;push save_type				;ebp+20
;save_type   ;0 - Only save file without confirmation ;1 - Save and close file with confirmation
;STREAMOUT_type			;0 - All   ;1 - Selection

start_transfer_file_for_SP_save:
push 0  					;STREAMOUT_type			;ebp+20
push dword ptr [ebp]+12				;richedit_window_handle		;ebp+16
push dword ptr [ebp]+16				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Transfer_Richedit_Window_Contents_Into_File
cmp eax,(-1)
je start_transfer_file_for_SP_save
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - Error owner
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - WriteFile generates error
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je end_save_specified_file

push specified_file_description		;ebp+20
push dword ptr [ebp]+16			;offset file_name	;ebp+16
push ebx				;error_code		;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Generate_File_IO_Error_Report

end_save_specified_file:

push 0				;lParam   
push 0				;wParam		Modification new value   
push 0B9h			;EM_SETMODIFY 0B8h
push dword ptr [ebp]+12		;current_save_active_richedit_window
call SendMessageA

SP_save_or_close_end_point:


SP_all_operation_cancel_point:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SSF_01, LP_SSF_01, EP_SSF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 12
SCL_Save_Specified_File endp		;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Using example
;push File_List_Item_Number		;ebp+12
;push operation_type			;ebp+8
;call SCL_Close_Specified_File_List_Item
;save_type   ;0 - Only save file without confirmation ;1 - Save and close file with confirmation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Close_Specified_File_List_Item proc
push ebp
mov ebp,esp
;;;;Close corresponding File List Item and remove item from file list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CSFLI_01, EP_CSFLI_01

mov eax,dword ptr [ebp]+8
mov operation_type_CSFLI_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CSFLI_01, LF_CSFLI_01, operation_type_CSFLI_01, LP_CSFLI_01, EP_CSFLI_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
.DATA
specified_close_richedit_window		dd 0
specified_close_FNL_item		dd 0
.CODE
cmp List_Items_Count,0
je no_close_specified_item		;Jump if list is empty 

mov eax,dword ptr [ebp]+12		;List_Item_Selection_Number
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov specified_close_FNL_item,eax
mov ecx,dword ptr [eax]+448		;FNL_richedit_window_handle
mov specified_close_richedit_window,ecx

push	0				;SW_RESTORE
push	ecx				;FNL_richedit_window_handle
call	ShowWindow			;Hide Window 

push specified_close_richedit_window
call DestroyWindow			;Destroy Richedit Window

push specified_close_FNL_item		;close_FNL_item_address
push 0 ;operation_type
call SCL_Invalidate_FNL_Item

push offset COLOR_HANDLES_ARRAY	;ebp+24
push dword ptr [ebp]+12			;close_list_item_number	 ;remove_position ;ebp+20
push offset LIST_CONTENTS		;ebp+16
push 0  ;operation_type		;ebp+8
call SCL_Remove_File_List_Item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show Remaining windows
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show Remaining windows
mov new_header_button_selection,1

push 6	;function_number		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Concentrated_Switch_Control	;Set File List Visibility 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End close file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

no_close_specified_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CSFLI_01, LP_CSFLI_01, EP_CSFLI_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Close_Specified_File_List_Item   endp     ;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push file_list_item_number		;ebp+12
;push operation_type			;ebp+8
;call SCL_Complete_Corresponding_FNL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Complete_Corresponding_FNL proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CCF_01, EP_CCF_01

mov eax,dword ptr [ebp]+8
mov operation_type_CCF_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CCF_01, LF_CCF_01, operation_type_CCF_01, LP_CCF_01, EP_CCF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
FNL_Item_Address		dd 0
FNL_Item_Scroll_Pos		dd 0, 0
FNL_Item_Selected_Range		dd 0, 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+12		;file_list_item_number
cmp eax,0
je no_complete_corresponding_FNL
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov FNL_Item_Address,eax

mov eax,dword ptr [FNL_Item_Address]+448

push offset FNL_Item_Selected_Range
push 0					;wParam
push 400h+52				;EM_EXGETSEL  WM_USER + 52
push eax				;spl_window_handle
call SendMessageA

mov ebx,FNL_Item_Selected_Range		;Range start
mov ecx,FNL_Item_Selected_Range+4	;Range end
mov dword ptr [FNL_Item_Address]+452,ebx
mov dword ptr [FNL_Item_Address]+456,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset FNL_Item_Scroll_Pos
;push 0					;wParam
;push 400h+221				;EM_GETSCROLLPOS WM_USER + 221
;push eax				;spl_window_handle
;call SendMessageA
;SPL_load_flag				dd 0 ;0 - Spl file not loaded ;1 - SPl file loaded

;FNL_Item_1	label dword 
;	FNL_busy_flag				dd 0		;0	;0 - Free ;1 - Busy
;	FNL_file_full_name_length		dd 0		;4
;	FNL_file_full_name			db 400 dup (0)	;8
;	FNL_only_file_path_length		dd 0		;408
;	FNL_only_file_name_length		dd 0		;412
;	FNL_file_size				dd 0		;416
;	FNL_only_file_name_address		dd 0		;420
;	FNL_only_file_extension_address		dd 0		;424
;	FNL_file_extension_length		dd 0		;428
;	FNL_file_type				dd 0		;432
;	FNL_richedit_window_proc_address	dd offset Richedit_Window_Filter_Proc_1		;436
;	FNL_richedit_window_old_proc_address	dd 0		;440
;	FNL_richedit_insert_overwrite_state	dd 0		;444	;0 - Insert ;1 - Overwrite
;	FNL_richedit_window_handle		dd 0		;448

;	FNL_richedit_selection_range_start	dd 0		;452
;	FNL_richedit_selection_range_end	dd 0		;456
;	FNL_richedit_vertical_scroll_pos	dd 0		;460
;	FNL_richedit_horizontal_scroll_pos	dd 0		;464
;	FNL_Reserved				dd 0		;468
;	FNL_Reserved				dd 0		;472

no_complete_corresponding_FNL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CCF_01, LP_CCF_01, EP_CCF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Complete_Corresponding_FNL endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Set_FNL_Window_Proc_Addresses proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SFWPA_01, EP_SFWPA_01

mov eax,dword ptr [ebp]+8
mov operation_type_SFWPA_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SFWPA_01, LF_SFWPA_01, operation_type_SFWPA_01, LP_SFWPA_01, EP_SFWPA_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov dword ptr [FNL_Item_1]+436,offset Richedit_Window_Filter_Proc_1
mov dword ptr [FNL_Item_2]+436,offset Richedit_Window_Filter_Proc_2
mov dword ptr [FNL_Item_3]+436,offset Richedit_Window_Filter_Proc_3
mov dword ptr [FNL_Item_4]+436,offset Richedit_Window_Filter_Proc_4
mov dword ptr [FNL_Item_5]+436,offset Richedit_Window_Filter_Proc_5
mov dword ptr [FNL_Item_6]+436,offset Richedit_Window_Filter_Proc_6
mov dword ptr [FNL_Item_7]+436,offset Richedit_Window_Filter_Proc_7
mov dword ptr [FNL_Item_8]+436,offset Richedit_Window_Filter_Proc_8
mov dword ptr [FNL_Item_9]+436,offset Richedit_Window_Filter_Proc_9
mov dword ptr [FNL_Item_10]+436,offset Richedit_Window_Filter_Proc_10
mov dword ptr [FNL_Item_11]+436,offset Richedit_Window_Filter_Proc_11
mov dword ptr [FNL_Item_12]+436,offset Richedit_Window_Filter_Proc_12
mov dword ptr [FNL_Item_13]+436,offset Richedit_Window_Filter_Proc_13
mov dword ptr [FNL_Item_14]+436,offset Richedit_Window_Filter_Proc_14
mov dword ptr [FNL_Item_15]+436,offset Richedit_Window_Filter_Proc_15
mov dword ptr [FNL_Item_16]+436,offset Richedit_Window_Filter_Proc_16
mov dword ptr [FNL_Item_17]+436,offset Richedit_Window_Filter_Proc_17
mov dword ptr [FNL_Item_18]+436,offset Richedit_Window_Filter_Proc_18
mov dword ptr [FNL_Item_19]+436,offset Richedit_Window_Filter_Proc_19
mov dword ptr [FNL_Item_20]+436,offset Richedit_Window_Filter_Proc_20
mov dword ptr [FNL_Item_21]+436,offset Richedit_Window_Filter_Proc_21
mov dword ptr [FNL_Item_22]+436,offset Richedit_Window_Filter_Proc_22
mov dword ptr [FNL_Item_23]+436,offset Richedit_Window_Filter_Proc_23
mov dword ptr [FNL_Item_24]+436,offset Richedit_Window_Filter_Proc_24
mov dword ptr [FNL_Item_25]+436,offset Richedit_Window_Filter_Proc_25
mov dword ptr [FNL_Item_26]+436,offset Richedit_Window_Filter_Proc_26
mov dword ptr [FNL_Item_27]+436,offset Richedit_Window_Filter_Proc_27
mov dword ptr [FNL_Item_28]+436,offset Richedit_Window_Filter_Proc_28
mov dword ptr [FNL_Item_29]+436,offset Richedit_Window_Filter_Proc_29
mov dword ptr [FNL_Item_30]+436,offset Richedit_Window_Filter_Proc_30
mov dword ptr [FNL_Item_31]+436,offset Richedit_Window_Filter_Proc_31
mov dword ptr [FNL_Item_32]+436,offset Richedit_Window_Filter_Proc_32
mov dword ptr [FNL_Item_33]+436,offset Richedit_Window_Filter_Proc_33
mov dword ptr [FNL_Item_34]+436,offset Richedit_Window_Filter_Proc_34
mov dword ptr [FNL_Item_35]+436,offset Richedit_Window_Filter_Proc_35
mov dword ptr [FNL_Item_36]+436,offset Richedit_Window_Filter_Proc_36
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SFWPA_01, LP_SFWPA_01, EP_SFWPA_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Set_FNL_Window_Proc_Addresses endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push project_save_type		;ebp+12
;push operation_type		;ebp+8
;call SCL_Save_Current_Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;project_save_type	;0 - Save without any confirmation	;1 - Save with confirmation and close project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Save_Current_Project proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SCP_01, EP_SCP_01

mov eax,dword ptr [ebp]+8
mov operation_type_SCP_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SCP_01, LF_SCP_01, operation_type_SCP_01, LP_SCP_01, EP_SCP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save All list files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Save All list files
.DATA
save_file_name_address			dd 0
save_file_richedit_window_handle	dd 0
file_list_save_internal_counter		dd 0
spl_not_loaded_error_title		db 'SPL absent',0
spl_not_loaded_error_text		db 'SPL project file is not loaded. Cannot compile or save project',0
.CODE

end_save_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SCP_01, LP_SCP_01, EP_SCP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SCL_Save_Current_Project endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push project_save_type		;ebp+12
;push operation_type		;ebp+8
;call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Save_Project_To_APF_File proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SPTAPFF_01, EP_SPTAPFF_01

mov eax,dword ptr [ebp]+8
mov operation_type_SPTAPFF_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SPTAPFF_01, LF_SPTAPFF_01, operation_type_SPTAPFF_01, LP_SPTAPFF_01, EP_SPTAPFF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,offset current_APF_file_name		;Project current loaded APF file name
mov APF_file_name_address,eax			;Initially set APF file name address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get APF file name

.DATA
APF_file_name_address		dd 0
APF_file_name_length		dd 0
APF_files_filter		db 'All files',0,'*.*',0, 'Apf files',0,'*.apf',0,0
APF_OPENFILENAMEA		dd 68 dup (0)
APF_get_file_buffer		db 400 dup (0)
APF_get_file_title		db 400 dup (0)
APF_get_file_dialog_title	db 'Save current project as...',0
.CODE

xor eax,eax
xor ebx,ebx
mov ecx,dword ptr [ebp]+12		;project_save_type
cmp ecx,1
sete al
cmp APF_load_flag,0			;0 - APF absent ;1 - APF present
sete bl
and eax,ebx
cmp eax,1
je all_project_save_end_point		;Jump if  APF not loaded and request was to close APF


cmp APF_load_flag,1			;0 - APF absent ;1 - APF present 
je do_not_show_APF_create_confirmation	;Jump if APF already present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset APF_get_file_buffer
mov edi,offset APF_get_file_buffer
mov ecx,100
xor eax,eax
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset APF_get_file_buffer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Save File Name for Result file
mov dword ptr APF_OPENFILENAMEA+28,offset APF_get_file_buffer
mov dword ptr APF_OPENFILENAMEA+36,offset APF_get_file_title
mov dword ptr APF_OPENFILENAMEA+44,0					;offset current_dir
mov dword ptr APF_OPENFILENAMEA+48,offset APF_get_file_dialog_title
mov dword ptr APF_OPENFILENAMEA,76
mov dword ptr APF_OPENFILENAMEA+24,2
mov dword ptr APF_OPENFILENAMEA+60,offset default_extension
mov dword ptr APF_OPENFILENAMEA+32,398
mov dword ptr APF_OPENFILENAMEA+40,398
mov dword ptr APF_OPENFILENAMEA+52,80000h+4h+200000h+20000h+2000000h+400h+2h+02000000h		;OFN_OVERWRITEPROMPT  2h
mov dword ptr APF_OPENFILENAMEA+12,offset APF_files_filter
mov eax,hwnd 
mov dword ptr APF_OPENFILENAMEA+4,eax
push offset APF_OPENFILENAMEA
call GetSaveFileNameA
cmp eax,0
je all_project_save_end_point		;end_get_APF_file

mov edi,offset current_APF_file_name
mov esi,offset APF_get_file_buffer
mov ecx,100
cld
rep movsd

do_not_show_APF_create_confirmation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get APF file name

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save All list files
.DATA
apf_load_error_title		db 'Project file present error',0
apf_load_error_text		db 'Assembler Project File [ .APF ] not loaded,',0dh, 0ah, 'Cannot save workspace to .APF',0
current_APF_file_name		db 400 dup (0)
APF_load_flag			dd 0			;0 - APF absent ;1 - APF present 
all_project_save_counter	dd 0
project_close_save_YES_TO_ALL	dd 0
project_close_save_NO_TO_ALL	dd 0
project_save_current_window	dd 0
project_save_file_name		dd 0
APF_file_open_flag		dd 0
project_save_description	db 'Process type: [Try to save workspace to APF file]',0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Preparing Project DATA for corresponding save
push 0	;operation_type
call SCL_Complete_All_FNL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Preparing Project DATA for corresponding save
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start write to file Project contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Open file
push 0         
push 80h			;FILE_ATTRIBUTE_NORMAL)
push 4				;OPEN_ALWAYS 4		;APF_file_open_flag
push 0         
push 0  
push 80000000h+40000000h	;(GENERIC READ/WRITE)  ;;;      mov eax,dword ptr [ebp+28]     
push APF_file_name_address
call CreateFileA
mov APF_file_create_internal_handle,eax
cmp eax,(-1)
jne no_error_in_APF_save_file			;INVALID_HANDLE_VALUE -1

call GetLastError
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset project_save_description	;ebp+20
push APF_file_name_address		;offset file_name	;ebp+16
push eax				;error_code		;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Generate_File_IO_Error_Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
APF_file_create_internal_handle		dd 0
APF_create_file_error_text		dd 0
.CODE

jmp all_project_save_end_point
no_error_in_APF_save_file:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;project_save_type		;[ebp]+12
;0	0 - Do not reset optional windows	;1 - Reset optional windows
;1	0 - Do not save SPL			;1 - Save SPL
;2	0 - Do not save workspace into APF	;1 - Save workspace into APF
;3	0 - Do not Close Project		;1 - Close Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

push APF_file_create_internal_handle	;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Project_Workspace_Into_File

mov APF_load_flag,1			;Set .APF file load flag as "APF loaded"

no_save_workspace_into_APF:

push APF_file_create_internal_handle	;current_file_handle;  ;Returned by CreateFileA
call CloseHandle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Open file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Create New File
end_create_APF:

;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project
;;;;;;;;;; [ebp]+12

mov eax,dword ptr [ebp]+12

push eax			;save_type		;ebp+12
push 0				;operation_type		;ebp+8
call SCL_Save_All_Files_List
;;;save_type			;0 - Save	 ;1 - Save And Close

mov eax,dword ptr [ebp]+12

push eax			;save_type			;ebp+12
push 0 ;operation_type		;ebp+8
call SCL_Save_Loaded_SPL_File
;;;;;;;;;;;;;;;;save_type	;0 - Do not show Save Confirmation Dialog	;1 - Show Save Confirmation Dialog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Save SPL


;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project
;;;;;;;;;; [ebp]+12
cmp dword ptr [ebp]+12,0
je no_reset_project_contents

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset List Contents
mov edi,offset LIST_CONTENTS
xor eax,eax
mov ecx,288				;1152 / 4 = 288
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset List Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset FNL
mov edi,offset FILE_NAME_LIST
xor eax,eax
mov ecx,4284				;17136 / 4 = 4284
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset FNL
push 0	;operation_type
call SCL_Set_FNL_Window_Proc_Addresses
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Results List Contents
mov edi,offset PROJECT_LIST_CONTENTS
xor eax,eax
mov ecx,288				;1152 / 4 = 288
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Results List Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset RFNL
mov edi,offset RESULT_FILE_NAME_LIST
xor eax,eax
mov ecx,4284				;17136 / 4 = 4284
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset RFNL
mov APF_load_flag,0			;0 - APF absent ;1 - APF present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

push 0				;lParam 
push 0				;wParam
push 0ch			;WM_SETTEXT
push spl_window_handle
call SendMessageA		;Reset SPL window contents
mov SPL_load_flag,0		;Set SPL load status as "SPL ABSENT"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Optional windows
;WM_SETTEXT  0ch
;wParam = 0;                     // not used; must be zero 
;lParam = (LPARAM)(LPCTSTR)lpsz; // address of window-text string 

push 0				;lParam 
push 0				;wParam
push 0ch			;WM_SETTEXT
push spl_window_handle
call SendMessageA		;Reset SPL window contents

push 0				;lParam 
push 0				;wParam
push 0ch			;WM_SETTEXT
push output_window_handle
call SendMessageA		;Reset Output Window contents

;push 0				;lParam 
;push 0				;wParam
;push 0ch			;WM_SETTEXT
;push report_window_handle
;call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Optional windows
no_reset_project_contents:


all_project_save_end_point:


push 0  ;operation_type				;ebp+8
call SCL_Set_Workspace_Lists_View
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SPTAPFF_01, LP_SPTAPFF_01, EP_SPTAPFF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SCL_Save_Project_To_APF_File endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push open_type			;ebp+16
;push offset  project_name	;ebp+12
;push operation_type		;ebp+8
;call SCL_Open_Project_APF_File
;open_type ;0 - Use GetOpenFileNameA ;1 - Use specified file

SCL_Open_Project_APF_File proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_OPAPFF_01, EP_OPAPFF_01

mov eax,dword ptr [ebp]+8
mov operation_type_OPAPFF_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_OPAPFF_01, LF_OPAPFF_01, operation_type_OPAPFF_01, LP_OPAPFF_01, EP_OPAPFF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp APF_load_flag,1			;0 - APF absent ;1 - APF present
jne no_already_project_open

push 20h+2000h
push offset project_open_confirmation_title	;"Already project open"
push offset project_open_confirmation_text	;"You have already open project......."
push hwnd
call MessageBoxA
jmp  all_project_open_end_point
no_already_project_open:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save All list files
.DATA
project_open_confirmation_title	db 'Already project open.',0
project_open_confirmation_text	db 'You have already open project.', 0dh, 0ah, 'You must at first close current project',0

open_APF_file_address		dd 0
APF_open_file_dialog_title	db 'Open Assembler project file',0
APF_open_file_title		db 400 dup (0)
APF_open_file_buffer		db 400 dup (0)
APF_open_file_error_title	db 'System error occured with .APF file. [ Try to open .APF ]',0dh, 0ah
project_open_description	db 'Process type: [Try to open .APF file]',0
.CODE
mov eax,dword ptr [ebp]+12
mov open_APF_file_address,eax

cmp dword ptr [ebp]+16,1
je no_use_get_open_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset APF_open_file_buffer
mov edi,offset APF_open_file_buffer
mov ecx,100
xor eax,eax
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset APF_open_file_buffer
mov dword ptr APF_OPENFILENAMEA+28,offset APF_open_file_buffer
mov dword ptr APF_OPENFILENAMEA+36,offset APF_open_file_title
mov dword ptr APF_OPENFILENAMEA+44,0					;offset current_dir
mov dword ptr APF_OPENFILENAMEA+48,offset APF_open_file_dialog_title
mov dword ptr APF_OPENFILENAMEA,76
mov dword ptr APF_OPENFILENAMEA+24,2
mov dword ptr APF_OPENFILENAMEA+60,offset default_extension
mov dword ptr APF_OPENFILENAMEA+32,398
mov dword ptr APF_OPENFILENAMEA+40,398
mov dword ptr APF_OPENFILENAMEA+52,80000h+4h+200000h+20000h+2000000h+400h+02000000h
mov dword ptr APF_OPENFILENAMEA+12,offset APF_files_filter
mov eax,hwnd 
mov dword ptr APF_OPENFILENAMEA+4,eax
push offset APF_OPENFILENAMEA
call GetSaveFileNameA
cmp eax,0
je all_project_open_end_point

mov eax,offset APF_open_file_buffer
mov open_APF_file_address,eax

no_use_get_open_file_name:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Current APF File Name
mov edi,offset current_APF_file_name
xor eax,eax
mov ecx,100			;400 / 4 = 100
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Current APF File Name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start write to file Project contents
;current_APF_file_name		db 'C:\current.apf',0	; .APF default size 37060 byte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Open file
push 0         
push 80h			;FILE_ATTRIBUTE_NORMAL)
push 3				;OPEN_EXISTING 3
push 0         
push 0  
push 80000000h+40000000h	;(GENERIC READ/WRITE)  ;;;      mov eax,dword ptr [ebp+28]     
push open_APF_file_address	;offset current_APF_file_name
call CreateFileA
mov APF_file_open_internal_handle,eax
cmp eax,(-1)
jne no_error_in_APF_open_file			;INVALID_HANDLE_VALUE -1
call GetLastError

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset project_open_description	;ebp+20
push open_APF_file_address		;offset file_name	;ebp+16
push eax				;error_code		;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Generate_File_IO_Error_Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
APF_file_open_internal_handle		dd 0
APF_open_file_error_text		dd 0
;;APF_create_file_error_title		db 'System error occured with .APF file',0
APF_file_read_bytes_count		dd 0

;APF_header_text			db 'Assembler project file'		;22    byte	;0
;APF_creator_version			db 'APF creator  ASMIDEv16'		;22    byte	;22
;APF_spl_file_name			db 400   dup (0)			;400   byte	;44
;APF_File_List				db 1172  dup (0)			;1172  byte	;444
;APF_FNL				db 17136 dup (0)			;17136 byte	;1616
;APF_Results_List			db 1172  dup (0)			;1172  byte	;18752
;APF_RFNL				db 17136 dup (0)			;17136 byte	;19924
open_APF_valid_state			dd 0
.CODE

jmp all_project_open_end_point
no_error_in_APF_open_file:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Current APF File Name
mov esi,open_APF_file_address
mov edi,offset current_APF_file_name
mov ecx,100			;400 / 4 = 100
cld
rep movsd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Current APF File Name
push APF_file_open_internal_handle
push 0 ;operation_type
call SCL_Project_File_Into_Workspace
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy
;[ebx] - 1 - APF projection not occured. APF invalid. [Error description in "Reports" window]
;[ebx] - 0 - APF projection occured successfully. 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov open_APF_valid_state,ebx

push APF_file_open_internal_handle	;current_file_handle;  ;Returned by CreateFileA
call CloseHandle

cmp open_APF_valid_state,0
je APF_valid

mov APF_load_flag,0			;0 - APF absent ;1 - APF present
mov SPL_load_flag,0			;0 - Spl file not loaded ;1 - SPl file loaded

jmp all_project_open_end_point
APF_valid:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset FILE_NAME_LIST		;FNL		;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Connect_Project_Objects

push offset RESULT_FILE_NAME_LIST	;ebp+16
push offset PROJECT_LIST_CONTENTS	;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Connect_Project_Objects
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0 ;operation_type				;ebp+8
call SCL_Set_Workspace_Lists_View

push 0			;operation_type
call SCL_Set_FNL_Window_Proc_Addresses

cmp SPL_load_flag,0				;0 - Spl file not loaded ;1 - SPl file loaded ;APF_spl_file_present_flag
je do_not_try_to_open_SPL

push 10 ;open_type				;ebp+16
push offset project_spl_file_name		;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Open_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
do_not_try_to_open_SPL:

push 0	;operation_type
call SCL_Validate_Project_Windows		;Create FNL corresponding richedit windows

all_project_open_end_point:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_OPAPFF_01, LP_OPAPFF_01, EP_OPAPFF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Open_Project_APF_File endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset FNL		;ebp+16
;push offset LIST_CONTENTS	;ebp+12
;push operation_type		;ebp+8
;call SCL_Connect_Project_Objects

SCL_Connect_Project_Objects proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CPO_01, EP_CPO_01

mov eax,dword ptr [ebp]+8
mov operation_type_CPO_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CPO_01, LF_CPO_01, operation_type_CPO_01, LP_CPO_01, EP_CPO_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
project_objects_connect_counter		dd 0
project_objects_connect_COUNT		dd 0
project_FNL_object_address		dd 0
project_LIST_object_address		dd 0
.CODE
mov project_objects_connect_counter,0
mov eax,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov ebx,dword ptr [eax]
mov project_objects_connect_COUNT,ebx

start_connect_project_objects:
inc project_objects_connect_counter

mov eax,project_objects_connect_counter
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+12		;add eax,offset LIST_CONTENTS
mov project_LIST_object_address,eax

mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,dword ptr [ebp]+16		;add eax,offset FILE_NAME_LIST
mov project_FNL_object_address,eax

mov ecx,project_LIST_object_address
mov eax,project_FNL_object_address

xor ecx,ecx

mov ebx,eax
add ebx,8				;FNL_file_full_name

xor ecx,ecx
push 400		;string_length	;ebp+20
push ecx		;find_byte		;ebp+16
push ebx		;scan_string	;ebp+12
call Find_Byte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,project_FNL_object_address
mov esi,eax
add esi,412
mov esi,dword ptr [esi]			;FNL_only_file_name_length

add eax,8
add eax,ecx				;length of string
sub eax,esi

mov ecx,project_LIST_object_address
mov dword ptr [ecx]+4,eax

;;FNL_only_file_name_length		dd 0		;412

mov eax,project_objects_connect_COUNT
cmp project_objects_connect_counter,eax
jb start_connect_project_objects
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CPO_01, LP_CPO_01, EP_CPO_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Connect_Project_Objects endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push operation_type
;call SCL_Validate_Projects_Windows
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Validate_Project_Windows proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_VPW_02, EP_VPW_02

mov eax,dword ptr [ebp]+8
mov operation_type_VPW_02,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_VPW_02, LF_VPW_02, operation_type_VPW_02, LP_VPW_02, EP_VPW_02
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
windows_validate_counter	dd 0
validate_FNL_address		dd 0
.CODE

cmp List_Items_Count,0
je end_validate_project_windows

mov eax,List_Items_Count
cmp List_Item_Selection_Number,eax
ja end_validate_project_windows


mov windows_validate_counter,0
start_validate_project_windows:
inc windows_validate_counter

mov eax,windows_validate_counter
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST

mov validate_FNL_address,eax

push eax				;AEF_first_free_FNL_item_address		;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Create_Corresponding_Richedit_Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer file contents into richedit window
start_transfer_file_contents_into_window:

mov eax,validate_FNL_address
mov ebx,dword ptr [eax]+448		;FNL_richedit_window_handle  448 
mov ecx,eax
add ecx,8

push 0  ;STREAMIN_type					;ebp+24
push 160000		;file_size_limit in bytes	;ebp+20
push ebx		;richedit_window_handle		;ebp+16
push ecx		;file_name_address		;offset file_name	;ebp+12
push 0		 	;operation_type			;ebp+8
call SCL_Transfer_File_Contents_Into_Richedit_Window
cmp eax,(-1)
je start_transfer_file_contents_into_window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - Error owner
	;[eax] - (-1) - function busy
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - ReadFile generates error
	;[eax] - 3 - File size is out of allowed limit
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je file_processed_normal

mov input_transfer_error_code,eax
mov input_transfer_system_error_code,ebx

.DATA
APF_files_open_description		db 'Process type: [Try to open one of the specified files from .APF]',0
;input_transfer_system_error_code	dd 0
;input_transfer_error_code		dd 0
;input_transfer_system_error_text	dd 0

;file_input_access_error		db 'File access system error occured',0dh, 0ah, 0
;file_input_error_title			db 'System error description:		',0

;file_size_error_title_text		db 'File size error.',0dh, 0ah, 0
;file_size_error_text			db 'File size is too large',0dh, 0ah
					db 'Specified file size is above than 160kb.',0dh, 0ah, 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp input_transfer_error_code,3		;File size is out of allowed limit
jne no_file_size_input_error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset line_text		;"________________________________________"
add_report_line 			;[eax] - contains line address

mov eax,offset file_size_error_title_text	;"File size error......"
add_report_line 			;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset file_name_text		;"File Name"
add_report_line 			;[eax] - contains line address

mov eax,file_name_address
add_report_line 			;[eax] - contains line address

mov eax,offset eol_code
add_report_line 			;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
mov eax,offset file_size_error_text	;"File size is too large"
add_report_line 			;[eax] - contains line address

mov eax,offset line_text		;"_________________________________________"
add_report_line 			;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

no_file_size_input_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov new_header_button_selection,4

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp input_transfer_error_code,3		;File size is out of allowed limit
je no_file_system_error

push offset APF_files_open_description
push file_name_address			;offset file_name	;ebp+16
push input_transfer_system_error_code	;error_code		;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Generate_File_IO_Error_Report

no_file_system_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,validate_FNL_address
mov ebx,dword ptr [eax]+448		;FNL_richedit_window_handle  448 

push 0
push ebx
call ShowWindow				;Hide richedit window 

mov eax,validate_FNL_address
mov ebx,dword ptr [eax]+448		;FNL_richedit_window_handle  448 

push ebx
call DestroyWindow			;Destroy richedit window [Because of file open error]

mov eax,validate_FNL_address

push eax				;AEF_first_free_FNL_item_address
push 0 ;operation_type
call SCL_Invalidate_FNL_Item		;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

push offset COLOR_HANDLES_ARRAY		;ebp+20
push windows_validate_counter		;remove_position			;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Remove_File_List_Item		;Remove item when could not load correspondig file

mov eax,List_Items_Count
cmp windows_validate_counter,eax
jb start_validate_project_windows

file_processed_normal:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer file contents into richedit window
mov eax,validate_FNL_address
mov ebx,dword ptr [eax]+448		;FNL_richedit_window_handle  448 

push 0				;lParam   
push 0				;wParam		Modification new value   
push 0B9h			;EM_SETMODIFY 0B8h
push ebx			;richedit_window_handle
call SendMessageA

mov eax,List_Items_Count
cmp windows_validate_counter,eax
jb start_validate_project_windows
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp header_selection_number,1
jne no_show_file_list_item

mov eax,List_Items_Count
cmp List_Item_Selection_Number,eax
ja no_show_file_list_item

mov eax,List_Item_Selection_Number
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov ecx,dword ptr [eax]+448		;FNL_richedit_window_handle  448 

push 1
push ecx
call ShowWindow

no_show_file_list_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

end_validate_project_windows:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_VPW_02, LP_VPW_02, EP_VPW_02
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Validate_Project_Windows endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push offset optional_text			;ebp+20
;push offset file_name				;ebp+16
;push error_code				;ebp+12
;push operation_type				;ebp+8
;call SCL_Generate_File_IO_Error_Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Generate_File_IO_Error_Report proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GFIOER_02, EP_GFIOER_02

mov eax,dword ptr [ebp]+8
mov operation_type_GFIOER_02,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_GFIOER_02, LF_GFIOER_02, operation_type_GFIOER_02, LP_GFIOER_02, EP_GFIOER_02
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
file_io_error_report_text_address	dd  0
optional_file_IO_text			db 'Optional		',0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov new_header_button_selection,4

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

push dword ptr [ebp]+12 		;system_error code		;ebp+8
call Get_System_Error_Text 
mov file_io_error_report_text_address,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset line_text	;"____________________________________________________"
add_report_line 		;[eax] - contains line address

mov eax,offset file_input_access_error	;"File access system error occured"
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset optional_file_IO_text	;"Optional"
add_report_line 		;[eax] - contains line address

mov eax,dword ptr [ebp]+20	
add_report_line 		;[eax] - contains line address

mov eax,offset eol_code
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset file_name_text	;"File name"
add_report_line 		;[eax] - contains line address

mov eax,dword ptr [ebp]+16	
add_report_line 		;[eax] - contains line address

mov eax,offset eol_code
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset file_input_error_title		;"System error description:"
add_report_line 		;[eax] - contains line address

mov eax,file_io_error_report_text_address
add_report_line 		;[eax] - contains line address

mov eax,offset eol_code
add_report_line 		;[eax] - contains line address

mov eax,offset line_text	;"______________________________________________________"
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_GFIOER_02, LP_GFIOER_02, EP_GFIOER_02
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 16
SCL_Generate_File_IO_Error_Report endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push 0
;push offset Project_Save_Dialog
;push hwnd   ;handle to the owner window
;push offset dialog_name
;push hInst
;call DialogBoxParamA
;;;Return values
;[eax] - 0 - Only close without button push
;[eax] - 1000 - Pressed [ Yes ] button
;[eax] - 1001 - Pressed [ Yes to all ] button
;[eax] - 1002 - Pressed [ No ] button
;[eax] - 1003 - Pressed [ No to all ] button
;[eax] - 1004 - Pressed [ Cancel ] button
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 