scan_command_line macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset command_line_file	;ebp+12
;push 0	;operation_type		;ebp+8
;call SCL_Scan_Command_Line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;; Scan and determine wheter command line file is specified
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Scan_Command_Line proc
push ebp
mov ebp,esp
;;;;Save specified window handle contents into specified file 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SCL_01, EP_SCL_01

mov eax,dword ptr [ebp]+8
mov operation_type_SCL_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SCL_01, LF_SCL_01, operation_type_SCL_01, LP_SCL_01, EP_SCL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Buffer
mov edi,dword ptr [ebp]+12
mov ecx,100
xor eax,eax
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Buffer

.DATA
current_module_command_line_address		dd 0
scan_command_line_error_code		dd 0
specified_command_line_length		dd 0
specified_command_line_increment		dd 0
CLS_file_name_start_address			dd 0
CLS_file_name_length			dd 0
CLS_extension				dd 0

.CODE
mov scan_command_line_error_code,0		;No Command line specified [Error code]
mov specified_command_line_increment,0

;;  Sent To Format   -->  "................MODULE NAME................"  command_line

call GetCommandLine
mov current_module_command_line_address,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Full Command Line Length
push 800						;string_length	;ebp+20
push 0						;find_byte		;ebp+16
push current_module_command_line_address		;scan_string	;ebp+12
call Find_Byte 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je end_scan_command_line
mov specified_command_line_length,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Full Command Line Length

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Escape Separators Before First Double Delimiter
push specified_command_line_length			;string_length		;ebp+28
push current_module_command_line_address		;offset string		;ebp+24
call Escape_Separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov scan_command_line_error_code,0			;No command Line Specified [Error code]
cmp eax,1
jne end_scan_command_line				;Jump IF String End Reached
mov specified_command_line_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Escape Separators Before First Double Delimiter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check IF First Symbol is Delimiter
mov eax,current_module_command_line_address
add eax,specified_command_line_increment

mov scan_command_line_error_code,4		;Absent first delimiter [Error code]
cmp byte ptr [eax],'"'
jne end_scan_command_line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check IF First Symbol is Delimiter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start  Try To Find Second Delimiter
inc specified_command_line_increment

mov ecx,specified_command_line_length
cmp  specified_command_line_increment,ecx
jae end_scan_command_line

mov ecx,specified_command_line_length
sub ecx,specified_command_line_increment

mov eax,current_module_command_line_address
add eax,specified_command_line_increment

xor ebx,ebx
mov bl,'"'

push ecx						;string_length	;ebp+20
push ebx						;find_byte		;ebp+16
push eax						;scan_string	;ebp+12
call Find_Byte 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov scan_command_line_error_code,5		;Absent second delimiter [Error code]
cmp eax,0
je end_scan_command_line			;Jump If Second Delimiter Not Found

inc ecx
mov scan_command_line_error_code,0		;No Command line specified [Error code]
add specified_command_line_increment,ecx

mov ecx,specified_command_line_length
cmp  specified_command_line_increment,ecx
jae end_scan_command_line			;Jump if String End Reached after Second delimiter. [ No command line specified ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End  Try To Find Second Delimiter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Escape delimiters After Second Double Delimiter
mov ecx,specified_command_line_length
sub ecx,specified_command_line_increment

mov eax,current_module_command_line_address
add eax,specified_command_line_increment

push ecx						;string_length		;ebp+28
push eax						;offset string		;ebp+24
call Escape_Separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov scan_command_line_error_code,0		;No Command line specified [Error code]
cmp eax,1
jne end_scan_command_line					;Jump IF String End Reached After Second Delimiter

add specified_command_line_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Escape delimiters After Second Double Delimiter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Specified Command Line File Name
mov scan_command_line_error_code,0		;No Command line specified [Error code]
mov ecx,specified_command_line_length
cmp  specified_command_line_increment,ecx
jae end_scan_command_line			;Jump IF String end reached After Second Double Delimiter

mov eax,current_module_command_line_address
add eax,specified_command_line_increment

xor ebx,ebx
mov bl,byte ptr [eax]
cmp bl,0
je end_scan_command_line 

mov ecx,specified_command_line_length
sub ecx,specified_command_line_increment

mov eax,current_module_command_line_address
add eax,specified_command_line_increment

mov CLS_file_name_length,ecx
mov CLS_file_name_start_address,eax

mov GCLFNP_file_name_length,ecx
mov GCLFNP_file_name_address,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Find command line

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Scan Specified File Name
.DATA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GET_CL_FILE_NAME_PARAMETERS label dword
		GCLFNP_file_name_length		dd 0					;0
		GCLFNP_file_name_address		dd 0					;4
		GCLFNP_full_file_name_length	dd 0				;8
		GCLFNP_specified_file_type		dd 0	;0 - Full file name	;1 - Only File name	;12
		GCLFNP_file_name_end_type		dd 0	;0 - End Found	;1 - End Not Found	;16
		GCLFNP_only_file_name_length	dd 0					;20
		GCLFNP_only_file_name_address	dd 0					;24
		GCLFNP_extension_specified_flag	dd 0					;28
		GCLFNP_only_extension_length	dd 0					;32
		GCLFNP_only_extension_address	dd 0					;36
		GCLFNP_extension_type		dd 0					;40
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE

push offset GET_CL_FILE_NAME_PARAMETERS		;ebp+8
call SC_Get_File_Name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Return values
;[eax] - (-1) - function busy
;[eax] - 0 - Function processed successfully
;[eax] - 1 - Specified filename too long, cannot find filename end
;[eax] - 2 - Specified Filename is invalid
;[eax] - 3 - Specified filename has null length 
;[eax] - 4 - Extension Point defined but extension is not [Extension point defined at file name end]
;[eax] - 5 - Extension too long [Error code]
;[eax] - 6 - File Name Absent. Cannot perform file name scan [Error code]

	;[ebx] - 0 - filename without extension
	;[ebx] - 1 - filename with .asm extension
	;[ebx] - 2 - filename with .inc extension
	;[ebx] - 3 - filename with .def extension
	;[ebx] - 4 - filename with .rc  extension
	;[ebx] - 5 - filename with .map extension
	;[ebx] - 6 - filename with .txt extension
	;[ebx] - 7 - filename with .bat extension
	;[ebx] - 8 - filename with .spl extension
	;[ebx] - 9 - filename with .apf extension
	;[ebx] - 10 - filename with unsupported extension
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov scan_command_line_error_code,6		;Specified filename has incorrect format [Error code]
cmp eax,0
jne end_scan_command_line			;Jump IF error

mov scan_command_line_error_code,2		;Add Existing File To Project

;;IF [GCLFNP_extension_type]  =  9  Then [scan_command_line_error_code] = 1 - Specified APF file
;;IF [GCLFNP_extension_type]  =  8  Then [scan_command_line_error_code] = 3  - Specified .spl file
;; All other Cases specified files which must be load as "Add Existing File To Project"    [scan_command_line_error_code] = 2 

cmp  GCLFNP_extension_type,9
sete al
ror eax,1
cdq
mov esi,1					; - Specified APF file
mov edi,scan_command_line_error_code
and esi,edx
not edx
and edi,edx
add esi,edi
mov scan_command_line_error_code,esi

cmp  GCLFNP_extension_type,8
sete al
ror eax,1
cdq
mov esi,3					; - Specified APF file
mov edi,scan_command_line_error_code
and esi,edx
not edx
and edi,edx
add esi,edi
mov scan_command_line_error_code,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Scan Specified File Name

mov edi,dword ptr [ebp]+12			;offset command_line_file
mov esi,CLS_file_name_start_address
mov ecx,CLS_file_name_length
rep movsb

end_scan_command_line:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SCL_01, LP_SCL_01, EP_SCL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,scan_command_line_error_code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Return 
;[eax] - (-1) - Function busy
	;[ebx] -  0  - No command Line Specified 
	;[ebx] -  1 -  Specified .APF file	
	;[ebx] -  2  -  File Which must be load as single file in project
	;[ebx] -  3  - Specified .spl file
	;[ebx] -  4  - Absent first delimiter [Error code]
	;[ebx] -  5  - Absent Second delimiter [Error code]
	;[ebx]  - 6  - Specified filename has incorrect format
	;[ebx]  - 7  - Specified file name has no extension
	;[ebx] -  8  - Specified file name has unsupported extension
;[esi]  - File full name address
;[ecx] - File full name length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,dword ptr [ebp]+12
mov ecx,CLS_file_name_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SCL_Scan_Command_Line endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm






