file_name_standard_operations macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push offset GET_FILE_NAME_PARAMETERS		;ebp+8
;call SC_Get_File_Name

SC_Get_File_Name proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;GET_FILE_NAME_PARAMETERS label dword
;		GFNP_file_name_length		dd 43					;0
;		GFNP_file_name_address		dd 0;offset file_name_string_for_check		;4
;		GFNP_full_file_name_length		dd 0					;8
;		GFNP_specified_file_type		dd 0	;0 - Full file name	;1 - Only File name	;12
;		GFNP_file_name_end_type		dd 0	;0 - End Found	;1 - End Not Found	;16
;		GFNP_only_file_name_length		dd 0					;20
;		GFNP_only_file_name_address	dd 0					;24
;		GFNP_extension_specified_flag	dd 0					;28
;		GFNP_only_extension_length		dd 0					;32
;		GFNP_only_extension_address	dd 0					;36
;		GFNP_extension_type		dd 0					;40
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GFN_01, EP_GFN_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+8			;offset GET_FILE_NAME_PARAMETERS

mov FNSP_file_name_end_type,0			;0 - End Found
mov get_file_name_internal_error_code,0
mov FNSP_extension_type,0
mov get_file_name_internal_error_code,3		;; Specified filename has null length [Error code]
cmp dword ptr [eax],0				;cmp dword ptr [ebp]+12,0
je end_get_file_name

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find specified filename end
.DATA
length_of_all_string				dd 0
;full_file_name_specified_flag			dd 0	;0 - Specified only file name	;1 - Specified full file name
get_file_name_internal_error_code		dd 0

FILE_NAME_WORD_PARAMETERS	 label dword
	file_name_string_max_length	dd 38
	file_name_string_address	dd 0  ;offset file_name_string_for_check
	full_file_name_length	dd 0	
	specified_file_type		dd 0	;0 - Full file name specified   ;1 - Only file name specified  ;2 - Unicode file type  ;3 - UNC file type ;4 - Defined relative file name
	drive_designator_present	dd 0	;0 - Drive designator not present	;1 - Drive designator present
	back_slash_count		dd 0	;20
	FNWP_double_point_count			dd 0		;24
	FNWP_back_slash_count_in_file_name_string	dd 0		;28
	FNWP_last_back_slash_offset		dd 0		;32
	FNWP_points_count_in_file_name		dd 0		;36
	FNWP_last_point_offset			dd 0		;40
	FNWP_extension_specified_flag		dd 0	;0 - Extension Not Specified ;1 - Extension Specified	;44
	FNWP_full_file_name_length			dd 0		;48

FNSP_specified_file_type				dd 0	;0 - Full file name	;1 - Only File name
FNSP_file_name_end_type				dd 0	;0 - End Found	;1 - End Not Found
FNSP_file_name_present_flag				dd 0	;0 - File name Absent 	;1 - File Name Present
FNSP_only_file_name_length				dd 0
FNSP_only_file_name_address			dd 0
FNSP_only_extension_length				dd 0
FNSP_only_extension_address			dd 0
FNSP_extension_type				dd 0

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Specified File Name String Length
mov eax,dword ptr [ebp]+8		;offset GET_FILE_NAME_PARAMETERS

mov ebx,dword ptr [eax]		;mov ebx,dword ptr [ebp]+12		;String length
xor edx,edx
mov eax,dword ptr [eax]+4		;offset file_name_string_for_check

push ebx				;string_length	;ebp+20
push edx				;find_byte		;ebp+16
push eax				;scan_string	;ebp+12
call Find_Byte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;[eax] = 1  byte found
;;;;[eax] = 0  byte not found
;	;;;[ecx] = length of string [from start to different byte]	
;	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
;	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov get_file_name_internal_error_code,1		;; Specified filename too long, cannot find filename end [Error code]

cmp eax,0
sete  al
ror eax,1;
cdq
mov esi,1
mov edi,0
and esi,edx
not edx
and edi,edx
add esi,edi
mov FNSP_file_name_end_type,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Specified File Name String Length
mov ebx,dword ptr [ebp]+8		;offset GET_FILE_NAME_PARAMETERS

mov eax,dword ptr [ebx]		;mov eax,dword ptr [ebp]+12			;string_length
mov length_of_all_string,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get File Name Parameters
mov ebx,dword ptr [ebp]+8		;offset GET_FILE_NAME_PARAMETERS

mov eax,dword ptr [ebx]+4		;mov eax,dword ptr [ebp]+8		;offset file_name_string_for_check
mov ebx,length_of_all_string

mov file_name_string_max_length,ebx
mov file_name_string_address,eax

push offset FILE_NAME_WORD_PARAMETERS
call SC_Get_Filename_Word
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy 
;[eax] -  0  - Function normal processed
;	[ebx] - 0 - Function successfully processed
;	[ebx] - 1 - Function error. Defined Unicode file format
;	[ebx] - 2 - Function error. Defined UNC file format
;	[ebx] - 3 - File name contains invalid characters.
;	[ebx] - 4 - File name has incorrect structure. Point specified before last backslash
;	[ebx] - 5 - File name has incorrect structure.  Double Point count is above  than 1
;	[ebx] - 6 - File name has incorrect structure. Defined backslash without double point
;	[ecx] - Full file Name length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov get_file_name_internal_error_code,2	;Specified Filename is invalid [Error code]
cmp ebx,0
jne end_get_file_name			;Jump IF Error

cmp FNWP_double_point_count,1
ja end_get_file_name

mov get_file_name_internal_error_code,3	;Specified Filename has null length. [Error code]
cmp FNWP_full_file_name_length,0

mov get_file_name_internal_error_code,0	;Function Process Successfully
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get File Name Parameters
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Get File Word Results
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Specified file type
;;IF [back_slash_count] = 0  Then SET   "DEFINED ONLY FILE NAME"

cmp FNWP_back_slash_count_in_file_name_string,0
sete al
ror eax,1
cdq
mov esi,1						;Defined Only file name
mov edi,0						;Defined Full file name
and esi,edx
not edx
and edi,edx
add esi,edi
mov FNSP_specified_file_type,esi			;0 - Full file name	;1 - Only File name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Specified file type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check File Name Present
;;IF [FNWP_back_slash_count_in_file_name_string] > 0  AND
;;    [FNWP_last_back_slash_offset]  = [FNWP_full_file_name_length] - 1 Then File Name Not Specified

xor eax,eax
xor ecx,ecx
cmp FNWP_back_slash_count_in_file_name_string,0
setne al

mov ebx,FNWP_full_file_name_length
dec ebx
cmp FNWP_last_back_slash_offset,ebx
sete cl
and ecx,eax
cmp ecx,1
sete al
ror eax,1
cdq
mov esi,0
mov edi,1
and esi,edx
not edx
and edi,edx
add esi,edi
mov FNSP_file_name_present_flag,esi

mov get_file_name_internal_error_code,6	;File Name Absent. Cannot perform file name scan [Error code]
cmp FNSP_file_name_present_flag,0
je end_get_file_name

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check File Name Present
;;;IF [FNWP_points_count_in_file_name] > 0  AND
;;[FNWP_last_point_offset]  = [FNWP_full_file_name_length] - 1 Then Extension Point Specified but extension Not [Error code]

xor eax,eax
xor ecx,ecx
cmp FNWP_points_count_in_file_name,0
setne al

mov ebx,FNWP_full_file_name_length			;37
dec ebx
cmp FNWP_last_point_offset,ebx			;36
sete cl
and ecx,eax
cmp ecx,1
sete al
ror eax,1
cdq
mov esi,0
mov edi,FNWP_extension_specified_flag
and esi,edx
not edx
and edi,edx
add esi,edi
mov FNWP_extension_specified_flag,esi

mov get_file_name_internal_error_code,3	;[Extension point defined at file name end] [Error code]
cmp ecx,1
je end_get_file_name

mov get_file_name_internal_error_code,0	;[Extension point defined at file name end] [Error code]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Get File Word Results

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Specified File Name Parameters
;FNSP_only_file_name_length				dd 0
;FNSP_only_file_name_address			dd 0

;;;;;;               [ FNSP_only_file_name_address ]  ---------->|
;;;;;;					        |<-------------------------->| ------ [ FNSP_only_file_name_length ]
;;;;;;   |<----------- [ FNWP_last_back_slash_offset  ] -------->|
;;;;;;   |<---------------------[ FNWP_full_file_name_length ]----------------------------------->|
;;;;;;   C:\-----------------------------------\--------------------------------------\------------------------.-----

;;;;;   [ FNSP_only_file_name_length ]


; [ FNWP_full_file_name_length - 1 ]   --- > Offset of Last Character
; [ FNWP_last_back_slash_offset ]     --- > Last Back Slash offset  

mov eax,FNWP_full_file_name_length		;37
dec eax					;36
sub eax,FNWP_last_back_slash_offset		;24
mov FNSP_only_file_name_length,eax

mov ebx,dword ptr [ebp]+8		;offset GET_FILE_NAME_PARAMETERS

mov eax,FNWP_last_back_slash_offset
inc eax
add eax,dword ptr [ebx]+4			;add eax,dword ptr [ebp]+8			;offset file_name
mov FNSP_only_file_name_address,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Specified File Name Parameters

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Extension 
cmp  FNWP_extension_specified_flag,0
je extension_not_specified

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Extension Parameters
;;;;;;;;;;;					               |<-->|------- [ FNSP_only_extension_length ]
;;;;;;;; |<---------------------[ FNWP_last_point_offset ]------------------>|
;;;;;;;; |<--------------[ FNWP_full_file_name_length ]----------------------->|
;;;;;;   C:\---------------------------\----------------------------\------------------------.-----

mov eax,FNWP_full_file_name_length		;37
dec eax					;36
sub eax,FNWP_last_point_offset		;24
mov FNSP_only_extension_length,eax

mov ebx,dword ptr [ebp]+8		;offset GET_FILE_NAME_PARAMETERS

mov eax,FNWP_last_point_offset
inc eax
add eax,dword ptr [ebx]+4			;add eax,dword ptr [ebp]+8			;offset file_name
mov FNSP_only_extension_address,eax

mov get_file_name_internal_error_code,5	;Extension too long [Error code]
cmp FNSP_only_extension_length,400
jae end_get_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Extension Parameters
mov FNSP_extension_type,0				;filename without extension

push FNSP_only_extension_length			;extension_length		;ebp+12
push FNSP_only_extension_address			;extension		;ebp+8
call SC_Check_Extension
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ecx] - 0 - Extension check Successfuly
;[ecx] - 1 - Extension Too long. Cannot check extension [Error code]
		;[ebx] - 0 - filename without extension
		;[ebx] - 1 - filename with .asm extension
		;[ebx] - 2 - filename with .inc extension
		;[ebx] - 3 - filename with .def extension
		;[ebx] - 4 - filename with .rc  extension
		;[ebx] - 5 - filename with .map extension
		;[ebx] - 6 - filename with .txt extension
		;[ebx] - 7 - filename with .bat extension
		;[ebx] - 10 - filename with unsupported extension
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov FNSP_extension_type,ebx

extension_not_specified:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Extension 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov get_file_name_internal_error_code,0
end_get_file_name:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LP_GFN_01:
mov BF_GFN_01,0
EP_GFN_01: 

mov ebx,dword ptr [ebp]+8		;offset GET_FILE_NAME_PARAMETERS
mov eax,FNWP_full_file_name_length
mov dword ptr [ebx]+8,eax		;GFNP_full_file_name_length
mov eax,FNSP_specified_file_type
mov dword ptr [ebx]+12,eax
mov eax,FNSP_file_name_end_type
mov dword ptr [ebx]+16,eax
mov eax,FNSP_only_file_name_length
mov dword ptr [ebx]+20,eax
mov eax,FNSP_only_file_name_address
mov dword ptr [ebx]+24,eax
mov eax,FNWP_extension_specified_flag
mov dword ptr [ebx]+28,eax
mov eax,FNSP_only_extension_length
mov dword ptr [ebx]+32,eax
mov eax,FNSP_only_extension_address
mov dword ptr [ebx]+36,eax
mov eax,FNSP_extension_type
mov dword ptr [ebx]+40,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;GET_FILE_NAME_PARAMETERS label dword
;		GFNP_file_name_length		dd 43					;0
;		GFNP_file_name_address		dd 0;offset file_name_string_for_check		;4
;		GFNP_full_file_name_length		dd 0					;8
;		GFNP_specified_file_type		dd 0	;0 - Full file name	;1 - Only File name	;12
;		GFNP_file_name_end_type		dd 0	;0 - End Found	;1 - End Not Found	;16
;		GFNP_only_file_name_length		dd 0					;20
;		GFNP_only_file_name_address	dd 0					;24
;		GFNP_extension_specified_flag	dd 0					;28
;		GFNP_only_extension_length		dd 0					;32
;		GFNP_only_extension_address	dd 0					;36
;		GFNP_extension_type		dd 0					;40
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,get_file_name_internal_error_code
mov ebx,FNSP_extension_type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Return values
;[eax] - (-1) - function busy
;[eax] - 0 - Function processed successfully
;[eax] - 1 - Specified filename too long, cannot find filename end
;[eax] - 2 - Specified Filename is invalid
;[eax] - 3 - Specified filename has null length 
;[eax] - 4 - Extension Point defined but extension is not [Extension point defined at file name end]
;[eax] - 5 - Extension too long [Error code]
;[eax] - 6 - File Name Absent. Cannot perform file name scan [Error code]
	;[ebx] - 0 - filename without extension
	;[ebx] - 1 - filename with .asm extension
	;[ebx] - 2 - filename with .inc extension
	;[ebx] - 3 - filename with .def extension
	;[ebx] - 4 - filename with .rc  extension
	;[ebx] - 5 - filename with .map extension
	;[ebx] - 6 - filename with .txt extension
	;[ebx] - 7 - filename with .bat extension
	;[ebx] - 10 - filename with unsupported extension
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 4
SC_Get_File_Name endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push string_length			;ebp+12
;push string_address			;ebp+8
;call SC_Convert_Into_Lowercase

SC_Convert_Into_Lowercase proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CIL_01, EP_CIL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
lowercase_convert_counter			dd 0
lowercase_convert_flag				dd 0
.CODE

mov lowercase_convert_flag,0		;Initially set count of converted flag to null
mov lowercase_convert_counter,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert into lowercase
start_convert_into_lowercase:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;UPPERCASE CODES	--> [ 65 - 90  ]
;LOWERCASE CODES	--> [ 97 - 122 ]

;;;;;;;;;; Substraction --> 32
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ebx,ebx
mov eax,dword ptr [ebp]+8		;string address
add eax,lowercase_convert_counter

;;Check_Location_Within_Boundaries macro Min, Value, Max ;[EAX] - 1 True	[EAX] - 0 False

mov bl,byte ptr [eax]
Check_Location_Within_Boundaries  65, ebx, 90 ;[EAX] - 1 True	[EAX] - 0 False

xor edx,edx
mov ecx,dword ptr [ebp]+8		;string address
add ecx,lowercase_convert_counter
mov dl,byte ptr [ecx]
mov esi,edx
mov edi,edx
add esi,32

xchg eax,ebx
xor eax,eax
cmp ebx,1
sete al
add lowercase_convert_flag,eax

ror eax,1
cdq
and esi,edx
not edx
and edi,edx
add esi,edi
mov eax,esi

mov ecx,dword ptr [ebp]+8		;string length
add ecx,lowercase_convert_counter
mov byte ptr [ecx],al
;;;;ADD 32 if eax 1 else no

inc lowercase_convert_counter
mov eax,dword ptr [ebp]+12		;string length
cmp lowercase_convert_counter,eax
jb start_convert_into_lowercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert into lowercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CIL_01, LP_CIL_01, EP_CIL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov ebx,lowercase_convert_flag

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy 
;[eax] -  0  - Function normal processed
	;[ebx] - count of converted bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Convert_Into_Lowercase endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push string_length			;ebp+12
;push string_address			;ebp+8
;call SC_Convert_Into_Uppercase

SC_Convert_Into_Uppercase proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CIU_01, EP_CIU_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA

uppercase_convert_counter			dd 0
uppercase_convert_flag				dd 0
.CODE

mov uppercase_convert_flag,0		;Initially set count of converted flag to null
mov uppercase_convert_counter,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert into lowercase
start_convert_into_uppercase:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;UPPERCASE CODES	--> [ 65 - 90  ]
;LOWERCASE CODES	--> [ 97 - 122 ]

;;;;;;;;;; Substraction --> 32
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ebx,ebx
mov eax,dword ptr [ebp]+8		;string address
add eax,uppercase_convert_counter

;;Check_Location_Within_Boundaries macro Min, Value, Max ;[EAX] - 1 True	[EAX] - 0 False

mov bl,byte ptr [eax]
Check_Location_Within_Boundaries  97, ebx, 122 ;[EAX] - 1 True	[EAX] - 0 False

xor edx,edx
mov ecx,dword ptr [ebp]+8		;string address
add ecx,uppercase_convert_counter
mov dl,byte ptr [ecx]
mov esi,edx
mov edi,edx
sub esi,32

xchg eax,ebx
xor eax,eax
cmp ebx,1
sete al
add uppercase_convert_flag,eax

ror eax,1
cdq
and esi,edx
not edx
and edi,edx
add esi,edi
mov eax,esi

mov ecx,dword ptr [ebp]+8		;string length
add ecx,uppercase_convert_counter
mov byte ptr [ecx],al
;;;;ADD 32 if eax 1 else no

inc uppercase_convert_counter
mov eax,dword ptr [ebp]+12		;string length
cmp uppercase_convert_counter,eax
jb start_convert_into_uppercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert into lowercase



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CIU_01, LP_CIU_01, EP_CIU_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,uppercase_convert_flag
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy 
;[eax] -  0  - Function normal processed
	;[ebx] - count of converted bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Convert_Into_Uppercase endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push offset FILE_NAME_WORD_PARAMETERS
;call SC_Get_Filename_Word

SC_Get_Filename_Word proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GFW_01  , EP_GFW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
.DATA
get_file_name_word_increment	dd 0
get_file_word_error_flag		dd 0
last_back_slash_offset		dd 0
last_point_offset			dd 0
double_point_count		dd 0
current_symbol_in_file_name_string	dd 0
back_slash_count_in_file_name_string	dd 0
points_count_in_file_name		dd 0
extension_specified_flag		dd 0	;0 - Extension Not Specified ;1 - Extension Specified

;FILE_NAME_WORD_PARAMETERS	 label dword
;	file_name_string_max_length	dd 0					;0
;	file_name_string_address	dd offset file_name_string_for_check		;4
;	full_file_name_length	dd 0					;8
;	specified_file_type		dd 0	;0 - Full file name specified  ;1 - Only file name specified  ;2 - Unicode file type	;12
;	drive_designator_present	dd 0	;0 - Drive designator not present	;1 - Drive designator present		;16
;	back_slash_count		dd 0		;20

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Initially Set Parameters
mov double_point_count,0
mov last_back_slash_offset,0
mov last_point_offset,0
mov get_file_word_error_flag,0		;Function successfully processed [Error code]
mov get_file_name_word_increment,0
mov back_slash_count_in_file_name_string,0
mov points_count_in_file_name,0
mov extension_specified_flag,0

mov eax,dword ptr [ebp]+8			;offset FILE_NAME_WORD_PARAMETERS
mov dword ptr [eax]+8,0			;full_file_name_length
mov dword ptr [eax]+12,0			;specified_file_type
mov dword ptr [eax]+16,0			;drive_designator_present
mov dword ptr [eax]+20,0			;back_slash_count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Initially Set Parameters
mov eax,dword ptr [ebp]+8			;offset FILE_NAME_WORD_PARAMETERS
mov ebx,dword ptr [eax]			;file_name_string_max_length
cmp ebx,0
je function_process_error_point
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Whether first symbol is "\"
xor eax,eax
mov ebx,dword ptr [ebp]+8		;offset FILE_NAME_WORD_PARAMETERS
mov ecx,dword ptr [ebx]+4		;file_name_string_address
add ecx,get_file_name_word_increment

;;; Check for format -->  "\..................\......................\...................."

mov al,byte ptr [ecx]
cmp al,'\'
setne byte ptr [ebx]+16
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Whether first symbol is "\"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Whether first symbol is ".."
xor eax,eax
mov ebx,dword ptr [ebp]+8		;offset FILE_NAME_WORD_PARAMETERS
mov ecx,dword ptr [ebx]		;file_name_string_max_length
cmp ecx,2
jb no_check_file_name_for_relative_path

;;; Check for format -->  "..\..................\......................\...................."

mov edx,dword ptr [ebx]+4		;Offset file name
mov ax,word ptr [edx]
cmp ax,".."
jne no_check_file_name_for_relative_path

mov ebx,dword ptr [ebp]+8			;offset FILE_NAME_WORD_PARAMETERS
mov dword ptr [ebx]+12,4			;;4 - Defined relative file name

jmp function_process_error_point
no_check_file_name_for_relative_path:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Whether first symbol is ".."
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Whether file name defined in unicode
xor eax,eax
mov ebx,dword ptr [ebp]+8		;offset FILE_NAME_WORD_PARAMETERS
mov ecx,dword ptr [ebx]		;file_name_string_max_length
cmp ecx,8
jb no_check_file_name_for_UNC

;\\?\UNC\

;;; Check for format -->  "\\?\UNC\..................\......................\...................."

xor edx,edx
xor ecx,ecx

mov edx,dword ptr [ebx]+4		;Offset file name
mov eax,dword ptr [edx]
cmp eax,"\?\\"
sete bl
mov eax,dword ptr [edx]+4
cmp eax,"\CNU"
sete cl
and ebx,ecx
cmp ebx,1
jne no_check_file_name_for_UNC

mov ebx,dword ptr [ebp]+8			;offset FILE_NAME_WORD_PARAMETERS
mov dword ptr [ebx]+12,3			;;3 - UNC type	;specified_file_type
mov get_file_word_error_flag,2		;Function error. Defined UNC file format [Error code]

jmp function_process_error_point
no_check_file_name_for_UNC:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Whether file name defined in unicode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Whether file name defined in unicode
xor eax,eax
mov ebx,dword ptr [ebp]+8		;offset FILE_NAME_WORD_PARAMETERS
mov ecx,dword ptr [ebx]		;file_name_string_max_length
cmp ecx,4
jb no_check_file_name_for_unicode

;;; Check for format -->  "\\?\C:\..................\......................\...................."

mov edx,dword ptr [ebx]+4		;Offset file name
mov eax,dword ptr [edx]
cmp eax,"\?\\"
jne no_check_file_name_for_unicode

mov dword ptr [ebx]+12,2			;;2 - Unicode file type	;specified_file_type
mov get_file_word_error_flag,1		;Function error. Defined Unicode file format [Error code]

jmp function_process_error_point
no_check_file_name_for_unicode:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Whether file name defined in unicode

;mov ebx,dword ptr [ebp]+8			;offset FILE_NAME_WORD_PARAMETERS
;mov dword ptr [ebx]+12,3			;;3 - UNC type	;specified_file_type
;mov get_file_word_error_flag,2		;Function error. Defined UNC file format [Error code]

;;; Check for format -->  "\\?\C:\..................\......................\...................."	[Error case] [Unicode file type]
;;; Check for format -->  "\\?\UNC\..................\......................\...................."	[Error case] [ UNC file type ]
;;; Check for format -->  "\..................\......................\...................."		[Not errror case][ Drive designator not present ]
;;; Check for format -->  "..\..................\......................\...................."		[Not error case][ Defined relative file name ]

mov get_file_word_error_flag,4		;File Name Has Incorrect Structure [Error code]
xor eax,eax
mov ebx,dword ptr [ebp]+8		;offset FILE_NAME_WORD_PARAMETERS
mov ecx,dword ptr [ebx]+4		;file_name_string_address
mov al,byte ptr [ecx]
cmp al,"."
je function_process_error_point
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Scan File Name String
start_get_file_name_word:

xor eax,eax
mov ebx,dword ptr [ebp]+8		;offset FILE_NAME_WORD_PARAMETERS
mov ecx,dword ptr [ebx]+4		;file_name_string_address
add ecx,get_file_name_word_increment

mov get_file_word_error_flag,0		;Function successfully processed  [Error code]

mov al,byte ptr [ecx]
mov byte ptr current_symbol_in_file_name_string,al

cmp al,20h			;Space 
je end_get_file_name_word
cmp al,09h 			;Tab
je end_get_file_name_word
cmp al,0 
je end_get_file_name_word
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Not Allowed Chars
mov get_file_word_error_flag,3		;Function contains not allowed characters  [Error code]
cmp al,"|" 
je function_process_error_point		;Error Jump 
cmp al,">" 
je function_process_error_point		;Error Jump
cmp al,"<" 
je function_process_error_point		;Jump on error condition
cmp al,'"'
je function_process_error_point
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Not Allowed Chars
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Increment BackSlash Count
cmp byte ptr current_symbol_in_file_name_string,"\"	;Backslash
sete al
ror eax,1
cdq
mov esi,back_slash_count_in_file_name_string
inc esi
mov edi,back_slash_count_in_file_name_string
and esi,edx
not edx
and edi,edx
add esi,edi
mov back_slash_count_in_file_name_string,esi
not edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Increment BackSlash Count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Last Back Slash Address 
mov esi,get_file_name_word_increment
mov edi,last_back_slash_offset
and esi,edx
not edx
and edi,edx
add esi,edi
mov last_back_slash_offset,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Last Back Slash Address 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Double Point Count
cmp byte ptr current_symbol_in_file_name_string,":"		;Double Point
sete al
ror eax,1
cdq
mov esi,double_point_count
inc esi
mov edi,double_point_count
and esi,edx
not edx
and edi,edx
add esi,edi
mov double_point_count,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Double Point Count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Last Point Offset
cmp byte ptr current_symbol_in_file_name_string,"."		;Point
sete al
ror eax,1
cdq
mov esi,get_file_name_word_increment
mov edi,last_point_offset
and esi,edx
not edx
and edi,edx
add esi,edi
mov last_point_offset,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Last Point Offset
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Double Point Count
cmp byte ptr current_symbol_in_file_name_string,"."		;Double Point
sete al
ror eax,1
cdq
mov esi,points_count_in_file_name
inc esi
mov edi,points_count_in_file_name
and esi,edx
not edx
and edi,edx
add esi,edi
mov points_count_in_file_name,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Double Point Count
;last_back_slash_offset		dd 0
;last_point_offset			dd 0
;double_point_count		dd 0
;

inc get_file_name_word_increment
mov eax,dword ptr [ebp]+8			;offset FILE_NAME_WORD_PARAMETERS
mov ebx,dword ptr [eax]			;file_name_string_max_length
cmp get_file_name_word_increment,ebx
jb start_get_file_name_word

mov get_file_word_error_flag,0		;Function successfully processed  [Error code]

end_get_file_name_word:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Scan File Name String


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Determine Wheteter extension is present
;IF [last_point_offset] = 0 or [last_point_offset] = [get_file_name_word_increment]
;Then Extension Not Specified

xor eax,eax
cmp last_point_offset,0
sete al		;Set 1 if  [last_point_offset] not equal to 0

xor ecx,ecx;
mov ebx,last_point_offset
cmp get_file_name_word_increment,ebx
sete cl
or eax,ecx
cmp eax,1
setne byte ptr [extension_specified_flag]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Determine Wheteter extension is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Determine Wheteter extension point is defined not correct
mov get_file_word_error_flag,4		;File name has incorrect structure. Point specified before last backslash [Error code]

;IF [last_point_offset] = 0 Then No perform any extension check
;IF [last_point_offset] < [last_back_slash_offset] Then file name has incorrect structure

cmp last_point_offset,0
je no_check_extension_valid_state

mov eax,last_back_slash_offset
cmp last_point_offset,eax
jb function_process_error_point

no_check_extension_valid_state:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Determine Wheteter extension point is defined not correct
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov get_file_word_error_flag,5		;File name has incorrect structure. Double Point count is above than 1 [Error code]
;; IF [double_point_count] > 1  Then File Name Structure defined incorrect
cmp double_point_count,1
ja function_process_error_point
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov get_file_word_error_flag,6		;File name has incorrect structure. Defined backslash without double point [Error code]
;;IF [back_slash_count_in_file_name_string] > 1 AND  [double_point_count] =  0 Then  Specified file name has incorrect structure

xor eax,eax
xor ebx,ebx
cmp back_slash_count_in_file_name_string,1
seta al

cmp double_point_count,0
sete bl
and eax,ebx
cmp eax,1
je function_process_error_point
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;cmp double_point_count,1
;;IF [back_slash_count_in_file_name_string] > = 1 AND [double_point_count] >  1
;get_file_word_error_flag		dd 0
;double_point_count		dd 0
;back_slash_count_in_file_name_string	dd 0
;last_back_slash_offset		dd 0
;points_count_in_file_name		dd 0
;last_point_offset			dd 0
;extension_specified_flag		dd 0	;0 - Extension Not Specified ;1 - Extension Specified

mov get_file_word_error_flag,0		;Function successfully processed  [Error code]
function_process_error_point:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_GFW_01, LP_GFW_01, EP_GFW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,dword ptr [ebp]+8	;offset FILE_NAME_WORD_PARAMETERS
mov ecx,double_point_count
mov dword ptr [ebx]+24,ecx

mov ecx,back_slash_count_in_file_name_string
mov dword ptr [ebx]+28,ecx

mov ecx,last_back_slash_offset
mov dword ptr [ebx]+32,ecx

mov ecx,points_count_in_file_name
mov dword ptr [ebx]+36,ecx

mov ecx,last_point_offset
mov dword ptr [ebx]+40,ecx

mov ecx,extension_specified_flag
mov dword ptr [ebx]+44,ecx

mov ecx,get_file_name_word_increment
mov dword ptr [ebx]+48,ecx

mov ebx,get_file_word_error_flag

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy 
;[eax] -  0  - Function normal processed
;	[ebx] - 0 - Function successfully processed
;	[ebx] - 1 - Function error. Defined Unicode file format
;	[ebx] - 2 - Function error. Defined UNC file format
;	[ebx] - 3 - File name contains invalid characters.
;	[ebx] - 4 - File name has incorrect structure. Point specified before last backslash
;	[ebx] - 5 - File name has incorrect structure.  Double Point count is above  than 1
;	[ebx] - 6 - File name has incorrect structure. Defined backslash without double point
;	[ecx] - Full file Name length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;get_file_word_error_flag		dd 0
;double_point_count		dd 0
;back_slash_count_in_file_name_string	dd 0
;last_back_slash_offset		dd 0
;points_count_in_file_name		dd 0
;last_point_offset			dd 0
;extension_specified_flag		dd 0	;0 - Extension Not Specified ;1 - Extension Specified

mov esp,ebp
pop ebp
ret 4
SC_Get_Filename_Word endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push extension_length		;ebp+12
;push offset extension		;ebp+8
;call SC_Check_Extension

SC_Check_Extension proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CE_01  , EP_CE_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
CE_extension_type			dd 0
CE_specified_extension		db 400 dup (0)
CE_extension_internal_error_code	dd 0
.CODE

mov CE_extension_internal_error_code,1			;Extension Too long. Cannot check extension [Error code]
cmp dword ptr [ebp]+12,400
jae end_check_extension

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer extension
mov ecx,dword ptr [ebp]+12			;extension_length
mov esi,dword ptr [ebp]+8			;extension_start_address
mov edi,offset CE_specified_extension
cld
rep movsb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer extension
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert extension into lowercase
start_convert_extension_for_type_determining:
push dword ptr [ebp]+12				;extension_length				;ebp+12
push offset CE_specified_extension			;ebp+8
call SC_Convert_Into_Lowercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - (-1) - Function busy 
;;[eax] -  0  - Function normal processed
;	;[ebx] - count of converted bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_convert_extension_for_type_determining
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert extension into lowercase

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine extension type
.DATA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Supported extension types
asm_extension		db 'asm'		;Extension code - 1 
inc_extension		db 'inc'		;Extension code - 2
def_extension		db 'def'		;Extension code - 3
rc_extension		db 'rc '		;Extension code - 4
map_extension		db 'map'		;Extension code - 5
txt_extension		db 'txt'		;Extension code - 6
bat_extension		db 'bat'		;Extension code - 7
spl_extension		db 'spl'		;Extension code - 8
apf_extension		db 'apf'		;Extension code - 9
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Supported extension types
.CODE
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 1
push 3 ;dword ptr [ebp]+12		;extension_length			;ebp+24
push offset asm_extension		;Second_string		;ebp+20
push offset CE_specified_extension	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_1_determining

mov CE_extension_type,1
jmp end_of_extension_determining
end_of_extension_1_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 2
push 3 ;dword ptr [ebp]+12		;extension_length			;ebp+24
push offset inc_extension		;Second_string		;ebp+20
push offset CE_specified_extension	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_2_determining

mov CE_extension_type,2
jmp end_of_extension_determining
end_of_extension_2_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 3
push 3 ;dword ptr [ebp]+12		;extension_length			;ebp+24
push offset def_extension		;Second_string		;ebp+20
push offset CE_specified_extension	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_3_determining

mov CE_extension_type,3
jmp end_of_extension_determining
end_of_extension_3_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 4
push 2 ;dword ptr [ebp]+12		;extension_length			;ebp+24
push offset rc_extension		;Second_string		;ebp+20
push offset CE_specified_extension	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_4_determining

mov CE_extension_type,4
jmp end_of_extension_determining
end_of_extension_4_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 5
push 3;dword ptr [ebp]+12		;extension_length			;ebp+24
push offset map_extension		;Second_string		;ebp+20
push offset CE_specified_extension	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_5_determining

mov CE_extension_type,5
jmp end_of_extension_determining
end_of_extension_5_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 6
push 3 ;dword ptr [ebp]+12		;extension_length			;ebp+24
push offset txt_extension		;Second_string		;ebp+20
push offset CE_specified_extension	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_6_determining

mov CE_extension_type,6
jmp end_of_extension_determining
end_of_extension_6_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 7
push 3 ;dword ptr [ebp]+12		;extension_length			;ebp+24
push offset bat_extension		;Second_string		;ebp+20
push offset CE_specified_extension	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_7_determining

mov CE_extension_type,7
jmp end_of_extension_determining
end_of_extension_7_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 8
push 3 ;dword ptr [ebp]+12		;extension_length			;ebp+24
push offset spl_extension		;Second_string		;ebp+20
push offset CE_specified_extension	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_8_determining

mov CE_extension_type,8
jmp end_of_extension_determining
end_of_extension_8_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for extension 9
push 3 ;dword ptr [ebp]+12		;extension_length			;ebp+24
push offset apf_extension		;Second_string		;ebp+20
push offset CE_specified_extension	;First_string		;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] = 1 Strings are similar
;;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je end_of_extension_9_determining

mov CE_extension_type,9
jmp end_of_extension_determining
end_of_extension_9_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for extension 9

mov CE_extension_type,10

end_of_extension_determining:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine extension type


end_check_extension:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CE_01, LP_CE_01, EP_CE_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov ecx,CE_extension_internal_error_code
mov ebx,CE_extension_type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ecx] - 0 - Extension check Successfuly
;[ecx] - 1 - Extension Too long. Cannot check extension [Error code]
		;[ebx] - 0 - filename without extension
		;[ebx] - 1 - filename with .asm extension
		;[ebx] - 2 - filename with .inc extension
		;[ebx] - 3 - filename with .def extension
		;[ebx] - 4 - filename with .rc  extension
		;[ebx] - 5 - filename with .map extension
		;[ebx] - 6 - filename with .txt extension
		;[ebx] - 7 - filename with .bat extension
		;[ebx] - 8 - filename with .spl extension
		;[ebx] - 9 - filename with .apf extension
		;[ebx] - 10 - filename with unsupported extension
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Check_Extension endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push  FNL_Item Number
;push extension_type		;ebp+8
;call SC_Form_According_Show_Code

SC_Form_According_Show_Code proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_FASC_01  , EP_FASC_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
FASC_text_color_status_number		dd 0
FASC_background_color_status_number	dd 0
FASC_complete_show_code			dd 0
.CODE
mov FASC_complete_show_code,0
mov FASC_text_color_status_number,0
mov FASC_background_color_status_number,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Status word structure 
;;Bytes 			Description
;;  0				  Arrow status [ 0 ] - arrow not show  [ 1 ] - arrow shows
;;  1				  Text color status number
;;  2				  Background color status number
;;  3				  Reserved
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; IF [extension_type] = 0 Then 
;;;;			[FASC_text_color_status_number] = 7
;;;;			[FASC_background_color_status_number] = 7

cmp dword ptr [ebp]+8,0	;extension_type
sete al
ror eax,1
cdq
mov esi,7
mov edi,FASC_text_color_status_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov FASC_text_color_status_number,esi
not edx

mov esi,7
mov edi,FASC_background_color_status_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov FASC_background_color_status_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; IF [extension_type] = 1 Then 
;;;;			[FASC_text_color_status_number] = 3
;;;;			[FASC_background_color_status_number] = 2

cmp dword ptr [ebp]+8,1	;extension_type
sete al
ror eax,1
cdq
mov esi,3
mov edi,FASC_text_color_status_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov FASC_text_color_status_number,esi
not edx

mov esi,2
mov edi,FASC_background_color_status_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov FASC_background_color_status_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; IF [extension_type] >=2  AND  [extension_type] < = 6  Then 
;;;;			[FASC_text_color_status_number] = 3
;;;;			[FASC_background_color_status_number] = 0

xor ecx,ecx
xor ebx,ebx
cmp dword ptr [ebp]+8,2	;extension_type
setae cl

cmp dword ptr [ebp]+8,6	;extension_type
setbe bl
and ecx,ebx
cmp ecx,1
sete al
ror eax,1
cdq
mov esi,3
mov edi,FASC_text_color_status_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov FASC_text_color_status_number,esi
not edx

mov esi,0
mov edi,FASC_background_color_status_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov FASC_background_color_status_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; IF [extension_type] >=7 Then 
;;;;			[FASC_text_color_status_number] = 3
;;;;			[FASC_background_color_status_number] = 6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp dword ptr [ebp]+8,7	;extension_type
setae al
ror eax,1
cdq
mov esi,3
mov edi,FASC_text_color_status_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov FASC_text_color_status_number,esi
not edx

mov esi,6
mov edi,FASC_background_color_status_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov FASC_background_color_status_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; IF [extension_type] = 0 Then 
;;;;			[FASC_text_color_status_number] = 7
;;;;			[FASC_background_color_status_number] = 7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; IF [extension_type] = 1 Then 
;;;;			[FASC_text_color_status_number] = 3
;;;;			[FASC_background_color_status_number] = 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; IF [extension_type] >=2  OR  [extension_type] < = 6  Then 
;;;;			[FASC_text_color_status_number] = 3
;;;;			[FASC_background_color_status_number] = 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; IF [extension_type] >=7 Then 
;;;;			[FASC_text_color_status_number] = 3
;;;;			[FASC_background_color_status_number] = 6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Background Color
;	      Bytes								File Type Code
;		0          Text         Background       FNL  Item Number
;		0	1		2		3
;[   ] -->		0	7		7		-		;0
;[ASM] --> 	0	3		2		-		;1
;[INC] -->		0	3		0		-		;2 - 6
;[BAT] -->		0	3		6		-		;7 - 10 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,0								;Byte 0
mov ebx,FASC_text_color_status_number					;Byte 1
mov ecx,FASC_background_color_status_number					;Byte 2
mov edx,dword ptr [ebp]+12				;FNL_Item Number		;Byte 3

ror eax,8
mov al,bl
ror eax,8
mov al,cl
ror eax,8
mov al,dl
ror eax,8
mov FASC_complete_show_code,eax

;[ebx] - 0 - filename without extension
;[ebx] - 1 - filename with .asm extension
;[ebx] - 2 - filename with .inc extension
;[ebx] - 3 - filename with .def extension
;[ebx] - 4 - filename with .rc  extension
;[ebx] - 5 - filename with .map extension
;[ebx] - 6 - filename with .txt extension
;[ebx] - 7 - filename with .bat extension
;[ebx] - 8 - filename with .spl extension
;[ebx] - 9 - filename with .apf extension
;[ebx] - 10 - filename with unsupported extension
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_FASC_01, LP_FASC_01, EP_FASC_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,FASC_complete_show_code

;;;;;;[ebx] - formed show code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Form_According_Show_Code endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

endm 


