F_list_add_remove_operations macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset COLOR_HANDLES_ARRAY	;ebp+32
;push 000000100000001100000000b		;ebp+28		;Used only high 3 bytes of status word
;push add_item_text_length		;ebp+24
;push offset  text_to_add		;ebp+20
;push add_position			;ebp+16
;push offset LIST_CONTENTS		;ebp+12
;push operation_type			;ebp+8
;call SCL_Add_File_List_Item		;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Add_File_List_Item proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_003, EP_003 

mov eax,dword ptr [ebp]+8
mov operation_type_003,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_003, LF_003, operation_type_003, LP_003, EP_003 

.DATA
add_file_internal_error_code	dd 0
.CODE

mov add_file_internal_error_code,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Lock List Draw for Item Add
start_lock_for_list_add:

push 0	;offset COLOR_HANDLES_ARRAY		;ebp+28
push 0	;memory_dc
push 0	;list_font_handle		;ebp+24
push 0	;offset LIST_CONTENTS		;ebp+16
push 0	;dword ptr [ebp]+8		;child_file_list_handle				;ebp+12
push 3	;operation_type			;ebp+8
call SCL_Draw_List_On_Window		;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_lock_for_list_add
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Lock List Draw for Item Add
mov ebx,1				;List items count above than 24. Cannot add item [Error code]
mov eax,dword ptr [ebp]+12		;mov eax,offset LIST_CONTENTS
mov ecx,dword ptr [eax]			;List_Items_Count
cmp ecx,36
jae end_set_list_parameters		;Jump if List items count is too large. [Above than 24 items]

mov ebx,2				;Add item position is above than [List_Items_Count]+1	[Error code]
mov eax,dword ptr [ebp]+12		;mov eax,offset LIST_CONTENTS
mov ecx,dword ptr [eax]			;List_Items_Count
inc ecx
mov ebx,dword ptr [ebp]+16		;add_position
cmp ebx,ecx
ja end_set_list_parameters		;Jump if Add item position is above than [List_Items_Count]+1

mov ebx,3				;Specified add position is null.	[Error code]
mov edx,dword ptr [ebp]+16		;add_position
cmp edx,0
je end_set_list_parameters		;Jump if specified add position is null
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start enlarge list
mov eax,dword ptr [ebp]+12		;mov eax,offset LIST_CONTENTS
cmp dword ptr [eax],0			;List_Items_Count
je end_enlarge_list_for_add		;Jump if List_Items_Count is null and there are no reason to enlarge list

mov eax,dword ptr [ebp]+12		;mov eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]			;List_Items_Count
mov ecx,dword ptr [ebp]+16		;add_position
sub ebx,ecx
rol ebx,3				;Mul 8		;in [ebx] - count of dwords to shift 
add ebx,8				;Add optional LIST_ITEM size in dwords 

mov ecx,ebx

mov edi,dword ptr [ebp]+12		;mov edi,offset LIST_CONTENTS
mov edi,dword ptr [edi]			;List_Items_Count
dec edi
mov eax,32				;List One Item size
mul edi

add eax,20				;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+12		;add eax,offset LIST_CONTENTS
add eax,28				;Add List_one_Item_size - 4  [ 32 - 4 ] = 28
mov esi,eax

mov edi,esi
add edi,32

std
rep movsd
cld

end_enlarge_list_for_add:

mov eax,dword ptr [ebp]+12		;mov eax,offset LIST_CONTENTS
inc dword ptr [eax]			;List_Items_Count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End enlarge list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Status word
mov ecx,dword ptr [ebp]+16		;add_position
dec ecx
mov eax,32				;List one item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+12		;add eax,offset LIST_CONTENTS

mov ecx,dword ptr [ebp]+28
mov dword ptr [eax]+28,ecx		;Set status word
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Status word
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set New selection
mov ecx,dword ptr [ebp]+16		;add_position

mov eax,dword ptr [ebp]+12		;mov eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+4		;List_Item_Selection_Number
cmp ebx,ecx
jb no_reset_list_selection 

mov eax,dword ptr [ebp]+12		;mov eax,offset LIST_CONTENTS
inc dword ptr [eax]+4			;List_Item_Selection_Number

no_reset_list_selection:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set New selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set New text address and size
mov ecx,dword ptr [ebp]+16		;add_position
dec ecx
mov eax,32				;List one item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+12		;add eax,offset LIST_CONTENTS

mov edx,dword ptr [ebp]+24		;New text length
mov ebx,dword ptr [ebp]+20		;New text address

mov dword ptr [eax],edx			;Set new text length
mov dword ptr [eax]+4,ebx		;Set new text address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set New text address and size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set List parameters. [ coordinates and colors ]
start_set_list_parameters_after_add:

push dword ptr [ebp]+32			;offset COLOR_HANDLES_ARRAY		;ebp+16
push dword ptr [ebp]+12			;offset LIST_CONTENTS		;ebp+12
push 0	;operation_type							;ebp+8
call SCL_Set_List_Parameters

cmp eax,(-1)
je start_set_list_parameters_after_add
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set List parameters. [ coordinates and colors ]
xor ebx,ebx
end_set_list_parameters:
mov add_file_internal_error_code,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Unlock List Draw for Item Add
start_unlock_for_list_add:

push 0	;offset COLOR_HANDLES_ARRAY		;ebp+28
push 0	;memory_dc
push 0	;list_font_handle			;ebp+24
push 0	;offset LIST_CONTENTS		;ebp+16
push 0	;dword ptr [ebp]+8		;child_file_list_handle				;ebp+12
push 2	;operation_type			;ebp+8
call SCL_Draw_List_On_Window		;unlock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_unlock_for_list_add
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Unlock List Draw for Item Add
;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_003, LP_003, EP_003

mov ebx,add_file_internal_error_code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy 
;[eax] - 0 - function processed
	;[ebx] - 0 - List item add successfully
	;[ebx] - 1 - List items count above than 36. Cannot add item		[Error code]
	;[ebx] - 2 - Add item position is above than [List_Items_Count]+1	[Error code]
	;[ebx] - 3 - Specified add position is null.				[Error code]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 28
SCL_Add_File_List_Item endp		;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;Using example
;push offset COLOR_HANDLES_ARRAY	;ebp+20
;push remove_position			;ebp+16
;push offset LIST_CONTENTS		;ebp+12
;push operation_type			;ebp+8
;call SCL_Remove_File_List_Item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Remove_File_List_Item proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_004, EP_004

mov eax,dword ptr [ebp]+8
mov operation_type_004,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_004, LF_004, operation_type_004, LP_004, EP_004 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Lock List Draw for Item Add
start_lock_for_list_remove:

push 0	;offset COLOR_HANDLES_ARRAY		;ebp+28
push 0	;memory_dc
push 0	;list_font_handle			;ebp+24
push 0	;offset LIST_CONTENTS		;ebp+16
push 0	;dword ptr [ebp]+8		;child_file_list_handle				;ebp+12
push 3	;operation_type			;ebp+8
call SCL_Draw_List_On_Window		;lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_lock_for_list_remove
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Lock List Draw for Item Add
.DATA
list_remove_status	dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Error cases
mov ebx,1				;List items count is 0. Cannot Remove item [Error code]
mov eax,dword ptr [ebp]+12		;offset LIST_CONTENTS
cmp dword ptr [eax],0
je end_remove_list_item

mov ebx,2				;Remove item position is above than [List_Items_Count]	[Error code]
mov ecx,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov edx,dword ptr [ecx]			;List_Items_Count
mov esi,dword ptr [ebp]+16		;Remove_position
cmp esi,edx
ja no_reset_item_selection_after_remove	;Jump if Remove item position is above than [List_Items_Count]

mov ebx,3				;Specified Remove position is invalid[null].		[Error code]
mov esi,dword ptr [ebp]+16		;Remove_position
cmp esi,0
je no_reset_item_selection_after_remove	;Jump if specified Remove position is invalid[null].
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Error cases
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Remove List Item
mov eax,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov ebx,dword ptr [eax]			;List_Items_Count
sub ebx,dword ptr [ebp]+16		;remove_position
shl ebx,3				;Mul 8. In [ebx] now count of items [in dword] to shift for remove

mov eax,dword ptr [ebp]+16		;remove_position
dec eax
mov ecx,32				;One item size in bytes

mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+12		;offset LIST_CONTENTS

mov esi,eax
mov edi,eax

add esi,32				;One item size in bytes
mov ecx,ebx

cld 
rep movsd				;Transfer remaining part of LIST_CONTENST
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Remove List Item
mov eax,dword ptr [ebp]+12		;offset LIST_CONTENTS
dec dword ptr [eax]			;List_Items_Count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set List Parameters
start_set_list_parameters_after_remove:

push dword ptr [ebp]+20			;offset COLOR_HANDLES_ARRAY	;ebp+16
push dword ptr [ebp]+12			;offset LIST_CONTENTS		;ebp+12
push 0;operation_type			;ebp+8
call SCL_Set_List_Parameters

cmp eax,(-1)
je start_set_list_parameters_after_remove
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set List Parameters
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set List New Selection 
mov eax,dword ptr [ebp]+16		;remove_position
mov ebx,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov ecx,dword ptr [ebx]+4		;List_Item_Selection_Number
cmp eax,ecx
ja no_reset_item_selection_after_remove

mov ebx,dword ptr [ebp]+12		;offset LIST_CONTENTS
cmp dword ptr [ebx]+4,0
je no_reset_item_selection_after_remove	;Jump if List_Item_Selection_Number is null
dec dword ptr [ebx]+4			;List_Item_Selection_Number

no_reset_item_selection_after_remove:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set List New Selection 
xor ebx,ebx
end_remove_list_item:
mov list_remove_status,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Unlock List Draw for Item Add
start_unlock_for_list_remove:

push 0	;offset COLOR_HANDLES_ARRAY		;ebp+28
push 0	;memory_dc
push 0	;list_font_handle			;ebp+24
push 0	;offset LIST_CONTENTS		;ebp+16
push 0	;dword ptr [ebp]+8		;child_file_list_handle				;ebp+12
push 2	;operation_type			;ebp+8
call SCL_Draw_List_On_Window		;unlock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_unlock_for_list_remove
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Unlock List Draw for Item Add
;;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_004, LP_004, EP_004

mov ebx,list_remove_status
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy
;[eax] -  0 - function processed
	;[ebx] - 0 - List item remove successfully
	;[ebx] - 1 - List items count is 0. Cannot Remove item			[Error code]
	;[ebx] - 2 - Remove item position is above than [List_Items_Count]	[Error code]
	;[ebx] - 3 - Specified Remove position is invalid[null].		[Error code]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 16
SCL_Remove_File_List_Item endp		;FPC_4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset COLOR_HANDLES_ARRAY	;ebp+16
;push offset LIST_CONTENTS		;ebp+12
;push operation_type			;ebp+8
;call SCL_Set_List_Parameters

SCL_Set_List_Parameters proc
push ebp
mov ebp,esp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Function must set Items start X and Y cordinates and also 
;;set Colors and handles from COLOR_HANDLES_ARRAY
;;Colors and handles in COLOR_HANDLES_ARRAY are 0 - based
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_019, EP_019

mov eax,dword ptr [ebp]+8
mov operation_type_019,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_019, LF_019, operation_type_019, LP_019, EP_019
;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check error case
mov eax,dword ptr [ebp]+12		;mov eax,offset LIST_CONTENTS
cmp dword ptr [eax],0			;List_Items_Count
je no_set_parameters			;Jump if List_Items_Count is null
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check error case

mov list_parameters_set_internal_counter,0
mov list_item_Y_coordinate,0

.DATA
list_parameters_set_internal_counter	dd 0
list_item_Y_coordinate			dd 0
.CODE


start_set_list_parameters:
inc list_parameters_set_internal_counter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set List items X and Y coordinates
mov eax,list_parameters_set_internal_counter
dec eax
mov ebx,32					;One list item size in bytes
mul ebx
add eax,20					;Add  LIST_CONTENTS headers size
add eax,dword ptr [ebp]+12			;add eax,offset LIST_CONTENTS

mov ecx,list_item_Y_coordinate

mov dword ptr [eax]+24,ecx			;list_item_Y_coordinate
mov dword ptr [eax]+20,4;28			;Text X coordinate

;;dd   28	;Text X coordinate			;20
;;dd   14	;Text Y coordinate			;24
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set List items X and Y coordinates
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set List items Colors 
mov eax,list_parameters_set_internal_counter
dec eax
mov ebx,32					;One list item size in bytes
mul ebx
add eax,20					;Add  LIST_CONTENTS headers size
add eax,dword ptr [ebp]+12			;add eax,offset LIST_CONTENTS
mov edi,eax

mov ecx,dword ptr [eax]+28			;Arrow show status

xor ebx,ebx
xor edx,edx

shr ecx,8
mov bl,cl					;in [ebx] - Text color status number
shr ecx,8
mov dl,cl					;in [edx] - Background color status number

rol ebx,3					;mul 8
add ebx,dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY
mov eax,dword ptr [ebx]				;Text Color
mov dword ptr [edi]+8,eax

mov esi,dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY
rol edx,3					;mul 8
add edx,dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY

mov eax,dword ptr [edx]				;Background color
mov ebx,dword ptr [edx]+4			;Background color handle

mov dword ptr [edi]+12,eax
mov dword ptr [edi]+16,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;  Arrow show status  
;;Bytes 			Description
;;  0				  Arrow status [ 0 ] - arrow not show  [ 1 ] - arrow shows
;;  1				  Text color status number
;;  2				  Background color status number
;;  3				  Reserved
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set List items Colors 
add list_item_Y_coordinate,14

mov eax,dword ptr [ebp]+12		;mov eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]			;List_Items_Count
cmp list_parameters_set_internal_counter,ebx
jb start_set_list_parameters

no_set_parameters:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_019, LP_019, EP_019
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] -  0   - function processed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Set_List_Parameters endp		;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset COLOR_HANDLES_ARRAY	;ebp+16
;push offset LIST_CONTENTS		;ebp+12
;push operation_type			;ebp+8
;call SCL_Set_List_Selection_Color

SCL_Set_List_Selection_Color proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Colors and handles in COLOR_HANDLES_ARRAY are 0 - based
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_020, EP_020

mov eax,dword ptr [ebp]+8
mov operation_type_020,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_020, LF_020, operation_type_020, LP_020, EP_020
;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection Text color
mov eax,dword ptr [ebp]+12			;offset LIST_CONTENTS
mov ebx,dword ptr [eax]				;List_Items_Count
cmp ebx,0
je end_set_selection_color			;Jump if List_Items_Count is null

mov eax,dword ptr [ebp]+12			;offset LIST_CONTENTS
mov ebx,dword ptr [eax]+4			;List_Item_Selection_Number
cmp ebx,0
je end_set_selection_color			;Jump if Selection is null

mov eax,32					;One item size in bytes
dec ebx
mul ebx
add eax,20					;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+12			;offset LIST_CONTENTS

mov ebx,dword ptr [eax]+28			;Arrow show status
shl ebx,8					;Filtering high byte which contains FNL item number
shr ebx,8					;Filtering high byte which contains FNL item number

shr ebx,16
cmp ebx,0
sete al
ror eax,1
cdq

mov esi,0023FE2Eh		;[Green] - Set Selected text color as "GREEN"
mov edi,00FFFFFFh		;[White color] - Set Selected[on colored item] text color as "WHITE"

and esi,edx
not edx
and edi,edx

add esi,edi

mov eax,dword ptr [ebp]+12			;offset LIST_CONTENTS
mov ebx,dword ptr [eax]+4			;List_Item_Selection_Number
mov eax,32					;One item size in bytes
dec ebx
mul ebx
add eax,20					;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+12			;offset LIST_CONTENTS

mov dword ptr [eax]+8,esi			;Text color 

;If Background color status is not equal to 0 than 
;text color is set to 00FFFFFFh [White color] else color is set to 0023FE2Eh [Green]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection Text color
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection Background color
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;COLOR_HANDLES_ARRAY label dword
;List_Passive_Color			dd 00E9E9E9h			;0
;List_Passive_Color_Handle		dd 0	;Background		;4
;List_Active_Color			dd 007F7F7Fh			;8
;List_Active_Color_Handle		dd 0	;Background		;12 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+12			;offset LIST_CONTENTS
mov ebx,dword ptr [eax]+4			;List_Item_Selection_Number
mov eax,32					;One item size in bytes
dec ebx
mul ebx
add eax,20					;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+12			;offset LIST_CONTENTS

;;;;mov esi,dword ptr [eax]+28			;Arrow show status
;;;;bts esi,0					;Set Arrow show status
;;;;mov dword ptr [eax]+28,esi			;Arrow show status

mov ebx,dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY
mov ecx,dword ptr [ebx]+12			;List_Active_Color_Handle
mov edx,dword ptr [ebx]+8			;List_Active_Color

mov dword ptr [eax]+16,ecx			;Background color handle
mov dword ptr [eax]+12,edx			;Text background color
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;  Arrow show status  
;;Bytes 			Description
;;  0				  Arrow status [ 0 ] - arrow not show  [ 1 ] - arrow shows
;;  1				  Text color status number
;;  2				  Background color status number
;;  3				  Reserved
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection Background color
end_set_selection_color:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_020, LP_020, EP_020
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] -  0   - function processed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Set_List_Selection_Color endp		;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push item_number			;ebp+20
;push offset COLOR_HANDLES_ARRAY	;ebp+16
;push offset LIST_CONTENTS		;ebp+12
;push operation_type			;ebp+8
;call SCL_Recover_Item_Color

SCL_Recover_Item_Color proc
push ebp
mov ebp,esp

;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_022, EP_022

mov eax,dword ptr [ebp]+8
mov operation_type_022,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_022, LF_022, operation_type_022, LP_022, EP_022

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Recover Item Colors 
mov esi,dword ptr [ebp]+12
mov ebx,dword ptr [esi]				;List_Items_Count
cmp ebx,0
je no_recover_item_color			;Jump if List_Items_Count is null

cmp dword ptr [ebp]+20,ebx			;item_number [ebp]+20
ja no_recover_item_color			;Jump if recover item_number is above than List_Items_Count

mov eax,dword ptr [ebp]+20			;item_number
cmp eax,0
je no_recover_item_color			;Jump if specified item number is null


dec eax
mov ebx,32					;One list item size in bytes
mul ebx
add eax,20					;Add  LIST_CONTENTS headers size
add eax,dword ptr [ebp]+12			;add eax,offset LIST_CONTENTS
mov edi,eax

mov ecx,dword ptr [eax]+28			;Arrow show status

xor ebx,ebx
xor edx,edx

shr ecx,8
mov bl,cl					;in [ebx] - Text color status number
shr ecx,8
mov dl,cl					;in [edx] - Background color status number

rol ebx,3					;mul 8
add ebx,dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY
mov eax,dword ptr [ebx]				;Text Color
mov dword ptr [edi]+8,eax

mov esi,dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY
rol edx,3					;mul 8
add edx,dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY

mov eax,dword ptr [edx]				;Background color
mov ebx,dword ptr [edx]+4			;Background color handle

mov dword ptr [edi]+12,eax
mov dword ptr [edi]+16,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;  Arrow show status  
;;Bytes 			Description
;;  0				  Arrow status [ 0 ] - arrow not show  [ 1 ] - arrow shows
;;  1				  Text color status number
;;  2				  Background color status number
;;  3				  Reserved
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

no_recover_item_color:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Recover Item Colors 
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point 
standard_sync_lock_footer BF_022, LP_022, EP_022 

mov esp,ebp
pop ebp
ret 16
SCL_Recover_Item_Color endp		;FPC_4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push memory_dc				;ebp+36
;push list_font_handle			;ebp+32
;push hwnd				;ebp+28
;push new_selection			;ebp+24
;push selection_type			;ebp+20
;push offset COLOR_HANDLES_ARRAY	;ebp+16
;push offset LIST_CONTENTS		;ebp+12
;push operation_type			;ebp+8
;call SCL_Set_List_Selection

SCL_Set_List_Selection proc
push ebp
mov ebp,esp
;selection_type can be 0 -  Standard Selection. 1 - Arrowed selection

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_023, EP_023

mov eax,dword ptr [ebp]+8
mov operation_type_023,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_023, LF_023, operation_type_023, LP_023, EP_023

;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cmp dword ptr [ebp]+24,0		;new_selection
je no_set_new_selection			;Jump if specified new selection is null

mov esi,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov edi,dword ptr [esi]			;List_Items_Count

cmp dword ptr [ebp]+24,edi		;new_selection
ja no_set_new_selection			;Jump if New Selection is above than List_Items_Count

mov eax,dword ptr [ebp]+24		;new_selection
mov esi,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov ebx,dword ptr [esi]+4		;List_Item_Selection_Number
cmp ebx,eax
je no_set_new_selection			;Jump if new and old selections are equal
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset arrow on current selection
mov esi,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov ebx,dword ptr [esi]+4		;List_Item_Selection_Number
cmp ebx,0
je no_reset_arrow_on_current_selection	;Jump if Current selection is null

dec ebx
mov eax,32				;List one item size in bytes
mul ebx
add eax,20				;LIST_CONTENTS header size
add eax,dword ptr [ebp]+12		;offset LIST_CONTENTS

mov ebx,dword ptr [eax]+28		;Arrow show status
btr ebx,0				;Reset arrow show status
mov dword ptr [eax]+28,ebx		;Arrow show status

no_reset_arrow_on_current_selection:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset arrow on current selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Recover Old Selected item colors
start_recover_item_color_for_selection_change:

mov esi,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov ebx,dword ptr [esi]+4		;List_Item_Selection_Number

push ebx	;item_number		;ebp+20
push dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY		;ebp+16
push dword ptr [ebp]+12			;offset LIST_CONTENTS			;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Recover_Item_Color

cmp eax,(-1)
je start_recover_item_color_for_selection_change

start_repaint_before_selection_change:

mov esi,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov ebx,dword ptr [esi]+4		;List_Item_Selection_Number;

push dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY		;ebp+28
push dword ptr [ebp]+36			;memory_dc				;ebp+28
push ebx 				;List Item number			;ebp+24
push dword ptr [ebp]+32			;list_font_handle			;ebp+20
push dword ptr [ebp]+12			;offset LIST_CONTENTS			;ebp+16
push dword ptr [ebp]+28			;child_file_list_handle			;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Repaint_List_Item

cmp eax,(-1)
je start_repaint_before_selection_change
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Recover Old Selected item colors

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Start Set new selection
mov esi,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov edi,dword ptr [ebp]+24		;new_selection_number
mov dword ptr [esi]+4,edi		;Set new selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; End Set new selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Start Set new selection color
push dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY		;ebp+16
push dword ptr [ebp]+12			;offset LIST_CONTENTS			;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_List_Selection_Color
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Start Set new selection color
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Start Set arrow on selection
cmp dword ptr [ebp]+20,0		;selection_type
je no_arrowed_selection			;Jump if selection type is no arrowed

mov esi,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov ebx,dword ptr [esi]+4		;List_Item_Selection_Number
dec ebx
mov eax,32				;List one item size in bytes
mul ebx
add eax,20				;LIST_CONTENTS header size
add eax,dword ptr [ebp]+12		;offset LIST_CONTENTS

mov ebx,dword ptr [eax]+28		;Arrow show status
bts ebx,0				;Set arrow show status
mov dword ptr [eax]+28,ebx		;Arrow show status

no_arrowed_selection:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; End Set arrow on selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Start repaint item after selection change
start_repaint_after_selection_change:

mov esi,dword ptr [ebp]+12		;offset LIST_CONTENTS
mov ebx,dword ptr [esi]+4		;List_Item_Selection_Number

push dword ptr [ebp]+16			;offset COLOR_HANDLES_ARRAY		;ebp+28
push dword ptr [ebp]+36			;memory_dc				;ebp+28
push ebx 				;List Item number			;ebp+24
push dword ptr [ebp]+32			;list_font_handle			;ebp+20
push dword ptr [ebp]+12			;offset LIST_CONTENTS			;ebp+16
push dword ptr [ebp]+28			;child_file_list_handle			;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Repaint_List_Item		;FPC_7

cmp eax,(-1)
je start_repaint_after_selection_change
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; End repaint item after selection change

no_set_new_selection:

;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_023, LP_023, EP_023

mov esp,ebp
pop ebp
ret 32
SCL_Set_List_Selection endp		;FPC_8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

endm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
set_item_visibility macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset vertical_current_pos	;ebp+24
;push item_number			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push child_file_list_handle		;ebp+12
;push operation_type			;ebp+8
;call SCL_Set_Item_Visibility
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Set_Item_Visibility proc
push ebp
mov ebp,esp
;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_005, EP_005

mov eax,dword ptr [ebp]+8
mov operation_type_005,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_005, LF_005, operation_type_005, LP_005, EP_005
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,dword ptr [ebp]+16		;offset LIST_CONTENTS
mov edi,dword ptr [esi]			;List_Items_Count
cmp dword ptr [ebp]+20,edi
ja no_set_visibility			;Jump if specified item number is above than List_Items_Count

cmp dword ptr [ebp]+20,0		;item_number
je no_set_visibility			;Jump if specified item number is null

mov eax,dword ptr [ebp]+20		;Item number
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;LIST_CONTENTS header size
add eax,dword ptr [ebp]+16		;offset LIST_CONTENTS

mov internal_item_address,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;IF [Text_Y]<[List_Internal_Y_offset]	than SET [List_Internal_Y_offset = Text_Y]

;List_Item_1				dd   85					;0
;					dd   offset text_to_show		;4
;					dd   0			;Text color	;8
;					dd   00E9E9E9h		;		;12
;					dd   0	;Background color handle	;16
;					dd   28	;Text X coordinate		;20
;					dd   0	;Text Y coordinate		;24
;					dd   1	;Arrow show status		;28 
;

mov eax,internal_item_address
mov ebx,dword ptr [eax]+24		;Text Y coordinate

mov edx,dword ptr [ebp]+16		;mov edx,offset LIST_CONTENTS
mov ecx,dword ptr [edx]+12		;List_Internal_Y_offset

cmp ebx,ecx
setl al				;Set IF signed [Text Y coordinate] < [List_Internal_Y_offset]
ror eax,1
cdq

mov eax,internal_item_address		;mov eax,offset List_Item_3
mov edi,dword ptr [eax]+24		;Text Y coordinate

mov ebx,dword ptr [ebp]+16		;mov edx,offset LIST_CONTENTS
mov esi,dword ptr [ebx]+12		;mov esi,List_Internal_Y_offset

and edi,edx
not edx
and esi,edx
add esi,edi

	mov ebx,dword ptr [ebp]+16	;mov edx,offset LIST_CONTENTS
mov dword ptr [ebx]+12,esi		;mov List_Internal_Y_offset,esi

mov eax,dword ptr [ebx]+12		;mov eax,List_Internal_Y_offset

mov ebx,dword ptr [ebp]+24		;offset vertical_current_pos
mov dword ptr [ebx],eax			;mov vertical_current_pos,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;IF [Text_Y]+14 > [List_Internal_Y_offset] + [CLIENT_AREA_HEIGHT]
;		Than SET [List_Internal_Y_offset] = [Text_Y] + 14  - [CLIENT_AREA_HEIGHT]

.DATA
child_client_list_rectangle	dd 0, 0, 0, 0
internal_item_address		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get List dimensions
push offset child_client_list_rectangle
push dword ptr [ebp]+12	;child_file_list_handle
call GetClientRect

;child_client_list_rectangle + 8	;Width  of client area
;child_client_list_rectangle + 12 	;Height of client area
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get List dimensions
mov eax,internal_item_address		;mov eax,offset List_Item_3		
mov ebx,dword ptr [eax]+24		;Text Y coordinate
add ebx,14				;Add LIST one item size in pixels

mov edx,dword ptr [ebp]+16		;mov edx,offset LIST_CONTENTS
mov ecx,dword ptr [edx]+12		;List_Internal_Y_offset
add ecx,child_client_list_rectangle + 12

cmp ebx,ecx
setg al
ror eax,1
cdq

mov eax,internal_item_address		;mov eax,offset List_Item_3		
mov edi,dword ptr [eax]+24		;Text Y coordinate
add edi,14
sub edi,child_client_list_rectangle + 12
inc edi

	mov ebx,dword ptr [ebp]+16	;mov edx,offset LIST_CONTENTS
mov esi,dword ptr [ebx]+12		;mov esi,List_Internal_Y_offset

and edi,edx
not edx
and esi,edx

add esi,edi

mov dword ptr [ebx]+12,esi		;mov List_Internal_Y_offset,esi

mov eax,esi				;mov eax,List_Internal_Y_offset

mov ebx,dword ptr [ebp]+24		;offset vertical_current_pos
mov dword ptr [ebx],eax			;mov vertical_current_pos,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,dword ptr [ebp]+24		;offset vertical_current_pos

push    1			;bRedraw
push    dword ptr [ebx]		;vertical_current_pos	;nPos
push    1			;nBar
push dword ptr [ebp]+12		;push    child_file_list_handle
call    SetScrollPos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
no_set_visibility:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set Vertical scroll bar position
;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_005, LP_005, EP_005
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 20
SCL_Set_Item_Visibility endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push draw_operation			;ebp+24
;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push child_file_list_handle		;ebp+12
;push 0;operation_type			;ebp+8
;call SCL_Perform_List_Effect		;FPC_5

SCL_Perform_List_Effect proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_024, EP_024

mov eax,dword ptr [ebp]+8
mov operation_type_024,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_024, LF_024, operation_type_024, LP_024, EP_024
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;draw_operation - 1 - Draw text effect
;draw_operation - 0 - Recover original text

.DATA
draw_text_effect_internal_hdc		dd 0
current_item_number_with_effect		dd 0
previous_item_number_with_effect	dd 0
.CODE


push dword ptr [ebp]+12	;child_file_list_handle
call GetDC
mov draw_text_effect_internal_hdc,eax

start_check_mouse_for_effect:

push dword ptr [ebp]+16			;offset LIST_CONTENTS		;ebp+16
push dword ptr [ebp]+12			;child_file_list_handle		;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Check_Mouse_Cursor_On_Item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 -  mouse cursor located on item
;[eax] - 1 -  mouse cursor is not located on item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_check_mouse_for_effect
mov current_item_number_with_effect,ebx

mov ebx,previous_item_number_with_effect

mov eax,current_item_number_with_effect
cmp previous_item_number_with_effect,eax
je no_draw_effect

push 0 ;show_text_type			;ebp+32
push 00FF0000h ;text_color		;ebp+28
push dword ptr [ebp]+20			;list_font_handle			;ebp+24
push ebx	;Item_number		;ebp+20
push dword ptr [ebp]+16			;offset LIST_CONTENTS		;ebp+16
push draw_text_effect_internal_hdc	;ebp+12
push 0;operation_type			;ebp+8
call SCL_Fill_Show_Zone_Only_By_Text	;FPC_7

cmp dword ptr [ebp]+24,0		;draw_operation
je no_draw_effect

mov ebx,current_item_number_with_effect

push 1 ;show_text_type			;ebp+32
push 00FF0000h ;text_color		;ebp+28
push dword ptr [ebp]+20			;list_font_handle		;ebp+24
push ebx	;Item_number		;ebp+20
push dword ptr [ebp]+16			;offset LIST_CONTENTS		;ebp+16
push draw_text_effect_internal_hdc	;ebp+12
push 0;operation_type			;ebp+8
call SCL_Fill_Show_Zone_Only_By_Text	;FPC_7

mov eax,current_item_number_with_effect
mov previous_item_number_with_effect,eax

no_draw_effect:

push draw_text_effect_internal_hdc
push dword ptr [ebp]+12	;child_file_list_handle
call ReleaseDC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_024, LP_024, EP_024

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 20
SCL_Perform_List_Effect endp		;FPC_5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


endm 







