spl_standard_operations macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Using example
;push save_type			;ebp+12
;push operation_type		;ebp+8
;call SCL_Save_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;save_type
;;Bits
;0	;0 - Do not display save confirmation	;1 - Display save confirmation
;1	;0 - Do not close SPL			;1 - Close SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Save_SPL  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SSPL_01, EP_SSPL_01

mov eax,dword ptr [ebp]+8
mov operation_type_SSPL_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SSPL_01, LF_SSPL_01, operation_type_SSPL_01, LP_SSPL_01, EP_SSPL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SPL_load_flag			dd 0 ;0 - Spl file not loaded ;1 - SPl file loaded
;project_spl_file_name			db 400 dup (0)

.DATA
spl_save_confirmation_title	db 'SPL save confirmation',0
spl_save_confirmation_text	db 'Current SPL file has been modified. Do you want to save file?',0
spl_save_description		db 'Process type: [Try to save .SPL]',0
.CODE

cmp SPL_load_flag,0
je end_save_SPL			;Jump if SPL is absent
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;lParam   
push 0				;wParam   
push 0B8h			;EM_GETMODIFY 0B8h
push spl_window_handle
call SendMessageA
cmp eax,0
je no_save_SPL			;Jump if specified text is not modified
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;save_type
;;Bits
;0	;0 - Do not display save confirmation	;1 - Display save confirmation
;1	;0 - Do not close SPL			;1 - Close SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save SPL
mov eax,dword ptr [ebp]+12		;save_type
bt eax,0
jnc do_not_display_save_confirmation	;Jump if bit is zero

push 30h+3h				;MB_YESNOCANCEL 3h
push offset spl_save_confirmation_title	;"SPL save confirmation"
push offset spl_save_confirmation_text	;"Current SPL file has been modified. Do you want to save file?"
push hwnd
call MessageBoxA
;IDYES 6
;IDNO  7

cmp eax,2				;IDCANCEL  2
je no_save_SPL
cmp eax,7				;IDNO  7
je no_save_SPL

do_not_display_save_confirmation:

mov eax,offset spl_save_description
mov specified_file_description,eax

push offset project_spl_file_name	;ebp+16
push spl_window_handle			;window_handle			;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Save_Specified_File

push 0				;lParam   
push 0				;wParam		Modification new value   
push 0B9h			;EM_SETMODIFY 0B8h
push spl_window_handle
call SendMessageA

push 0
push offset project_spl_file_name	;ebp+16
push offset project_spl_file_name	;ebp+16
push hwnd
call MessageBoxA

no_save_SPL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Save SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Close SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;save_type
;;Bits
;0	;0 - Do not display save confirmation	;1 - Display save confirmation
;1	;0 - Do not close SPL			;1 - Close SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save SPL
mov eax,dword ptr [ebp]+12		;save_type
bt eax,1
jnc no_close_SPL			;Jump if bit is zero

;SPL_load_flag			dd 0 ;0 - Spl file not loaded ;1 - SPl file loaded
;project_spl_file_name			db 400 dup (0)

mov SPL_load_flag,0			;Set SPL load status as "SPL ABSENT"

mov edi,offset project_spl_file_name
mov ecx,100
xor eax,eax
cld
rep stosd				;Reset SPL name

push 0				;lparam 
push 0				;wparam 
push WM_SETTEXT
push spl_window_handle
call SendMessageA		;Reset SPL window contents

push 0				;lParam   
push 0				;wParam		Modification new value   
push 0B9h			;EM_SETMODIFY 0B8h
push spl_window_handle
call SendMessageA		;Set SPL modification status as "UNMODIFIED"

no_close_SPL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Close SPL

end_save_SPL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SSPL_01, LP_SSPL_01, EP_SSPL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 8
SCL_Save_SPL  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Using example
;push open_type				;ebp+16
;push offset file_name			;ebp+12
;push operation_type			;ebp+8
;call SCL_Open_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Open_SPL  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_OESPL_01, EP_OESPL_01

mov eax,dword ptr [ebp]+8
mov operation_type_OESPL_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_OESPL_01, LF_OESPL_01, operation_type_OESPL_01, LP_OESPL_01, EP_OESPL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ecx,dword ptr [ebp]+12
mov OPEN_SPL_file_name_address,ecx		;Initial Set SPL file name address

mov eax,dword ptr [ebp]+16		;open_type
bt eax,2
jnc no_show_SPL_present_confirmation	;Jump if must show SPL present confirmation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
spl_present_flag_error_title	db 'SPL present',0
spl_present_flag_error_text	db 'You have already open SPL. SPL contents will be replaced.',0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show SPL present confirmation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp SPL_load_flag,0			;0 - Spl file not loaded ;1 - SPl file loaded
je no_show_SPL_present_confirmation	;Jump if SPL absent

push 30h+1h					;MB_OKCANCEL 1h
push offset spl_present_flag_error_title	;"SPL present"
push offset spl_present_flag_error_text		;"You have already open SPL. SPL contents will be replaced."
push hwnd
call MessageBoxA
cmp eax,2					;IDCANCEL  2
je end_open_SPL					;Jump if "Cancel" was pressed

no_show_SPL_present_confirmation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show SPL present confirmation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SPL_load_flag			dd 0 ;0 - Spl file not loaded ;1 - SPl file loaded
;project_spl_file_name			db 400 dup (0)

mov eax,dword ptr [ebp]+16		;open_type
bt eax,1
jc no_get_file_name_from_shell_dialog	;Jump if must use Specified file name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset GetOpenFileNameA
mov get_open_file_name_address,eax

mov ebx,offset GetSaveFileNameA
mov get_save_file_name_address,eax

.DATA
get_open_file_name_address	dd 0
get_save_file_name_address	dd 0

project_spl_file_name		db 400 dup (0)
SPL_load_flag			dd 0 ;0 - Spl file not loaded ;1 - SPl file loaded

SPLOPEN_OPENFILENAMEA		db 76  dup (0)  ;;file name offset 56    file extension offset 58 
SPL_OPEN_file_title		dd 100 dup (0)
SPL_OPEN_filter			db 'All files',0,'*.*',0, 'SPL files',0,'*.spl',0,0
SPL_OPEN_file_name		dd  100 dup (0)
SPL_OPEN_existing_title		db 'Open existing SPL file',0
SPL_OPEN_new_title		db 'Open new SPL file',0
OPEN_SPL_file_name_address	dd 0
SPL_open_dialog_address		dd 0
SPL_open_dialog_title_address	dd 0
default_spl_extension		db '.SPL',0,0, 0, 0
spl_open_flag			dd 0
SPL_file_open_internal_handle	dd 0
SPL_open_error_owner_type	dd 0
SPL_open_system_error_code	dd 0
SPL_file_name_buffer		db  400 dup (0)  ;Used in [asm_ide_standard_project_functions.inc]
spl_open_description		db 'Process type: [Try to open SPL]',0
spl_transfer_description	db 'Process type: [Try to transfer SPL contents into window]',0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset SPLOPEN_OPENFILENAMEA
xor eax,eax
mov edi,offset SPLOPEN_OPENFILENAMEA
mov ecx,19				;76 / 4 = 19
cld 
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset SPLOPEN_OPENFILENAMEA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset SPL_OPEN_file_name
xor eax,eax
mov edi,offset SPL_OPEN_file_name
mov ecx,100				;76 / 4 = 19
cld 
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset SPL_OPEN_file_name
mov eax,dword ptr [ebp]+16		;open_type
bt eax,1
jc no_get_file_name_from_shell_dialog	;Jump if must use Specified file name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;IF [eax.0] = 0 Then Use [GetOpenFilenameA] Else Use [GetSaveFilenameA]

mov ebx,dword ptr [ebp]+16		;open_type
bt ebx,0
setae al				;Set if CF = 0
ror eax,1
cdq
mov esi,get_open_file_name_address
mov edi,get_save_file_name_address
and esi,edx
not edx
and edi,edx
add esi,edi
mov SPL_open_dialog_address,esi
not edx

mov esi,offset SPL_OPEN_existing_title
mov edi,offset SPL_OPEN_new_title
and esi,edx
not edx
and edi,edx
add esi,edi
mov SPL_open_dialog_title_address,esi

mov eax,SPL_open_dialog_title_address
mov dword ptr SPLOPEN_OPENFILENAMEA+28,offset SPL_OPEN_file_name
mov dword ptr SPLOPEN_OPENFILENAMEA+36,offset SPL_OPEN_file_title
mov dword ptr SPLOPEN_OPENFILENAMEA+44,0					;offset current_dir
mov dword ptr SPLOPEN_OPENFILENAMEA+48,eax		;offset add_existing_file_title
mov dword ptr SPLOPEN_OPENFILENAMEA,76
mov dword ptr SPLOPEN_OPENFILENAMEA+24,2
mov dword ptr SPLOPEN_OPENFILENAMEA+60,offset default_spl_extension
mov dword ptr SPLOPEN_OPENFILENAMEA+32,398
mov dword ptr SPLOPEN_OPENFILENAMEA+40,398
mov dword ptr SPLOPEN_OPENFILENAMEA+52,80000h+4h+200000h+20000h+2000000h+400h 
mov dword ptr SPLOPEN_OPENFILENAMEA+12,offset SPL_OPEN_filter
mov eax,hwnd 
mov dword ptr SPLOPEN_OPENFILENAMEA+4,eax
push offset SPLOPEN_OPENFILENAMEA
call SPL_open_dialog_address		;GetOpenFileNameA
cmp eax,0
je end_open_SPL

mov ebx,offset SPL_OPEN_file_name
mov OPEN_SPL_file_name_address,ebx

no_get_file_name_from_shell_dialog:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create New File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,dword ptr [ebp]+16		;open_type
bt ebx,0
jnc no_need_to_create_SPL_file

push 0         
push 80h				;FILE_ATTRIBUTE_NORMAL)
push CREATE_NEW				;CREATE_NEW		1
push 0         
push 0  
push 80000000h+40000000h		;(GENERIC READ/WRITE)
push OPEN_SPL_file_name_address
call CreateFileA
mov SPL_file_open_internal_handle,eax
cmp eax,(-1)
jne no_error_when_open_SPL				;INVALID_HANDLE_VALUE -1
call GetLastError
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset spl_open_description	;ebp+20
push OPEN_SPL_file_name_address		;ebp+16
push eax 				;ebp+12	;error code
push 0 ;operation_type			;ebp+8
call SCL_Generate_File_IO_Error_Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp end_open_SPL
no_error_when_open_SPL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer file contents 

push SPL_file_open_internal_handle	;current_file_handle;  ;Returned by CreateFileA
call CloseHandle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Open file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Create New File
no_need_to_create_SPL_file:

;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;lparam 
push 0				;wparam 
push WM_SETTEXT
push spl_window_handle
call SendMessageA		;Reset SPL window contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer File to Richedit Window
start_transfer_SPL_into_window:
;STREAMIN_type  ; 0 - All ;1 - File

push 0  				;STREAMIN_type			;ebp+24
push 16000				;file_size_limit in bytes	;ebp+20
push spl_window_handle			;richedit_window_handle		;ebp+16
push OPEN_SPL_file_name_address		;offset file_name		;ebp+12
push 0		 	;operation_type			;ebp+8
call SCL_Transfer_File_Contents_Into_Richedit_Window
cmp eax,(-1)
je start_transfer_SPL_into_window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - Error owner
	;[eax] - (-1) - function busy
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - ReadFile generates error
	;[eax] - 3 - File size is out of allowed limit
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je SPL_processed_normal

mov SPL_open_error_owner_type,eax
mov SPL_open_system_error_code,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp SPL_open_error_owner_type,3		;File size is out of allowed limit
jne SPL_no_file_size_input_error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset line_text	;"_________________________________________________"
add_report_line 		;[eax] - contains line address


mov eax,offset file_size_error_title_text
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset file_name_text	;"File name"
add_report_line 		;[eax] - contains line address

mov eax,OPEN_SPL_file_name_address
add_report_line 		;[eax] - contains line address

mov eax,offset eol_code
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
mov eax,offset file_size_error_text
add_report_line 		;[eax] - contains line address

mov eax,offset line_text
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPL_no_file_size_input_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov new_header_button_selection,4

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp SPL_open_error_owner_type,3		;File size is out of allowed limit
je no_SPL_file_open_system_error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset spl_transfer_description
push OPEN_SPL_file_name_address			;ebp+16
push SPL_open_system_error_code			;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Generate_File_IO_Error_Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

no_SPL_file_open_system_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp end_open_SPL
SPL_processed_normal:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer File to Richedit Window
;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov ebx,dword ptr [ebp]+16		;open_type

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer SPL file name into [project_spl_file_name]
mov esi,OPEN_SPL_file_name_address
mov edi,offset project_spl_file_name
mov ecx,100
cld
rep movsd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer SPL file name into [project_spl_file_name]
;SPL_load_flag				dd 0 ;0 - Spl file not loaded ;1 - SPl file loaded
mov SPL_load_flag,1			;Set SPL load status as "SPL PRESENT"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set SPL modified status
push 0				;lParam   
push 0				;wParam		Modification new value   
push 0B9h			;EM_SETMODIFY 0B8h
push spl_window_handle
call SendMessageA		;Set SPL modification status as "UNMODIFIED"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set SPL modified status
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show SPL window
;mov new_header_button_selection,2

;push 5  ;function_number			;ebp+12
;push 0  ;operation_type				;ebp+8
;call SCL_Concentrated_Switch_Control		;Show "SPL" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show SPL window
end_open_SPL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_OESPL_01, LP_OESPL_01, EP_OESPL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Open_SPL  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;Using example
;push operation_type				;ebp+8
;call SCL_Generate_Standard_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Generate_Standard_SPL  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GSS_01, EP_GSS_01

mov eax,dword ptr [ebp]+8
mov operation_type_GSS_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_GSS_01, LF_GSS_01, operation_type_GSS_01, LP_GSS_01, EP_GSS_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
active_window_for_SG		dd 0
standard_SPL	label dword

; ' C:\std.txt is 1352 bytes long
db 91,70,105,108,101,95,76,105,115,116,95,83,116,97,114,116
db 93,13,10,9,91,48,48,49,55,50,32,32,61,32,32,39
db 99,58,92,84,97,115,109,73,68,69,92,84,97,115,109,105
db 100,101,50,92,80,114,111,106,101,99,116,115,49,92,83,99
db 97,110,110,101,114,92,77,78,46,65,83,77,39,93,13,10
db 91,70,105,108,101,95,76,105,115,116,95,69,110,100,93,13
db 10,13,10,91,80,114,111,103,114,97,109,115,95,76,105,115
db 116,95,83,116,97,114,116,93,13,10,9,91,77,97,115,109
db 95,99,111,109,112,105,108,101,114,32,61,32,39,99,58,92
db 109,97,115,109,51,50,92,98,105,110,92,77,76,46,69,88
db 69,39,9,9,93,13,10,9,91,77,97,115,109,95,108,105
db 110,107,101,114,32,32,32,61,32,39,99,58,92,109,97,115
db 109,51,50,92,98,105,110,92,76,73,78,75,46,69,88,69
db 39,9,93,13,10,91,80,114,111,103,114,97,109,115,95,76
db 105,115,116,95,69,110,100,93,13,10,13,10,91,79,112,101
db 114,97,116,105,111,110,115,95,76,105,115,116,95,83,116,97
db 114,116,93,13,10,9,91,79,112,101,114,97,116,105,111,110
db 32,39,67,111,109,112,105,108,101,39,32,32,83,116,97,114
db 116,93,91,79,117,116,112,117,116,58,83,84,68,79,85,84
db 47,83,84,68,69,82,82,93,91,32,32,32,77,97,115,109
db 95,99,111,109,112,105,108,101,114,32,32,32,32,93,91,32
db 39,32,47,99,32,32,47,99,111,102,102,32,91,73,110,115
db 101,114,116,32,34,70,105,108,101,34,32,83,116,97,114,116
db 93,91,48,48,49,55,50,93,91,73,110,115,101,114,116,32
db 34,70,105,108,101,34,32,69,110,100,93,32,39,32,32,93
db 91,79,112,101,114,97,116,105,111,110,32,39,67,111,109,112
db 105,108,101,39,32,32,69,110,100,93,32,13,10,9,91,79
db 112,101,114,97,116,105,111,110,32,39,68,101,108,101,116,101
db 39,32,32,32,83,116,97,114,116,93,91,79,117,116,112,117
db 116,58,83,84,68,79,85,84,47,83,84,68,69,82,82,93
db 91,32,39,91,73,110,115,101,114,116,32,34,70,105,108,101
db 34,32,83,116,97,114,116,93,91,48,48,49,55,50,93,91
db 34,101,120,101,34,93,91,73,110,115,101,114,116,32,34,70
db 105,108,101,34,32,69,110,100,93,46,46,39,32,32,93,91
db 79,112,101,114,97,116,105,111,110,32,39,68,101,108,101,116
db 101,39,32,32,32,69,110,100,93,13,10,9,91,79,112,101
db 114,97,116,105,111,110,32,39,76,105,110,107,39,32,32,83
db 116,97,114,116,93,91,79,117,116,112,117,116,58,83,84,68
db 79,85,84,47,83,84,68,69,82,82,93,91,32,32,32,77
db 97,115,109,95,108,105,110,107,101,114,32,32,32,32,93,91
db 32,39,32,32,47,83,85,66,83,89,83,84,69,77,58,87
db 73,78,68,79,87,83,32,32,91,73,110,115,101,114,116,32
db 34,70,105,108,101,34,32,83,116,97,114,116,93,91,48,48
db 49,55,50,93,91,34,111,98,106,34,93,91,73,110,115,101
db 114,116,32,34,70,105,108,101,34,32,69,110,100,93,32,39
db 32,32,93,91,79,112,101,114,97,116,105,111,110,32,39,76
db 105,110,107,39,32,32,69,110,100,93,13,10,9,91,79,112
db 101,114,97,116,105,111,110,32,39,69,120,101,99,117,116,101
db 39,32,32,83,116,97,114,116,93,91,79,117,116,112,117,116
db 58,83,84,68,79,85,84,47,83,84,68,69,82,82,93,91
db 32,39,91,73,110,115,101,114,116,32,34,70,105,108,101,34
db 32,83,116,97,114,116,93,91,48,48,49,55,50,93,91,34
db 101,120,101,34,93,91,73,110,115,101,114,116,32,34,70,105
db 108,101,34,32,69,110,100,93,39,32,32,93,91,79,112,101
db 114,97,116,105,111,110,32,39,69,120,101,99,117,116,101,39
db 32,32,69,110,100,93,13,10,59,9,91,79,112,101,114,97
db 116,105,111,110,32,39,83,104,101,108,108,69,120,101,99,117
db 116,101,39,32,32,83,116,97,114,116,93,91,79,117,116,112
db 117,116,58,83,84,68,79,85,84,47,83,84,68,69,82,82
db 93,91,32,39,91,73,110,115,101,114,116,32,34,70,105,108
db 101,34,32,83,116,97,114,116,93,91,83,72,69,76,76,93
db 91,73,110,115,101,114,116,32,34,70,105,108,101,34,32,69
db 110,100,93,39,32,32,93,91,79,112,101,114,97,116,105,111
db 110,32,39,83,104,101,108,108,69,120,101,99,117,116,101,39
db 32,32,69,110,100,93,13,10,59,9,91,79,112,101,114,97
db 116,105,111,110,32,39,67,111,112,121,39,32,32,83,116,97
db 114,116,93,91,79,117,116,112,117,116,58,83,84,68,79,85
db 84,47,83,84,68,69,82,82,93,91,32,32,32,34,99,58
db 92,99,104,101,99,107,95,102,105,108,101,95,105,111,46,116
db 120,116,34,32,32,32,32,93,91,32,34,99,58,92,84,97
db 115,109,73,68,69,92,84,97,115,109,105,100,101,50,92,80
db 114,111,106,101,99,116,115,49,92,83,99,97,110,110,101,114
db 92,99,104,101,99,107,95,102,105,108,101,95,105,111,46,116
db 120,116,34,32,93,91,79,112,101,114,97,116,105,111,110,32
db 39,67,111,112,121,39,32,32,69,110,100,93,32,13,10,13
db 10,91,79,112,101,114,97,116,105,111,110,115,95,76,105,115
db 116,95,69,110,100,93,13,10,13,10,109,108,46,101,120,101
db 32,32,32,32,47,99,32,47,99,111,102,102,32,32,102,105
db 108,101,46,97,115,109,9,9,59,83,116,97,110,100,97,114
db 100,32,87,105,110,51,50,32,46,101,120,101,32,102,105,108
db 101,13,10,108,105,110,107,46,101,120,101,32,47,83,85,66
db 83,89,83,84,69,77,58,87,73,78,68,79,87,83,32,32
db 102,105,108,101,46,111,98,106,9,59,83,116,97,110,100,97
db 114,100,32,87,105,110,51,50,32,46,101,120,101,32,102,105
db 108,101,13,10,13,10,13,10, 0

.CODE

start_check_active_window_for_SG:
push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je start_check_active_window_for_SG
mov active_window_for_SG,ebx
cmp ebx,0
je end_generate_standard_SPL

push offset standard_SPL	;lParam   
push 1				;wParam   
push 0C2h			;EM_REPLACESEL
push active_window_for_SG
call SendMessageA

end_generate_standard_SPL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_GSS_01, LP_GSS_01, EP_GSS_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Generate_Standard_SPL endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Using example
;push save_type			;ebp+12
;push operation_type		;ebp+8
;call SCL_Save_Loaded_SPL_File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;save_type	;0 - Do not show Save Confirmation Dialog	;1 - Show Save Confirmation Dialog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Save_Loaded_SPL_File  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SLSPL_01, EP_SLSPL_01

mov eax,dword ptr [ebp]+8
mov operation_type_SLSPL_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SLSPL_01, LF_SLSPL_01, operation_type_SLSPL_01, LP_SLSPL_01, EP_SLSPL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov save_loaded_SPL_error_code,0
.DATA
save_loaded_SPL_error_code	dd 0
.CODE

mov save_loaded_SPL_error_code,1
cmp SPL_load_flag,0
je end_save_SPL			;Jump if SPL is absent

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;lParam   
push 0				;wParam   
push 0B8h			;EM_GETMODIFY 0B8h
push spl_window_handle
call SendMessageA
cmp eax,0
je end_save_SPL			;Jump if specified text is not modified
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save SPL
mov eax,dword ptr [ebp]+12		;save_type
cmp eax,0
je do_not_show_SPL_save_confirmation

push 30h+3h				;MB_YESNOCANCEL 3h
push offset spl_save_confirmation_title	;"SPL save confirmation"
push offset spl_save_confirmation_text	;"Current SPL file has been modified. Do you want to save file?"
push hwnd
call MessageBoxA
;IDYES 6
;IDNO  7

cmp eax,2				;IDCANCEL  2
je end_save_SPL
cmp eax,7				;IDNO  7
je end_save_SPL

do_not_show_SPL_save_confirmation:

mov eax,offset spl_save_description
mov specified_file_description,eax

push offset project_spl_file_name	;ebp+16
push spl_window_handle			;window_handle			;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Save_Specified_File

push 0				;lParam   
push 0				;wParam		Modification new value   
push 0B9h			;EM_SETMODIFY 0B8h
push spl_window_handle
call SendMessageA

end_save_SPL:

mov save_loaded_SPL_error_code,0

end_save_loaded_SPL:
mov ebx,save_loaded_SPL_error_code



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Resturn
;[ebx] - 0 - Successful save SPL
;[ebx] - 1 - SPL is absent. Cannot save SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SLSPL_01, LP_SLSPL_01, EP_SLSPL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SCL_Save_Loaded_SPL_File endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;push 0				;lParam 
;push 0				;wParam
;push 0ch			;WM_SETTEXT
;push spl_window_handle
;call SendMessageA		;Reset SPL window contents
;mov SPL_load_flag,0		;Set SPL load status as "SPL ABSENT"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset SPL_file_name	;ebp+12
;push operation_type		;ebp+8
;call SCL_Open_SPL_File		;Open existing SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Open_SPL_File  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_OSPLF_01, EP_OSPLF_01

mov eax,dword ptr [ebp]+8
mov operation_type_OSPLF_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_OSPLF_01, LF_OSPLF_01, operation_type_OSPLF_01, LP_OSPLF_01, EP_OSPLF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

cmp SPL_load_flag,0			;0 - Spl file not loaded ;1 - SPl file loaded
je no_show_SPL_present_message		;Jump if SPL absent

push 30h+1h					;MB_OKCANCEL 1h
push offset spl_present_flag_error_title	;"SPL present"
push offset spl_present_flag_error_text		;"You have already open SPL. SPL contents will be replaced."
push hwnd
call MessageBoxA
cmp eax,2					;IDCANCEL  2
je end_open_SPL_file					;Jump if "Cancel" was pressed

no_show_SPL_present_message:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset current SPL
push 0				;lParam 
push 0				;wParam
push 0ch			;WM_SETTEXT
push spl_window_handle
call SendMessageA		;Reset SPL window contents

mov SPL_load_flag,0			;Set SPL load status as "SPL ABSENT"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset current SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start SPL file transfer
start_transfer_SPL_file_into_window:
;STREAMIN_type  ; 0 - All ;1 - File

push 0  				;STREAMIN_type			;ebp+24
push 16000				;file_size_limit in bytes	;ebp+20
push spl_window_handle			;richedit_window_handle		;ebp+16
push dword ptr [ebp]+12			;offset file_name		;ebp+12
push 0		 	;operation_type			;ebp+8
call SCL_Transfer_File_Contents_Into_Richedit_Window
cmp eax,(-1)
je start_transfer_SPL_file_into_window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - Error owner
	;[eax] - (-1) - function busy
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - ReadFile generates error
	;[eax] - 3 - File size is out of allowed limit
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je SPL_file_processed_normal

mov SPL_open_error_owner_type,eax
mov SPL_open_system_error_code,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp SPL_open_error_owner_type,3		;File size is out of allowed limit
jne not_SPL_file_size_input_error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset line_text	;"_________________________________________________"
add_report_line 		;[eax] - contains line address

mov eax,offset file_size_error_title_text
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset file_name_text	;"File name"
add_report_line 		;[eax] - contains line address

mov eax,dword ptr [ebp]+12
add_report_line 		;[eax] - contains line address

mov eax,offset eol_code
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
mov eax,offset file_size_error_text
add_report_line 		;[eax] - contains line address

mov eax,offset line_text
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
not_SPL_file_size_input_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov new_header_button_selection,4

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp SPL_open_error_owner_type,3		;File size is out of allowed limit
je not_SPL_file_open_system_error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset spl_transfer_description
push dword ptr [ebp]+12				;ebp+16
push SPL_open_system_error_code			;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Generate_File_IO_Error_Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
not_SPL_file_open_system_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp end_open_SPL_file
SPL_file_processed_normal:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End SPL file transfer


end_open_SPL_file:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_OSPLF_01, LP_OSPLF_01, EP_OSPLF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Open_SPL_File endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push save_type			;ebp+12
;push operation_type		;ebp+8
;call SCL_Save_All_Files_List
;;;save_type			;0 - Save	 ;1 - Save And Close
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Save_All_Files_List  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SAFL_03, EP_SAFL_03

mov eax,dword ptr [ebp]+8
mov operation_type_SAFL_03,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SAFL_03, LF_SAFL_03, operation_type_SAFL_03, LP_SAFL_03, EP_SAFL_03
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
all_files_list_save_counter	dd 0
SF_current_file_window_handle	dd 0
SF_current_file_name_address	dd 0
.CODE

cmp List_Items_Count,0
je no_save_files_list		;Jump if list is empty 

mov eax,List_Items_Count
cmp List_Item_Selection_Number,eax
ja no_save_files_list		;Jump if list contains error 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXX

.DATA
;all_close_save_NO_TO_ALL	dd 0
;all_close_save_YES_TO_ALL	dd 0
;file_list_save_description	db 'Try to save file list. [Save all files]',0
.CODE


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save All Windows contents
mov all_files_save_counter,0

start_save_all_files:
inc all_files_save_counter

mov eax,all_files_save_counter
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov specified_file_FNL_address,eax
mov ecx,dword ptr [eax]+448		;FNL_richedit_window_handle
mov specified_file_window_handle,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp all_close_save_NO_TO_ALL,1
je no_save_specified_file_for_all	;Jump if no need to save files to disk
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp all_close_save_YES_TO_ALL,1
je no_show_all_save_confirmation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;lParam   
push 0				;wParam   
push 0B8h			;EM_GETMODIFY 0B8h
push specified_file_window_handle
call SendMessageA
cmp eax,0
je no_show_all_save_confirmation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;save_type			;0 - Save	 ;1 - Save And Close
cmp dword ptr [ebp]+12,0
je no_show_all_save_confirmation

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,specified_file_FNL_address
add eax,8
mov dialog_file_name_show_address,eax		;Set File Name

push 0
push offset Project_Save_Dialog
push hwnd   ;handle to the owner window
push offset dialog_name
push hInst
call DialogBoxParamA
;;;Return values
;[eax] - 0 - Only close without button push
;[eax] - 1000 - Pressed [ Yes ] button
;[eax] - 1001 - Pressed [ Yes to all ] button
;[eax] - 1002 - Pressed [ No ] button
;[eax] - 1003 - Pressed [ No to all ] button
;[eax] - 1004 - Pressed [ Cancel ] button
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,1004				;[eax] - 1004 - Pressed [ Cancel ] button
je no_save_files_list
cmp eax,0				;[eax] - 0 - Only close without button push
je no_save_files_list
cmp eax,1002				;[eax] - 1002 - Pressed [ No ] button
je no_save_specified_file_for_all
;;[eax] - 1000 - Pressed [ Yes ] button
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check "No to all"
cmp eax,1003				;[eax] - 1003 - Pressed [ No to all ] button
jne no_no_to_all

mov project_close_save_NO_TO_ALL,1

jmp do_not_save_files
no_no_to_all:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check "No to all"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check "Yes to all"
cmp eax,1001				;[eax] - 1001 - Pressed [ Yes to all ] button
jne no_yes_to_all

mov project_close_save_YES_TO_ALL,1

no_yes_to_all:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check "Yes to all"
no_show_all_save_confirmation:

mov eax,offset file_list_save_description
mov specified_file_description,eax

mov eax,specified_file_FNL_address
add eax,8

push eax				;offset file_name			;ebp+16
push specified_file_window_handle	;window_handle			;ebp+12
push 0;operation_type			;ebp+8
call SCL_Save_Specified_File

no_save_specified_file_for_all:

;;;save_type			;0 - Save	 ;1 - Save And Close
cmp dword ptr [ebp]+12,0
je no_destroy_all_windows

push 0
push specified_file_window_handle
call ShowWindow

push specified_file_window_handle
call DestroyWindow

no_destroy_all_windows:

mov edx,List_Items_Count
cmp all_files_save_counter,edx
jb start_save_all_files

do_not_save_files:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Save All Windows contents
no_save_all_files:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Close All Files
;;;save_type			;0 - Save	 ;1 - Save And Close
cmp dword ptr [ebp]+12,0
je no_close_all_files

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Results List Contents
mov edi,offset LIST_CONTENTS
add edi,20				;LIST_CONTENTS header size
xor eax,eax
mov ecx,288				;1152 / 4 = 288
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Results List Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset RFNL
mov edi,offset FILE_NAME_LIST
xor eax,eax
mov ecx,4284				;17136 / 4 = 4284
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset RFNL 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Close All Files
no_close_all_files:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Close Saved File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


no_save_files_list:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SAFL_03, LP_SAFL_03, EP_SAFL_03
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SCL_Save_All_Files_List endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;push save_type			;ebp+16
;push specified_file_list_item	;ebp+12
;push operation_type		;ebp+8
;call SCL_Save_Specified_File_List_Item
;;;save_type			;0 - Only save	 ;1 - Save and Close
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Save_Specified_File_List_Item proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SSFLI_03, EP_SSFLI_03

mov eax,dword ptr [ebp]+8
mov operation_type_SSFLI_03,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SSFLI_03, LF_SSFLI_03, operation_type_SSFLI_03, LP_SSFLI_03, EP_SSFLI_03
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,List_Items_Count
cmp dword ptr [ebp]+12,eax		;specified_file_list_item
ja end_save_specified_file_list_item

cmp List_Items_Count,0
je end_save_specified_file_list_item

mov eax,dword ptr [ebp]+12		;specified_file_list_item
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST

mov ebx,eax
add ebx,8
mov SFI_current_file_name_address,ebx

mov ecx,dword ptr [eax]+448		;FNL_richedit_window_handle
mov SFI_current_file_window_handle,ecx
.DATA
SFI_current_file_name_address	dd 0
SFI_current_file_window_handle	dd 0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save File 
push SF_current_file_name_address	;offset file_name			;ebp+16
push SF_current_file_window_handle	;ebp+12
push 0					;operation_type			;ebp+8
call SCL_Save_Specified_File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Save File 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Destroy File 
;;;save_type			;0 - Only save	 ;1 - Save and Close
cmp dword ptr [ebp]+16,0	;save_type
je no_also_destroy_window

push 0
push SFI_current_file_window_handle
call ShowWindow				;Hide Window

push SFI_current_file_window_handle
call DestroyWindow

start_remove_specified_item_for_close:

mov eax,dword ptr [ebp]+12			;;push file_list_item_number	 ebp+12

push offset COLOR_HANDLES_ARRAY	;ebp+20
push eax					;remove_position				;ebp+16
push offset LIST_CONTENTS			;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Remove_File_List_Item
cmp eax,(-1)
je start_remove_specified_item_for_close

mov eax,SFI_current_file_name_address
sub eax,8

push eax				;File_List_Item_Address		;ebp+12
push 0 					;operation_type			;ebp+8
call SCL_Invalidate_FNL_Item

no_also_destroy_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Destroy File 


end_save_specified_file_list_item:

push 10						;function_number			;ebp+12
push 0	;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;SCL_Set_Workspace_Lists_View
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SSFLI_03, LP_SSFLI_03, EP_SSFLI_03
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Save_Specified_File_List_Item endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


endm

