system_error_text macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push shell_execute_error code		;ebp+8
;call Get_Shell_Execute_Error_Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Shell_Execute_Error_Text proc
push ebp
mov ebp,esp

mov ecx,dword ptr [ebp]+8
cmp ecx,32
jbe no_above_sh_error_code 
mov eax,offset sh_out_error
mov ebx,76
jmp end_get_sh_error_text
no_above_sh_error_code:

mov ecx,dword ptr [ebp]+8
rol ecx,3	; mul 8
add ecx,offset shell_execute_errors
mov eax,dword ptr [ecx]
mov ebx,dword ptr [ecx]+4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - error text address
;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
shell_execute_errors	dd offset N_SH_ZERO,                 51	;0
			dd offset invalid_error_code,   61	;1
			dd offset N_SH_ERROR_FILE_NOT_FOUND, 33	;2
			dd offset N_SH_ERROR_PATH_NOT_FOUND, 33	;3
			dd offset invalid_error_code,   61	;4
			dd offset N_SE_ERR_ACCESSDENIED,  57	;5
			dd offset invalid_error_code,   61	;6
			dd offset invalid_error_code,   61	;7
			dd offset N_SE_ERR_OOM,           54	;8
			dd offset invalid_error_code,   61	;9
			dd offset invalid_error_code,   61	;10
			dd offset N_SH_ERROR_BAD_FORMAT,     65	;11
			dd offset invalid_error_code,   61	;12
			dd offset invalid_error_code,   61	;13
			dd offset invalid_error_code,   61	;14
			dd offset invalid_error_code,   61	;15
			dd offset invalid_error_code,   61	;16
			dd offset invalid_error_code,   61	;17
			dd offset invalid_error_code,   61	;18
			dd offset invalid_error_code,   61	;19
			dd offset invalid_error_code,   61	;20
			dd offset invalid_error_code,   61	;21
			dd offset invalid_error_code,   61	;22
			dd offset invalid_error_code,   61	;23
			dd offset invalid_error_code,   61	;24
			dd offset invalid_error_code,   61	;25
			dd offset N_SE_ERR_SHARE,         29	;26
			dd offset N_SE_ERR_ASSOCINCOMPLETE, 50	;27
			dd offset N_SE_ERR_DDETIMEOUT,    73	;28
			dd offset N_SE_ERR_DDEFAIL,       27	;29
			dd offset N_SE_ERR_DDEBUSY,       95	;30
			dd offset N_SE_ERR_NOASSOC,       69	;31
			dd offset N_SE_ERR_DLLNOTFOUND,   49	;32

N_SH_ZERO			db 'The operating system is out of memory or resources.',0 				;0	
N_SH_ERROR_FILE_NOT_FOUND	db 'The specified file was not found.',0 						;2	
N_SH_ERROR_PATH_NOT_FOUND	db 'The specified path was not found.',0						;3	
N_SE_ERR_ACCESSDENIED	db 'The operating system denied access to the specified file.',0			;5	
N_SE_ERR_OOM		db 'There was not enough memory to complete the operation.',0 				;8	
N_SH_ERROR_BAD_FORMAT	db 'The .EXE file is invalid (non-Win32 .EXE or error in .EXE image).',0 		;11	
N_SE_ERR_SHARE		db 'A sharing violation occurred.',0							;26
N_SE_ERR_ASSOCINCOMPLETE	db 'The filename association is incomplete or invalid.',0				;27
N_SE_ERR_DDETIMEOUT	db 'The DDE transaction could not be completed because the request timed out.',0	;28
N_SE_ERR_DDEFAIL		db 'The DDE transaction failed.',0							;29
N_SE_ERR_DDEBUSY		db 'The DDE transaction could not be completed because other DDE transactions were being processed.',0 ;30
N_SE_ERR_NOASSOC		db 'There is no application associated with the given filename extension.',0		;31
N_SE_ERR_DLLNOTFOUND	db 'The specified dynamic-link library was not found.',0				;32
invalid_error_code	db 'The specified error code for ShellExecute function is invalid',0


sh_out_error		db 'The specified error code is above then 32. It is not ShellExecute Error code',0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE

end_get_sh_error_text:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - error text address
;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
Get_Shell_Execute_Error_Text endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push system_error code		;ebp+8
;call Get_System_Error_Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_System_Error_Text proc
push ebp
mov ebp,esp

mov ecx,dword ptr [ebp]+8
cmp ecx,299
jbe no_above_st_error_code 
mov eax,offset system_out_error_code
mov ebx,78
jmp end_get_system_error_text
no_above_st_error_code:

mov ecx,dword ptr [ebp]+8
rol ecx,3	; mul 8
add ecx,offset standard_system_errors
mov eax,dword ptr [ecx]
mov ebx,dword ptr [ecx]+4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - error text address
;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
standard_system_errors		dd offset N_ERROR_SUCCESS, 			37	;0
				dd offset N_ERROR_INVALID_FUNCTION, 		19	;1
				dd offset N_ERROR_FILE_NOT_FOUND,		42	;2
				dd offset N_ERROR_PATH_NOT_FOUND,		42	;3
				dd offset N_ERROR_TOO_MANY_OPEN_FILES, 		32	;4
				dd offset N_ERROR_ACCESS_DENIED, 		17	;5
				dd offset N_ERROR_INVALID_HANDLE,		22	;6
				dd offset N_ERROR_ARENA_TRASHED, 		42	;7
				dd offset N_ERROR_NOT_ENOUGH_MEMORY,		56	;8
				dd offset N_ERROR_INVALID_BLOCK,		45	;9
				dd offset N_ERROR_BAD_ENVIRONMENT,		29	;10
				dd offset N_ERROR_BAD_FORMAT,			63	;11
				dd offset N_ERROR_INVALID_ACCESS,		27	;12
				dd offset N_ERROR_INVALID_DATA,			20	;13
				dd offset N_ERROR_OUTOFMEMORY,			59	;14
				dd offset N_ERROR_INVALID_DRIVE,		33	;15
				dd offset N_ERROR_CURRENT_DIRECTORY,		32	;16
				dd offset N_ERROR_NOT_SAME_DEVICE, 		58	;17
				dd offset N_ERROR_NO_MORE_FILES,		24	;18
				dd offset N_ERROR_WRITE_PROTECT, 		29	;19
				dd offset N_ERROR_BAD_UNIT,			44	;20
				dd offset N_ERROR_NOT_READY, 			24	;21
				dd offset N_ERROR_BAD_COMMAND,			42	;22
				dd offset N_ERROR_CRC,				36	;23
				dd offset N_ERROR_BAD_LENGTH,			65	;24
				dd offset N_ERROR_SEEK,				61	;25
				dd offset N_ERROR_NOT_DOS_DISK,			50	;26
				dd offset N_ERROR_SECTOR_NOT_FOUND,		43	;27
				dd offset N_ERROR_OUT_OF_PAPER,			28	;28
				dd offset N_ERROR_WRITE_FAULT,			48	;29
				dd offset N_ERROR_READ_FAULT,			49	;30
				dd offset N_ERROR_GEN_FAILURE,			51	;31
				dd offset N_ERROR_SHARING_VIOLATION,		79	;32
				dd offset N_ERROR_LOCK_VIOLATION,		92	;33
				dd offset N_ERROR_WRONG_DISK,			87	;34
				dd offset N_ERROR_SHARING_BUFFER_EXCEEDED,	34	;35
				dd offset N_invalid_system_error,		74	;36
				dd offset N_invalid_system_error,		74	;37
				dd offset N_ERROR_HANDLE_EOF,			20	;38
				dd offset N_ERROR_HANDLE_DISK_FULL, 		17	;39
				dd offset N_invalid_system_error, 		74	;40
				dd offset N_invalid_system_error, 		74	;41
				dd offset N_invalid_system_error,		74	;42
				dd offset N_invalid_system_error,		74	;43
				dd offset N_invalid_system_error,		74	;44
				dd offset N_invalid_system_error,		25	;45
				dd offset N_invalid_system_error,		25	;46
				dd offset N_invalid_system_error,		25	;47
				dd offset N_invalid_system_error,		25	;48
				dd offset N_invalid_system_error,		25	;49
				dd offset N_ERROR_NOT_SUPPORTED,		37	;50
				dd offset N_ERROR_REM_NOT_LIST,			37	;51
				dd offset N_ERROR_DUP_NAME,			39	;52
				dd offset N_ERROR_BAD_NETPATH,			31	;53
				dd offset N_ERROR_NETWORK_BUSY,			20	;54
				dd offset N_ERROR_DEV_NOT_EXIST,		64	;55
				dd offset N_ERROR_TOO_MANY_CMDS,		48	;56
				dd offset N_ERROR_ADAP_HDW_ERR,			42	;57
				dd offset N_ERROR_BAD_NET_RESP,			60	;58
				dd offset N_ERROR_UNEXP_NET_ERR,		37	;59
				dd offset N_ERROR_BAD_REM_ADAP,			37	;60
				dd offset N_ERROR_PRINTQ_FULL, 			26	;61
				dd offset N_ERROR_NO_SPOOL_SPACE,		77	;62
				dd offset N_ERROR_PRINT_CANCELLED,		44	;63
				dd offset N_ERROR_NETNAME_DELETED, 		50	;64
				dd offset N_ERROR_NETWORK_ACCESS_DENIED,	25	;65
				dd offset N_ERROR_BAD_DEV_TYPE,			41	;66
				dd offset N_ERROR_BAD_NET_NAME,			33	;67
				dd offset N_ERROR_TOO_MANY_NAMES,		72	;68
				dd offset N_ERROR_TOO_MANY_SESS,		44	;69
				dd offset N_ERROR_SHARING_PAUSED,		72	;70
				dd offset N_ERROR_REQ_NOT_ACCEP,		142	;71
				dd offset N_ERROR_REDIR_PAUSED,			53	;72
				dd offset N_invalid_system_error,		25	;73
				dd offset N_invalid_system_error,		25	;74
				dd offset N_invalid_system_error,		25	;75
				dd offset N_invalid_system_error,		25	;76
				dd offset N_invalid_system_error,		25	;77
				dd offset N_invalid_system_error,		25	;78
				dd offset N_invalid_system_error,		25	;79
				dd offset N_ERROR_FILE_EXISTS, 			16	;80
				dd offset N_invalid_system_error,		25	;81
				dd offset N_ERROR_CANNOT_MAKE,			40	;82
				dd offset N_ERROR_FAIL_I24,			14	;83
				dd offset N_ERROR_OUT_OF_STRUCTURES,		49	;84
				dd offset N_ERROR_ALREADY_ASSIGNED,		40	;85
				dd offset N_ERROR_INVALID_PASSWORD,		46	;86
				dd offset N_ERROR_INVALID_PARAMETER,		27	;87
				dd offset N_ERROR_NET_WRITE_FAULT,		38	;88
				dd offset N_ERROR_NO_PROC_SLOTS,		53	;89
				dd offset N_invalid_system_error,		25	;90
				dd offset N_invalid_system_error,		25	;91
				dd offset N_invalid_system_error,		25	;92
				dd offset N_invalid_system_error,		25	;93
				dd offset N_invalid_system_error,		25	;94
				dd offset N_invalid_system_error,		25	;95
				dd offset N_invalid_system_error,		25	;96
				dd offset N_invalid_system_error,		25	;97
				dd offset N_invalid_system_error,		25	;98
				dd offset N_invalid_system_error,		25	;99
				dd offset N_ERROR_TOO_MANY_SEMAPHORES,		39	;100
				dd offset N_ERROR_EXCL_SEM_ALREADY_OWNED,	52	;101
				dd offset N_ERROR_SEM_IS_SET,			42	;102
				dd offset N_ERROR_TOO_MANY_SEM_REQUESTS,	34	;103
				dd offset N_ERROR_INVALID_AT_INTERRUPT_TIME,	54	;104
				dd offset N_ERROR_SEM_OWNER_DIED,		51	;105
				dd offset N_ERROR_SEM_USER_LIMIT,		33	;106
				dd offset N_ERROR_DISK_CHANGE,			60	;107
				dd offset N_ERROR_DRIVE_LOCKED,			48	;108
				dd offset N_ERROR_BROKEN_PIPE,			24	;109
				dd offset N_ERROR_OPEN_FAILED,			52	;110
				dd offset N_ERROR_BUFFER_OVERFLOW,		26	;111
				dd offset N_ERROR_DISK_FULL,			38	;112
				dd offset N_ERROR_NO_MORE_SEARCH_HANDLES,	44	;113
				dd offset N_ERROR_INVALID_TARGET_HANDLE,	49	;114
				dd offset N_invalid_system_error,		25	;115
				dd offset N_invalid_system_error,		25	;116
				dd offset N_ERROR_INVALID_CATEGORY,		62	;117
				dd offset N_ERROR_INVALID_VERIFY_SWITCH,	58	;118
				dd offset N_ERROR_BAD_DRIVER_LEVEL,		50	;119
				dd offset N_ERROR_CALL_NOT_IMPLEMENTED,		47	;120
				dd offset N_ERROR_SEM_TIMEOUT, 			41	;121
				dd offset N_ERROR_INSUFFICIENT_BUFFER,		51	;122
				dd offset N_ERROR_INVALID_NAME, 		66	;123
				dd offset N_ERROR_INVALID_LEVEL,		37	;124
				dd offset N_ERROR_NO_VOLUME_LABEL,		29	;125
				dd offset N_ERROR_MOD_NOT_FOUND,		40	;126
				dd offset N_ERROR_PROC_NOT_FOUND,		43	;127
				dd offset N_ERROR_WAIT_NO_CHILDREN,		41	;128
				dd offset N_ERROR_CHILD_NOT_COMPLETE,		52	;129
				dd offset N_ERROR_DIRECT_ACCESS_HANDLE,		96	;130
				dd offset N_ERROR_NEGATIVE_SEEK,		78	;131
				dd offset N_ERROR_SEEK_ON_DEVICE,		63	;132
				dd offset N_ERROR_IS_JOIN_TARGET,		90	;133
				dd offset N_ERROR_IS_JOINED,			91	;134
				dd offset N_ERROR_IS_SUBSTED,			96	;135
				dd offset N_ERROR_NOT_JOINED,			66	;136
				dd offset N_ERROR_NOT_SUBSTED, 			79	;137
				dd offset N_ERROR_JOIN_TO_JOIN,			66	;138
				dd offset N_ERROR_SUBST_TO_SUBST,		77	;139
				dd offset N_ERROR_JOIN_TO_SUBST, 		71	;140
				dd offset N_ERROR_SUBST_TO_JOIN, 		67	;141
				dd offset N_ERROR_BUSY_DRIVE,			55	;142
				dd offset N_ERROR_SAME_DRIVE,			85	;143
				dd offset N_ERROR_DIR_NOT_ROOT,			58	;144
				dd offset N_ERROR_DIR_NOT_EMPTY,		27	;145
				dd offset N_ERROR_IS_SUBST_PATH,		49 	;146
				dd offset N_ERROR_IS_JOIN_PATH,			59	;147
				dd offset N_ERROR_PATH_BUSY,			47	;148
				dd offset N_ERROR_IS_SUBST_TARGET,		124	;149
				dd offset N_ERROR_SYSTEM_TRACE,			93	;150
				dd offset N_ERROR_INVALID_EVENT_COUNT,		74	;151
				dd offset N_ERROR_TOO_MANY_MUXWAITERS,		67	;152
				dd offset N_ERROR_INVALID_LIST_FORMAT,		38	;153
				dd offset N_ERROR_LABEL_TOO_LONG,		89	;154
				dd offset N_ERROR_TOO_MANY_TCBS,		29	;155
				dd offset N_ERROR_SIGNAL_REFUSED,		45	;156
				dd offset N_ERROR_DISCARDED,			54	;157
				dd offset N_ERROR_NOT_LOCKED, 			32	;158
				dd offset N_ERROR_BAD_THREADID_ADDR,		40	;159
				dd offset N_ERROR_BAD_ARGUMENTS,		56	;160
				dd offset N_ERROR_BAD_PATHNAME,			30	;161
				dd offset N_ERROR_SIGNAL_PENDING,		28	;162
				dd offset N_invalid_system_error,		25	;163
				dd offset N_ERROR_MAX_THRDS_REACHED,		45	;164
				dd offset N_invalid_system_error,		25	;165
				dd offset N_invalid_system_error,		25	;166
				dd offset N_ERROR_LOCK_FAILED,			34	;167
				dd offset N_invalid_system_error, 		25	;168
				dd offset N_invalid_system_error,		25	;169
				dd offset N_ERROR_BUSY,				33	;170
				dd offset N_invalid_system_error,		25	;171
				dd offset N_invalid_system_error,		25	;172
				dd offset N_ERROR_CANCEL_VIOLATION,		66 	;173
				dd offset N_ERROR_ATOMIC_LOCKS_NOT_SUPPORTED,	65	;174
				dd offset N_invalid_system_error,		25	;175
				dd offset N_invalid_system_error,		25	;176
				dd offset N_invalid_system_error,		25	;177
				dd offset N_invalid_system_error,		25	;178
				dd offset N_invalid_system_error,		25	;179
				dd offset N_ERROR_INVALID_SEGMENT_NUMBER,	58 	;180
				dd offset N_invalid_system_error,		25	;181
				dd offset N_ERROR_INVALID_ORDINAL,		35	;182
				dd offset N_ERROR_ALREADY_EXISTS,		51	;183
				dd offset N_invalid_system_error,		25	;184
				dd offset N_invalid_system_error,		25	;185
				dd offset N_ERROR_INVALID_FLAG_NUMBER,		31	;186
				dd offset N_ERROR_SEM_NOT_FOUND,		50	;187
				dd offset N_ERROR_INVALID_STARTING_CODESEG,	35	;188
				dd offset N_ERROR_INVALID_STACKSEG,		35	;189
				dd offset N_ERROR_INVALID_MODULETYPE,		35	;190
				dd offset N_ERROR_INVALID_EXE_SIGNATURE,	33	;191
				dd offset N_ERROR_EXE_MARKED_INVALID,		35	;192
				dd offset N_ERROR_BAD_EXE_FORMAT,		41	;193
				dd offset N_ERROR_ITERATED_DATA_EXCEEDS_64k,	35	;194
				dd offset N_ERROR_INVALID_MINALLOCSIZE,		35	;195
				dd offset N_ERROR_DYNLINK_FROM_INVALID_RING,	57	;196
				dd offset N_ERROR_IOPL_NOT_ENABLED,		73	;197
				dd offset N_ERROR_INVALID_SEGDPL,		35	;198
				dd offset N_ERROR_AUTODATASEG_EXCEEDS_64k, 	57	;199
				dd offset N_ERROR_RING2SEG_MUST_BE_MOVABLE,	57	;200
				dd offset N_ERROR_RELOC_CHAIN_XEEDS_SEGLIM,	35	;201
				dd offset N_ERROR_INFLOOP_IN_RELOC_CHAIN,	35	;202
				dd offset N_ERROR_ENVVAR_NOT_FOUND,		66	;203
				dd offset N_invalid_system_error,		25	;204
				dd offset N_ERROR_NO_SIGNAL_SENT,		55	;205
				dd offset N_ERROR_FILENAME_EXCED_RANGE,		38	;206
				dd offset N_ERROR_RING2_STACK_IN_USE,		20	;207
				dd offset N_ERROR_META_EXPANSION_TOO_LONG,	117	;208
				dd offset N_ERROR_INVALID_SIGNAL_NUMBER,	39	;209
				dd offset N_ERROR_THREAD_1_INACTIVE,		33	;210
				dd offset N_invalid_system_error,		25	;211
				dd offset N_ERROR_LOCKED,			48	;212
				dd offset N_invalid_system_error,		25	;213
				dd offset N_ERROR_TOO_MANY_MODULES,		82	;214
				dd offset N_ERROR_NESTING_NOT_ALLOWED,		31	;215
				dd offset N_ERROR_EXE_MACHINE_TYPE_MISMATCH,	85	;216
				dd offset N_invalid_system_error,		25	;217
				dd offset N_invalid_system_error,		25	;218
				dd offset N_invalid_system_error,		25	;219
				dd offset N_invalid_system_error,		25	;220
				dd offset N_invalid_system_error,		25	;221
				dd offset N_invalid_system_error,		25	;222
				dd offset N_invalid_system_error,		25	;223
				dd offset N_invalid_system_error,		25	;224
				dd offset N_invalid_system_error,		25	;225
				dd offset N_invalid_system_error,		25	;226
				dd offset N_invalid_system_error,		25	;227
				dd offset N_invalid_system_error,		25	;228
				dd offset N_invalid_system_error,		25	;229
				dd offset N_ERROR_BAD_PIPE,			26	;230
				dd offset N_ERROR_PIPE_BUSY,			28	;231
				dd offset N_ERROR_NO_DATA,			25	;232
				dd offset N_ERROR_PIPE_NOT_CONNECTED,		43	;233
				dd offset N_ERROR_MORE_DATA,			23	;234
				dd offset N_invalid_system_error,		25	;235
				dd offset N_invalid_system_error,		25	;236
				dd offset N_invalid_system_error,		25	;237
				dd offset N_invalid_system_error,		25	;238
				dd offset N_invalid_system_error,		25	;239
				dd offset N_ERROR_VC_DISCONNECTED,		26	;240
				dd offset N_invalid_system_error,		25	;241
				dd offset N_invalid_system_error,		25	;242
				dd offset N_invalid_system_error,		25	;243
				dd offset N_invalid_system_error,		25	;244
				dd offset N_invalid_system_error,		25	;245
				dd offset N_invalid_system_error,		25	;246
				dd offset N_invalid_system_error,		25	;247
				dd offset N_invalid_system_error,		25	;248
				dd offset N_invalid_system_error,		25	;249
				dd offset N_invalid_system_error,		25	;250
				dd offset N_invalid_system_error,		25	;251
				dd offset N_invalid_system_error,		25	;252
				dd offset N_invalid_system_error,		25	;253
				dd offset N_ERROR_INVALID_EA_NAME,		50	;254
				dd offset N_ERROR_EA_LIST_INCONSISTENT,		41	;255
				dd offset N_invalid_system_error,		25	;256
				dd offset N_invalid_system_error,		25	;257
				dd offset N_invalid_system_error,		25	;258
				dd offset N_ERROR_NO_MORE_ITEMS, 		26	;259
				dd offset N_invalid_system_error,		25	;260
				dd offset N_invalid_system_error,		25	;261
				dd offset N_invalid_system_error,		25	;262
				dd offset N_invalid_system_error,		25	;263
				dd offset N_invalid_system_error,		25	;264
				dd offset N_invalid_system_error,		25	;265
				dd offset N_ERROR_CANNOT_COPY,			28	;266
				dd offset N_ERROR_DIRECTORY,			30	;267
				dd offset N_invalid_system_error,		25	;268
				dd offset N_invalid_system_error,		25	;269
				dd offset N_invalid_system_error,		25	;270
				dd offset N_invalid_system_error,		25	;271
				dd offset N_invalid_system_error,		25	;272
				dd offset N_invalid_system_error,		25	;273
				dd offset N_invalid_system_error,		25	;274
				dd offset N_ERROR_EAS_DIDNT_FIT,		50	;275
				dd offset N_ERROR_EA_FILE_CORRUPT,		66	;276
				dd offset N_ERROR_EA_TABLE_FULL,		42	;277
				dd offset N_ERROR_INVALID_EA_HANDLE,		51	;278
				dd offset N_invalid_system_error,		25	;279
				dd offset N_invalid_system_error,		25	;280
				dd offset N_invalid_system_error,		25	;281
				dd offset N_ERROR_EAS_NOT_SUPPORTED,		61	;282
				dd offset N_invalid_system_error,		25	;283
				dd offset N_invalid_system_error,		25	;284
				dd offset N_invalid_system_error,		25	;285
				dd offset N_invalid_system_error,		25	;286
				dd offset N_invalid_system_error,		25	;287
				dd offset N_ERROR_NOT_OWNER,			45	;288
				dd offset N_invalid_system_error,		25	;289
				dd offset N_invalid_system_error,		25	;290
				dd offset N_invalid_system_error,		25	;291
				dd offset N_invalid_system_error,		25	;292
				dd offset N_invalid_system_error,		25	;293
				dd offset N_invalid_system_error,		25	;294
				dd offset N_invalid_system_error,		25	;295
				dd offset N_invalid_system_error,		25	;296
				dd offset N_invalid_system_error,		25	;297
				dd offset N_ERROR_TOO_MANY_POSTS,		40	;298
				dd offset N_ERROR_PARTIAL_COPY,			61	;299

N_ERROR_SUCCESS			db 'The operation completed successfully.',0					;0
N_ERROR_INVALID_FUNCTION	db 'Incorrect function.',0							;1
N_ERROR_FILE_NOT_FOUND		db 'The system cannot find the file specified.',0				;2
N_ERROR_PATH_NOT_FOUND		db 'The system cannot find the path specified.',0				;3
N_ERROR_TOO_MANY_OPEN_FILES	db 'The system cannot open the file.',0						;4
N_ERROR_ACCESS_DENIED		db 'Access is denied.',0							;5
N_ERROR_INVALID_HANDLE		db 'The handle is invalid.',0							;6
N_ERROR_ARENA_TRASHED		db 'The storage control blocks were destroyed.',0				;7
N_ERROR_NOT_ENOUGH_MEMORY	db 'Not enough storage is available to process this command.',0			;8
N_ERROR_INVALID_BLOCK		db 'The storage control block address is invalid.',0				;9
N_ERROR_BAD_ENVIRONMENT		db 'The environment is incorrect.',0						;10
N_ERROR_BAD_FORMAT		db 'An attempt was made to load a program with an incorrect format.',0		;11
N_ERROR_INVALID_ACCESS		db 'The access code is invalid.',0						;12
N_ERROR_INVALID_DATA		db 'The data is invalid.',0							;13
N_ERROR_OUTOFMEMORY		db 'Not enough storage is available to complete this operation.',0		;14
N_ERROR_INVALID_DRIVE		db 'The system cannot find the drive specified.',0				;15
N_ERROR_CURRENT_DIRECTORY	db 'The directory cannot be removed.',0						;16
N_ERROR_NOT_SAME_DEVICE		db 'The system cannot move the file to a different disk drive.',0		;17
N_ERROR_NO_MORE_FILES		db 'There are no more files.',0							;18
N_ERROR_WRITE_PROTECT		db 'The media is write protected.',0						;19
N_ERROR_BAD_UNIT		db 'The system cannot find the device specified.',0				;20
N_ERROR_NOT_READY		db 'The device is not ready.',0							;21
N_ERROR_BAD_COMMAND		db 'The device does not recognize the command.',0				;22
N_ERROR_CRC			db 'Data error (cyclic redundancy check)',0					;23
N_ERROR_BAD_LENGTH		db 'The program issued a command but the command length is incorrect.',0	;24
N_ERROR_SEEK			db 'The drive cannot locate a specific area or track on the disk.',0		;25
N_ERROR_NOT_DOS_DISK		db 'The specified disk or diskette cannot be accessed.',0			;26
N_ERROR_SECTOR_NOT_FOUND	db 'The drive cannot find the sector requested.',0				;27
N_ERROR_OUT_OF_PAPER		db 'The printer is out of paper.',0						;28
N_ERROR_WRITE_FAULT		db 'The system cannot write to the specified device.',0				;29
N_ERROR_READ_FAULT		db 'The system cannot read from the specified device.',0			;30
N_ERROR_GEN_FAILURE		db 'A device attached to the system is not functioning.',0			;31
N_ERROR_SHARING_VIOLATION	db 'The process cannot access the file because it is being used by another process.',0			;32
N_ERROR_LOCK_VIOLATION		db 'The process cannot access the file because another process has locked a portion of the file.',0	;33
N_ERROR_WRONG_DISK		db 'The wrong diskette is in the drive. Insert %2 (Volume Serial Number: %3) into drive %1.',0		;34
N_ERROR_SHARING_BUFFER_EXCEEDED	db 'Too many files opened for sharing.',0 					;35
N_ERROR_HANDLE_EOF		db 'Reached end of file.',0 							;38
N_ERROR_HANDLE_DISK_FULL	db 'The disk is full.',0 							;39
N_ERROR_NOT_SUPPORTED		db 'The network request is not supported.',0					;50
N_ERROR_REM_NOT_LIST		db 'The remote computer is not available.',0					;51
N_ERROR_DUP_NAME		db 'A duplicate name exists on the network.',0					;52
N_ERROR_BAD_NETPATH		db 'The network path was not found.',0						;53
N_ERROR_NETWORK_BUSY		db 'The network is busy.',0							;54
N_ERROR_DEV_NOT_EXIST		db 'The specified network resource or device is no longer available.',0		;55
N_ERROR_TOO_MANY_CMDS		db 'The network BIOS command limit has been reached.',0				;56
N_ERROR_ADAP_HDW_ERR		db 'A network adapter hardware error occurred.',0				;57
N_ERROR_BAD_NET_RESP		db 'The specified server cannot perform the requested operation.',0		;58
N_ERROR_UNEXP_NET_ERR		db 'An unexpected network error occurred.',0					;59
N_ERROR_BAD_REM_ADAP		db 'The remote adapter is not compatible.',0					;60
N_ERROR_PRINTQ_FULL		db 'The printer queue is full.',0						;61
N_ERROR_NO_SPOOL_SPACE		db 'Space to store the file waiting to be printed is not available on the server.',0		;62
N_ERROR_PRINT_CANCELLED		db 'Your file waiting to be printed was deleted.',0				;63
N_ERROR_NETNAME_DELETED		db 'The specified network name is no longer available.',0			;64
N_ERROR_NETWORK_ACCESS_DENIED	db 'Network access is denied.',0						;65
N_ERROR_BAD_DEV_TYPE		db 'The network resource type is not correct.',0				;66
N_ERROR_BAD_NET_NAME		db 'The network name cannot be found.',0					;67
N_ERROR_TOO_MANY_NAMES		db 'The name limit for the local computer network adapter card was exceeded.',0	;68
N_ERROR_TOO_MANY_SESS		db 'The network BIOS session limit was exceeded.',0				;69
N_ERROR_SHARING_PAUSED		db 'The remote server has been paused or is in the process of being started.',0	;70
N_ERROR_REQ_NOT_ACCEP		db 'No more connections can be made to this remote computer at this time because there are already as many connections as the computer can accept.',0	;71
N_ERROR_REDIR_PAUSED		db 'The specified printer or disk device has been paused.',0			;72
N_ERROR_FILE_EXISTS		db 'The file exists.',0								;80
N_ERROR_CANNOT_MAKE		db 'The directory or file cannot be created.',0					;82
N_ERROR_FAIL_I24		db 'Fail on INT 24',0								;83
N_ERROR_OUT_OF_STRUCTURES	db 'Storage to process this request is not available.',0			;84
N_ERROR_ALREADY_ASSIGNED	db 'The local device name is already in use.',0					;85
N_ERROR_INVALID_PASSWORD	db 'The specified network password is not correct.',0				;86
N_ERROR_INVALID_PARAMETER	db 'The parameter is incorrect.',0						;87
N_ERROR_NET_WRITE_FAULT		db 'A write fault occurred on the network.',0					;88
N_ERROR_NO_PROC_SLOTS		db 'The system cannot start another process at this time.',0			;89
N_ERROR_TOO_MANY_SEMAPHORES	db 'Cannot create another system semaphore.',0					;100
N_ERROR_EXCL_SEM_ALREADY_OWNED	db 'The exclusive semaphore is owned by another process.',0			;101
N_ERROR_SEM_IS_SET		db 'The semaphore is set and cannot be closed.',0				;102
N_ERROR_TOO_MANY_SEM_REQUESTS	db 'The semaphore cannot be set again.',0					;103
N_ERROR_INVALID_AT_INTERRUPT_TIME	db 'Cannot request exclusive semaphores at interrupt time.',0			;104
N_ERROR_SEM_OWNER_DIED		db 'The previous ownership of this semaphore has ended.',0			;105
N_ERROR_SEM_USER_LIMIT		db 'Insert the diskette for drive %1.',0					;106
N_ERROR_DISK_CHANGE		db 'Program stopped because alternate diskette was not inserted.',0		;107
N_ERROR_DRIVE_LOCKED		db 'The disk is in use or locked by another process.',0				;108
N_ERROR_BROKEN_PIPE		db 'The pipe has been ended.',0							;109
N_ERROR_OPEN_FAILED		db 'The system cannot open the device or file specified.',0			;110
N_ERROR_BUFFER_OVERFLOW		db 'The file name is too long.',0						;111
N_ERROR_DISK_FULL		db 'There is not enough space on the disk.',0					;112
N_ERROR_NO_MORE_SEARCH_HANDLES	db 'No more internal file identifiers available.',0				;113
N_ERROR_INVALID_TARGET_HANDLE	db 'The target internal file identifier is incorrect.',0			;114
N_ERROR_INVALID_CATEGORY	db 'The IOCTL call made by the application program is not correct.',0		;117
N_ERROR_INVALID_VERIFY_SWITCH	db 'The verify-on-write switch parameter value is not correct.',0		;118
N_ERROR_BAD_DRIVER_LEVEL	db 'The system does not support the command requested.',0			;119
N_ERROR_CALL_NOT_IMPLEMENTED	db 'This function is only valid in Windows NT mode.',0				;120
N_ERROR_SEM_TIMEOUT		db 'The semaphore timeout period has expired.',0				;121
N_ERROR_INSUFFICIENT_BUFFER	db 'The data area passed to a system call is too small.',0			;122
N_ERROR_INVALID_NAME		db 'The filename, directory name, or volume label syntax is incorrect.',0	;123
N_ERROR_INVALID_LEVEL		db 'The system call level is not correct.',0					;124
N_ERROR_NO_VOLUME_LABEL		db 'The disk has no volume label.',0						;125
N_ERROR_MOD_NOT_FOUND		db 'The specified module could not be found.',0					;126
N_ERROR_PROC_NOT_FOUND		db 'The specified procedure could not be found.',0				;127
N_ERROR_WAIT_NO_CHILDREN	db 'There are no child processes to wait for.',0				;128
N_ERROR_CHILD_NOT_COMPLETE	db 'The %1 application cannot be run in Windows NT mode.',0			;129
N_ERROR_DIRECT_ACCESS_HANDLE	db 'Attempt to use a file handle to an open disk partition for an operation other than raw disk I/O.',0		;130
N_ERROR_NEGATIVE_SEEK		db 'An attempt was made to move the file pointer before the beginning of the file.',0				;131
N_ERROR_SEEK_ON_DEVICE		db 'The file pointer cannot be set on the specified device or file.',0						;132
N_ERROR_IS_JOIN_TARGET		db 'A JOIN or SUBST command cannot be used for a drive that contains previously joined drives.',0		;133
N_ERROR_IS_JOINED		db 'An attempt was made to use a JOIN or SUBST command on a drive that has already been joined.',0		;134
N_ERROR_IS_SUBSTED		db 'An attempt was made to use a JOIN or SUBST command on a drive that has already been substituted.',0		;135
N_ERROR_NOT_JOINED		db 'The system tried to delete the JOIN of a drive that is not joined.',0					;136
N_ERROR_NOT_SUBSTED		db 'The system tried to delete the substitution of a drive that is not substituted.',0				;137
N_ERROR_JOIN_TO_JOIN		db 'The system tried to join a drive to a directory on a joined drive.',0					;138
N_ERROR_SUBST_TO_SUBST		db 'The system tried to substitute a drive to a directory on a substituted drive.',0				;139
N_ERROR_JOIN_TO_SUBST		db 'The system tried to join a drive to a directory on a substituted drive.',0					;140
N_ERROR_SUBST_TO_JOIN		db 'The system tried to SUBST a drive to a directory on a joined drive.',0					;141
N_ERROR_BUSY_DRIVE		db 'The system cannot perform a JOIN or SUBST at this time.',0							;142
N_ERROR_SAME_DRIVE		db 'The system cannot join or substitute a drive to or for a directory on the same drive.',0			;143
N_ERROR_DIR_NOT_ROOT		db 'The directory is not a subdirectory of the root directory.',0						;144
N_ERROR_DIR_NOT_EMPTY		db 'The directory is not empty.',0										;145
N_ERROR_IS_SUBST_PATH		db 'The path specified is being used in a substitute.',0							;146
N_ERROR_IS_JOIN_PATH		db 'Not enough resources are available to process this command.',0						;147
N_ERROR_PATH_BUSY		db 'The path specified cannot be used at this time.',0								;148
N_ERROR_IS_SUBST_TARGET		db 'An attempt was made to join or substitute a drive for which a directory on the drive is the target of a previous substitute.',0	;149
N_ERROR_SYSTEM_TRACE		db 'System trace information was not specified in your CONFIG.SYS file, or tracing is disallowed.',0		;150
N_ERROR_INVALID_EVENT_COUNT	db 'The number of specified semaphore events for DosMuxSemWait is not correct.',0				;151
N_ERROR_TOO_MANY_MUXWAITERS	db 'DosMuxSemWait did not execute; too many semaphores are already set.',0					;152
N_ERROR_INVALID_LIST_FORMAT	db 'The DosMuxSemWait list is not correct.',0									;153
N_ERROR_LABEL_TOO_LONG		db 'The volume label you entered exceeds the label character limit of the target file system.',0		;154
N_ERROR_TOO_MANY_TCBS		db 'Cannot create another thread.',0										;155
N_ERROR_SIGNAL_REFUSED		db 'The recipient process has refused the signal.',0				;156
N_ERROR_DISCARDED		db 'The segment is already discarded and cannot be locked.',0			;157
N_ERROR_NOT_LOCKED		db 'The segment is already unlocked.',0						;158
N_ERROR_BAD_THREADID_ADDR	db 'The address for the thread ID is not correct.',0				;159
N_ERROR_BAD_ARGUMENTS		db 'The argument string passed to DosExecPgm is not correct.',0			;160
N_ERROR_BAD_PATHNAME		db 'The specified path is invalid.',0						;161
N_ERROR_SIGNAL_PENDING		db 'A signal is already pending.',0						;162
N_ERROR_MAX_THRDS_REACHED	db 'No more threads can be created in the system.',0				;164
N_ERROR_LOCK_FAILED		db 'Unable to lock a region of a file.',0					;167
N_ERROR_BUSY			db 'The requested resource is in use.',0					;170
N_ERROR_CANCEL_VIOLATION	db 'A lock request was not outstanding for the supplied cancel region.',0	;173
N_ERROR_ATOMIC_LOCKS_NOT_SUPPORTED db 'The file system does not support atomic changes to the lock type.',0	;174
N_ERROR_INVALID_SEGMENT_NUMBER	db 'The system detected a segment number that was not correct.',0		;180
N_ERROR_INVALID_ORDINAL		db 'The operating system cannot run %1.',0					;182
N_ERROR_ALREADY_EXISTS		db 'Cannot create a file when that file already exists.',0			;183
N_ERROR_INVALID_FLAG_NUMBER	db 'The flag passed is not correct.',0						;186	
N_ERROR_SEM_NOT_FOUND		db 'The specified system semaphore name was not found.',0			;187
N_ERROR_INVALID_STARTING_CODESEG	db 'The operating system cannot run %1.',0					;188
N_ERROR_INVALID_STACKSEG	db 'The operating system cannot run %1.	',0					;189
N_ERROR_INVALID_MODULETYPE	db 'The operating system cannot run %1.	',0					;190
N_ERROR_INVALID_EXE_SIGNATURE	db 'Cannot run %1 in Windows NT mode.',0					;191
N_ERROR_EXE_MARKED_INVALID	db 'The operating system cannot run %1.	',0					;192
N_ERROR_BAD_EXE_FORMAT		db '%1 is not a valid Windows NT application.',0				;193
N_ERROR_ITERATED_DATA_EXCEEDS_64k	db 'The operating system cannot run %1.',0					;194
N_ERROR_INVALID_MINALLOCSIZE	db 'The operating system cannot run %1.	',0					;195
N_ERROR_DYNLINK_FROM_INVALID_RING	db 'The operating system cannot run this application program.',0		;196
N_ERROR_IOPL_NOT_ENABLED	db 'The operating system is not presently configured to run this application.',0	;197
N_ERROR_INVALID_SEGDPL		db 'The operating system cannot run %1.',0					;198
N_ERROR_AUTODATASEG_EXCEEDS_64k	db 'The operating system cannot run this application program.',0		;199
N_ERROR_RING2SEG_MUST_BE_MOVABLE	db 'The code segment cannot be greater than or equal to 64KB.',0		;200
N_ERROR_RELOC_CHAIN_XEEDS_SEGLIM	db 'The operating system cannot run %1.',0					;201
N_ERROR_INFLOOP_IN_RELOC_CHAIN	db 'The operating system cannot run %1.',0					;202
N_ERROR_ENVVAR_NOT_FOUND	db 'The system could not find the environment option that was entered.',0	;203
N_ERROR_NO_SIGNAL_SENT		db 'No process in the command subtree has a signal handler.',0			;205
N_ERROR_FILENAME_EXCED_RANGE	db 'The filename or extension is too long.',0					;206
N_ERROR_RING2_STACK_IN_USE	db 'The ring 2 stack is in use.',0						;207
N_ERROR_META_EXPANSION_TOO_LONG	db 'The global filename characters, * or ?, are entered incorrectly or too many global filename characters are specified.',0	;208
N_ERROR_INVALID_SIGNAL_NUMBER	db 'The signal being posted is not correct.',0					;209
N_ERROR_THREAD_1_INACTIVE	db 'The signal handler cannot be set.',0					;210
N_ERROR_LOCKED			db 'The segment is locked and cannot be reallocated.',0				;212
N_ERROR_TOO_MANY_MODULES	db 'Too many dynamic link modules are attached to this program or dynamic link module.',0	;214
N_ERROR_NESTING_NOT_ALLOWED	db 'Cannot nest calls to LoadModule.',0								;215
N_ERROR_EXE_MACHINE_TYPE_MISMATCH	db 'The image file %1 is valid, but is for a machine type other than the current machine.',0	;216
N_ERROR_BAD_PIPE		db 'The pipe state is invalid.',0					;230
N_ERROR_PIPE_BUSY		db 'All pipe instances are busy.',0					;231
N_ERROR_NO_DATA			db 'The pipe is being closed.',0					;232
N_ERROR_PIPE_NOT_CONNECTED	db 'No process is on the other end of the pipe.',0			;233
N_ERROR_MORE_DATA		db 'More data is available.',0						;234
N_ERROR_VC_DISCONNECTED		db 'The session was cancelled.',0					;240
N_ERROR_INVALID_EA_NAME		db 'The specified extended attribute name was invalid.',0		;254
N_ERROR_EA_LIST_INCONSISTENT	db 'The extended attributes are inconsistent.',0			;255
N_ERROR_NO_MORE_ITEMS		db 'No more data is available.',0					;259
N_ERROR_CANNOT_COPY		db 'The Copy API cannot be used.',0					;266
N_ERROR_DIRECTORY		db 'The directory name is invalid.',0					;267
N_ERROR_EAS_DIDNT_FIT		db 'The extended attributes did not fit in the buffer.',0		;275
N_ERROR_EA_FILE_CORRUPT		db 'The extended attribute file on the mounted file system is corrupt.',0	;276
N_ERROR_EA_TABLE_FULL		db 'The extended attribute table file is full.',0				;277
N_ERROR_INVALID_EA_HANDLE	db 'The specified extended attribute handle is invalid.',0			;278
N_ERROR_EAS_NOT_SUPPORTED	db 'The mounted file system does not support extended attributes.',0		;282
N_ERROR_NOT_OWNER		db 'Attempt to release mutex not owned by caller.',0				;288
N_ERROR_TOO_MANY_POSTS		db 'Too many posts were made to a semaphore.',0					;298
N_ERROR_PARTIAL_COPY		db 'Only part of a Read/WriteProcessMemory request was completed.',0		;299
N_invalid_system_error		db 'Invalid system error code. The specified error code is not defined in SDK.',0

system_out_error_code		db 'Specified code is not supported by this function. Supported codes are 0 - 299.',0 

.CODE

end_get_system_error_text:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - error text address
;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
Get_System_Error_Text endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


endm

